<!--#INCLUDE VIRTUAL="/WS_Content/Includes/i_Includes.asp"-->
<%
	Response.Buffer = TRUE
	Dim iDomainUnq, sSystemUnq, sGroupUnq, rs1
	Dim sSQLText, rsDB, sType
	Dim sLogin, sPassword
	
	Call DISP_Action("SB_ACCOUNTS_ADMIN_OPEN")
	Call DISP_Action("SB_ACCOUNTS_MANAGE_GROUPS_GROUPRIGHTS")
	If   (ACCNT_AnyDomain("SB_UG_GROUPRIGHTS")) Then
		Call Main()
	Else
		Call DOMAIN_Message(DOMAIN_Text("ACCT_SYS_RIGHTS"), "ERROR")
	End If
	Call DISP_Action("SB_ACCOUNTS_CLOSE")
	Response.Flush

	'************************************************************************************
	'*																					*
	'*	-Group rights have a 0 in the AccountUnq column of the Rights table. 			*
	'*	-Individualized Group rights - Group rights unique to that user have both		*
	'*		the GroupUnq and AccountUnq columns filled with something other than 0.		*
	'*	-Individual rights have a 0 in the GroupUnq column and their AccountUnq			*
	'*		column filled.																*
	'*																					*
	'************************************************************************************
	Sub Main()
		Dim sAction, sRadio, sSuccess, sError
		Dim sRightsLvl, bInSystem, sTempRight
		
		Set rs1 = CreateObject("ADODB.Recordset")
		
		sAction = Request("sAction")
		sLogin = Trim(Request("sLogin"))
		sPassword = Trim(Request("sPassword"))
		sLogin = Replace(Replace(sLogin, "&#145;", "'"), "&#147;", """")
		sPassword = Replace(Replace(sPassword, "&#145;", "'"), "&#147;", """")
		iDomainUnq = Trim(Request("iDomainUnq"))
		sSystemUnq = Trim(Request("sSystemUnq"))
		
		iDomainUnq = Trim(Request("iDomainUnq"))
		If ( iDomainUnq = "" ) Then
			iDomainUnq = ACCNT_GetDomainW_Rights("SB_UG_GROUPRIGHTS", "", "")
		End If
		sGroupUnq = Trim(Request("sGroupUnq"))
		' now remove any S or R from the GroupUnq - in case the user just came from the Default.asp
		If ( InStr(sGroupUnq, "S") > 0 ) Then
			sGroupUnq = Replace(sGroupUnq, "S", "")
		End If
		If ( InStr(sGroupUnq, "R") > 0 ) Then
			sGroupUnq = Replace(sGroupUnq, "R", "")
		End If
		If ( sGroupUnq = "" ) Then
			sSQLText = "SELECT * FROM Groups (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " ORDER BY Name ASC"
			rs1.Open sSQLText, DBConnection
			If ( NOT rs1.EOF ) Then
				sGroupUnq = rs1("GroupUnq")
			Else
				sGroupUnq = "-1"
			End If
			rs1.Close
		End If
		If ( sSystemUnq = "" ) Then
			sSystemUnq = "1"
		End If
		
		Select Case sAction
			Case "UpdateRights"
				If ( iDomainUnq <> iDomainName ) And (NOT ACCNT_SpecificDomain("SB_UG_GROUPRIGHTS", iDomainUnq)) Then
					sError = DOMAIN_Text("DOM_SYS_RIGHTS")
				Else
		            For Each sRadio In Request.Form
		            	If ( InStr(sRadio, "ORIGINAL") > 0 ) Then
		            		sRightsLvl = Replace(sRadio, "ORIGINAL", "")
		            		sTempRight = Request(sRightsLvl)
		            		If ( ( sTempRight <> Request(sRadio) ) And ( sTempRight = "YES" ) ) Then
		            			' Give them the rights
								If sRightsLvl = "" Then
									sError = DOMAIN_Text("ACCOUNTS_GROUPS_ENTER_RTS_LVL")
								Else
									If sGroupUnq <> "" Then
										bInSystem = InSystem(sRightsLvl)
										If ( ACCNT_SpecificDomain(sRightsLvl, iDomainUnq) ) Then	' admins can only change rights they have
											' Modify the system
											If bInSystem <> FALSE OR IsNull(bInSystem) Then	' cannot say bInSystem = TRUE because it's either FALSE or NULL or a date but never TRUE
												DBConnection.Execute "UPDATE Rights SET RevokeDate = NULL WHERE DomainUnq = " & iDomainUnq & " AND GroupUnq = " & sGroupUnq & " AND SystemUnq = " & sSystemUnq & " AND RightsLvl = '" & SQLEncode(sRightsLvl) & "' AND AccountUnq = 0"
												Call DOMAIN_Log(56, "", sGroupUnq, "", iDomainUnq, "", sSystemUnq, "V", "U", SQLEncode(sRightsLvl), "")
												sSuccess = DOMAIN_Text("ACCOUNTS_GROUPS_ACCOUNT_REINSTATED")
											Else
												DBConnection.Execute "INSERT INTO Rights VALUES (0, " & sGroupUnq & ", " & sSystemUnq & ", " & iDomainUnq & ", '" & SQLEncode(sRightsLvl) & "', GetDate(), NULL)"
												Call DOMAIN_Log(56, "", sGroupUnq, "", iDomainUnq, "", sSystemUnq, "V", "I", SQLEncode(sRightsLvl), "")
												sSuccess = DOMAIN_Text("ACCOUNTS_GROUPS_ACCOUNT_ENTERED")
											End If
										Else
											sError = DOMAIN_Text("DOM_SYS_RIGHTS")
										End If
									Else
										sError = DOMAIN_Text("ACCOUNTS_GROUPS_CHOOSE_GROUP2")
									End If
								End If
		            		End If
		            		If ( ( sTempRight <> Request(sRadio) ) And ( sTempRight = "NO" ) ) Then
								bInSystem = InSystem(sRightsLvl)
								' Modify the system
								If bInSystem = FALSE Then
									'sError = DOMAIN_Text("ACCOUNTS_GROUPS_NEVER_ASSOCIATED")
								Else
									If ( sRightsLvl = "SB_UG_GROUPRIGHTS" ) And ( RevokingSelf() ) Then
										sError = DOMAIN_Text("ACCOUNTS_GROUPS_REVOKE_SELF")
									Else
										DBConnection.Execute "UPDATE Rights SET RevokeDate = GetDate() WHERE DomainUnq = " & iDomainUnq & " AND GroupUnq = " & sGroupUnq & " AND SystemUnq = " & sSystemUnq & " AND RightsLvl = '" & SQLEncode(sRightsLvl) & "' AND AccountUnq = 0"
										Call DOMAIN_Log(119, "", sGroupUnq, "", iDomainUnq, "", sSystemUnq, "V", "U", SQLEncode(sRightsLvl), "")
										sSuccess = DOMAIN_Text("ACCOUNTS_GROUPS_REMOVE_ACCOUNT")
									End If
								End If
		            		End If
						End If
		            Next
				End If
				
		End Select
		
		If ( sSuccess <> "" ) Then
			Call DOMAIN_Message(sSuccess, "SUCCESS")
		End If
		If ( sError <> "" ) Then
			Call DOMAIN_Message(sError, "ERROR")
		End If
		
		Call WriteForm()
		
		Set rs1 = Nothing

	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This checks to see if they are in the db or not. And if they are, it returns	*
	'*		the date they were taken out of that system or NULL if they are still in	*
	'*		it.																			*
	'*																					*
	'************************************************************************************
	Function InSystem(sRL)
		Dim sSql, rsDB
	
		sSql = "SELECT RevokeDate FROM Rights (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " AND GroupUnq = " & sGroupUnq & " AND SystemUnq = " & sSystemUnq & " AND RightsLvl = '" & SQLEncode(sRL) & "' AND AccountUnq = 0"
'response.write sSql & "<br>"
		Set rsDB = CreateObject("ADODB.Recordset")
		DBCommand.CommandText = sSQL
		rsDB.Open DBCommand
		If ( NOT rsDB.EOF ) Then
'response.write "<br>here1<br>"
'If IsNull(InSystem) Then
'	Response.Write "null<br>"
'End If
'If Trim(InSystem) = "" Then
'	Response.Write "empty<br>"
'End IF
'response.write ":" & InSystem & ":<br>"
			InSystem = rsDB("RevokeDate")
		Else
'response.write "<br>here2<br>"
			InSystem = FALSE
		End If
		rsDB.Close
		Set rsDB = Nothing
	End Function
	'************************************************************************************
	
	'************************************************************************************
	'*																					*
	'*	This checks to see if the admin is revoking their own rights to modify the		*
	'*		rights of groups. This would be bad because then they would be locked out	*
	'*		from doing further modifications or from correcting it if it were done in	*
	'*		error.																		*
	'*																					*
	'************************************************************************************
	Function RevokingSelf()
		Dim rsDB
		RevokingSelf = FALSE
		
		' If they are "UG_CROSS_GROUPRIGHTS" then we don't need to worry about it.
		Set rsDB = CreateObject("ADODB.Recordset")
		If ( NOT ACCNT_ReturnRights("SB_UG_CROSS_GROUPRIGHTS") ) Then
			' check to see if they have this setting in their own rights and not because they are in any specific group
			sSQLText = "SELECT * FROM Rights (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " AND AccountUnq = " & iLoginAccountUnq & " AND SystemUnq = " & sSystemUnq & " AND RightsLvl = 'UG_GROUPRIGHTS'"
			DBCommand.CommandText = sSQLText
			rsDB.Open DBCommand
			If ( rsDB.EOF ) Then
				' they don't have it in their own rights, so it must be in the rights of a group they are in.
				' check to see if the only group that they are in is this one that has the rights
				rsDB.Close
				sSQLText = "SELECT Count(*) FROM GroupMap M, Rights R WHERE R.RightsLvl = 'UG_GROUPRIGHTS' AND M.AccountUnq = " & iLoginAccountUnq & " AND R.DomainUnq = " & iDomainUnq & " AND R.SystemUnq = " & sSystemUnq & " AND M.DomainUnq = " & iDomainUnq & " AND R.GroupUnq = M.GroupUnq AND ((R.RevokeDate IS NULL) OR (R.RevokeDate < R.GrantDate))"
				DBCommand.CommandText = sSQLText
				rsDB.Open DBCommand
				If ( rsDB.EOF ) Then
					RevokingSelf = TRUE		' No groups and not in their own rights - they shouldn't be here in the first place!
				Else
					If ( CDbl(rsDB(0)) <= 1 ) Then
						RevokingSelf = TRUE
					End If
				End If
				rsDB.Close
			Else
				rsDB.Close
			End If
		End If
		Set rsDB = Nothing
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This is the function to write out the form.										*
	'*																					*
	'************************************************************************************
	Sub WriteForm()
		Dim sBGColor, sTextColor, sHasRights, rsDB2, sRevokeDate, sGrantDate, sTemp, sGroupName, sRightsLvl
		
		sSQLText = "SELECT * FROM RightsLookup (NOLOCK) WHERE DomainUnq = " & iDomainName & " AND SystemUnq = " & sSystemUnq
		Set rsDB = CreateObject("ADODB.Recordset")
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		sBGColor = DOMAIN_Color("AccountsBGColor2")
		%>
		<script language='JavaScript1.2' type='text/javascript'>
	
			function SubmitForm(sAction){
				document.ManageRights.sAction.value = sAction;
				document.ManageRights.submit();
			}
			
		</script>
		<form name='ManageRights' action='GroupRights.asp' method='post'>
		<%
		aVariables(0) = "sAction"
		aVariables(1) = "iDBLoc2"
		aVariables(2) = "iDomainUnq2"
		aVariables(3) = "sGroupUnq2"
		aValues(0) = "New"
		aValues(1) = Request("iDBLoc2")
		aValues(2) = Request("iDomainUnq2")
		aValues(3) = Request("sGroupUnq2")
		Response.Write DOMAIN_Link("P")
		%>
		<table cellpadding=0 cellspacing=0 border=0 width=671>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
			<tr>
				<td>
					<font color='<%=DOMAIN_Color("AccountsPageText")%>'>
					<font size=+1><b><%=DOMAIN_Text("ACCOUNTS_GROUPS_MANAGE_INTRO")%></b></font>
					<br>
					<table>
						<tr>
							<td><font color='<%=DOMAIN_Color("AccountsPageText")%>'><b><%=DOMAIN_Text("ACCOUNTS_GROUPS_DOMAIN")%></b></font></td>
							<td><font color='<%=DOMAIN_Color("AccountsPageText")%>'><b><%=DOMAIN_Text("ACCOUNTS_GROUPS_GROUP")%></b></font></td>
							<td><font color='<%=DOMAIN_Color("AccountsPageText")%>'><b><%=DOMAIN_Text("ACCOUNTS_GROUPS_SYSTEM")%></b></font></td>
						</tr>
						<tr>
							<td>
								<%Call DOMAINS_DomainsDropDown("SB_UG_GROUPRIGHTS", "", "")%>
							</td>
							<td>
								<select name = "sGroupUnq" onChange='SubmitForm("UpdateGroupUnq");'>
									<%
									sSQLText = "SELECT GroupUnq, Name, Type FROM Groups (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " ORDER BY Name"
									rs1.Open sSQLText, DBConnection
									While NOT rs1.EOF
										If ( Trim(UCase(rs1("Type"))) = "S" ) Then
											sTemp = DOMAIN_Text("ACCOUNTS_GROUPS_STD_END")
										Else
											sTemp = DOMAIN_Text("ACCOUNTS_GROUPS_ROT_END")
										End If
										sGroupName = Replace(rs1("Name"), "'", "&#39;")
										If ( sGroupUnq = CStr(rs1("GroupUnq")) ) Then
											Response.Write "<option value = '" & rs1("GroupUnq") & "' Selected>" & sGroupName & sTemp & "</option>"
										Else
											Response.Write "<option value = '" & rs1("GroupUnq") & "'>" & sGroupName & sTemp & "</option>"
										End If
										rs1.MoveNext
									Wend
									rs1.Close
									%>
								</select>
							</td>
							<td>
								<%Call DOMAINS_SystemsDropDown()%>
							</td>
						</tr>
					</table>
					<br>
					<table cellpadding=2 cellspacing=0 border=0 width=671>
						<tr>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>'><b><%=DOMAIN_Text("ACCOUNTS_GROUPS_RIGHT")%></b></td>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>'><b><%=DOMAIN_Text("ACCOUNTS_GROUPS_GRANTDATE")%></b></td>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>'><b><%=DOMAIN_Text("ACCOUNTS_GROUPS_REVOKEDATE")%></b></td>
							<td colspan=2 bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>'><b><%=DOMAIN_Text("ACCOUNTS_GROUPS_HASRIGHTS")%></b></td>
						</tr>
						<%
						Set rsDB2 = CreateObject("ADODB.Recordset")
						While ( NOT rsDB.EOF )
							If ( sBGColor = DOMAIN_Color("AccountsBGColor1") ) Then
								sBGColor = DOMAIN_Color("AccountsPageBGColor")
								sTextColor = DOMAIN_Color("AccountsPageText")
							Else
								sBGColor = DOMAIN_Color("AccountsBGColor1")
								sTextColor = DOMAIN_Color("AccountsTextColor1")
							End If
							sHasRights = FALSE
							sSQLText = "SELECT * FROM Rights (NOLOCK) WHERE SystemUnq = " & sSystemUnq & " AND RightsLvl = '" & rsDB("RightsLvl") & "' AND GroupUnq = " & sGroupUnq & " AND AccountUnq = 0 AND DomainUnq = " & iDomainUnq
							Set rsDB2 = CreateObject("ADODB.Recordset")
							rsDB2.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
							If ( NOT rsDB2.EOF ) Then
								If ( IsNull(rsDB2("RevokeDate")) ) Then
									sHasRights = TRUE
								Else
									If ( NOT IsNull(rsDB2("GrantDate")) ) Then
										If ( CDate(rsDB2("RevokeDate")) < CDate(rsDB2("GrantDate")) ) Then
											sHasRights = TRUE
										End If
									End If
								End If
								sGrantDate = rsDB2("GrantDate")
								sRevokeDate = rsDB2("RevokeDate")
							Else
								sGrantDate = ""
								sRevokeDate = ""
							End If
							rsDB2.Close
							sRightsLvl = rsDB("RightsLvl")
							%>
							<tr>
								<td valign=top bgcolor=<%=sBGColor%>><font size=-2 color='<%=sTextColor%>'><%=sRightsLvl%></b>&#151;<%=rsDB("RightsConst")%></td>
								<td valign=top bgcolor=<%=sBGColor%>><font size=-2 color='<%=sTextColor%>'><%=sGrantDate%></td>
								<td valign=top bgcolor=<%=sBGColor%>><font size=-2 color='<%=sTextColor%>'><%=sRevokeDate%></td>
								<td valign=top bgcolor=<%=sBGColor%>>
									<%If ( ACCNT_SpecificDomain(sRightsLvl, iDomainUnq) ) Then%>
									<table cellpadding=0 cellspacing=0 border=0>
										<tr>
										<td><font size=-2 color='<%=sTextColor%>'><%=DOMAIN_Text("ACCOUNTS_GROUPS_YES")%></td>
										<td>
											<input type='hidden' name='ORIGINAL<%=sRightsLvl%>' value='<%If ( sHasRights = TRUE ) Then Response.Write "YES" Else Response.Write "NO" End If%>'>
											<input type='radio' name='<%=sRightsLvl%>' value='YES'<%If ( sHasRights = TRUE ) Then Response.Write " checked" End If%>>
										</td>
										<td><font size=-2 color='<%=sTextColor%>'><%=DOMAIN_Text("ACCOUNTS_GROUPS_NO")%></td>
										<td>
											<input type='radio' name='<%=sRightsLvl%>' value='NO'<%If ( sHasRights = FALSE ) Then Response.Write " checked" End If%>>
										</td>
										</tr>
									</table>
									<%Else%>
									<center><%=DOMAIN_Text("NOACCESS")%></center>
									<%End If%>
								</td>
							</tr>
							<%
							rsDB.MoveNext
						Wend
						Set rsDB2 = Nothing
						%>
					</table>
				</td>
			</tr>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
		</table>
		</form>
		<%
		rsDB.Close
		Set rsDB = Nothing
	End Sub
	'********************************************************************************
%>