<!--#INCLUDE VIRTUAL="/WS_Content/Includes/i_Includes.asp"-->
<%
	Response.Buffer = TRUE
	Dim sError, rs1, sSystemUnq, sRightsLvl, sRemoveRightsLvl, iDomainUnq
	
	Dim sSQLText, rsDB
	
	Call DISP_Action("SB_ACCOUNTS_ADMIN_OPEN")
	Call DISP_Action("SB_ACCOUNTS_INITIAL_RIGHTS")
	If   (ACCNT_AnyDomain("SB_IR_UPDATE")) Then
		Call Main()
	Else
		Call DOMAIN_Message(DOMAIN_Text("ACCT_SYS_RIGHTS"), "ERROR")
	End If
	Call DISP_Action("SB_ACCOUNTS_CLOSE")
	Response.Flush

	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub Main()
		Dim sAction, sRadio, sSetting, sError, sSuccess
	
		Set rs1 = Server.CreateObject("ADODB.recordset")
		sSystemUnq = Trim(Request("sSystemUnq"))
		If ( sSystemUnq = "" ) Then
			sSystemUnq = "1"
		End If
		iDomainUnq = Trim(Request("iDomainUnq"))
		If ( iDomainUnq = "" ) Then
			iDomainUnq = ACCNT_GetDomainW_Rights("SB_IR_UPDATE", "", "")
		End If
		sRightsLvl = Trim(Request("sRightsLvl"))
		sRemoveRightsLvl = Trim(Request("sRemoveRightsLvl"))
		sAction = Request("sAction")
		
		
		Select Case sAction
			Case "UpdateRightsLvl"
			
				If ( iDomainUnq <> iDomainName ) And (NOT ACCNT_SpecificDomain("SB_IR_UPDATE", iDomainUnq)) Then
					' This checks to see if they only logged in with domain rights that they are only able
					'	to edit their domain -- even if they put another DomainUnq on the querystring or in a form they made themselves.
					sError = DOMAIN_Text("DOM_SYS_RIGHTS")
				Else
		            For Each sRadio In Request.Form
		            	If ( InStr(sRadio, "sInitialRight") > 0 ) Then
		            		sRightsLvl = Replace(sRadio, "sInitialRight", "")
		            		sSetting = Request(sRadio)
		            		If ( Request("sOldInitialRight" & sRightsLvl) <> sSetting ) Then
		            			' it's different than it originally was, so change it.
								If ( sSetting = "Y" ) Then
									If sRightsLvl = "" Then
										sError = DOMAIN_Text("ENTER_RTS_LVL")
									Else
										If ( iDomainUnq = "" ) Then
											sError = DOMAIN_Text("INIT_RIGHTS_DOM")
										End If
										If ( sError = "" ) Then
											' Modify the system
											If ( Not InSystem(sRightsLvl) ) Then
												If ( ACCNT_SpecificDomain(sRightsLvl, iDomainUnq) ) Then	' admins can only change rights they have
													DBConnection.Execute "INSERT INTO InitialRights VALUES (" & iDomainUnq & ", " & sSystemUnq & ", '" & SQLEncode(sRightsLvl) & "')"
													Call DOMAIN_Log(54, "", iDomainUnq, "", sSystemUnq, "", 0, "V", "I", SQLEncode(sRightsLvl), "")
													sSuccess = DOMAIN_Text("INSERTED_INITIALRIGHT")
												Else
													sError = DOMAIN_Text("DOM_SYS_RIGHTS")
												End If
											Else
												sError = DOMAIN_Text("INIT_RIGHTS_EXISTS")
											End If
										End If
									End If
								End If
								If ( sSetting = "N" ) Then
									If sRightsLvl = "" Then
										sError = DOMAIN_Text("ENTER_RTS_LVL")
									Else
										' Modify the system
										If ( iDomainUnq <> "" ) Then
											If ( InSystem(sRightsLvl) ) Then
												DBConnection.Execute "DELETE FROM InitialRights WHERE DomainUnq = " & iDomainUnq & " AND SystemUnq = " & sSystemUnq & " AND RightsLvl = '" & SQLEncode(sRightsLvl) & "'"
												Call DOMAIN_Log(54, "", iDomainUnq, "", sSystemUnq, "", 0, "V", "D", SQLEncode(sRightsLvl), "")
												sSuccess = DOMAIN_Text("DELETED_INITIALRIGHT")
											Else
												'sError = DOMAIN_Text("INIT_RIGHTS_NOT_FOUND")
											End If
										Else
											sError = DOMAIN_Text("INIT_RIGHTS_CHOOSE_DOM")
										End If
									End If
								End If
							End If	
		            	End If
		            Next
				End If

		End Select
		
		If ( sError <> "" ) Then
			Call DOMAIN_Message(sError, "ERROR")
		End If
		If ( sSuccess <> "" ) Then
			Call DOMAIN_Message(sSuccess, "SUCCESS")
		End If
		Call WriteForm()

		Set rs1 = Nothing
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This checks to see if they are in the db or not. And if they are, it returns	*
	'*		the date they were taken out of that system or NULL if they are still in	*
	'*		it.																			*
	'*																					*
	'************************************************************************************
	Function InSystem(sRL)
		Dim sSql, rsDB
	
		sSql = "SELECT * FROM InitialRights (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " AND SystemUnq = " & sSystemUnq & " AND RightsLvl = '" & sRL & "'"
		Set rsDB = CreateObject("ADODB.Recordset")
		DBCommand.CommandText = sSQL
		rsDB.Open DBCommand
		If ( NOT rsDB.EOF ) Then
			InSystem = TRUE
		Else
			InSystem = FALSE
		End If
		rsDB.Close
		Set rsDB = Nothing
	End Function
	'************************************************************************************

	
	
	'************************************************************************************
	'*																					*
	'*	This is the function to write out the form.										*
	'*																					*
	'************************************************************************************
	Sub WriteForm()
		Dim sBGColor, sTextColor, rsDomain, rsDB2, sYes, sNo, sRightsConst, sRightsLvl
		Dim sMapName, sRequired, sVisible, sDataType, sOldInitialRight
	
		Set rsDB2 = Server.CreateObject("ADODB.recordset")
		
		sSQLText = "SELECT * FROM RightsLookup (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " AND SystemUnq = " & sSystemUnq & " ORDER BY RightsLvl"
		Set rsDB = CreateObject("ADODB.Recordset")
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		sBGColor = DOMAIN_Color("AccountsBGColor2")
		%>
		<script language='JavaScript1.2' type='text/javascript'>
	
			function SubmitForm(sAction){
				document.ManageADV.sAction.value = sAction;
				document.ManageADV.submit();
			}
			
		</script>
		<form name='ManageADV' action='Default.asp' method='post'>
		<%
		aVariables(0) = "sAction"
		aValues(0) = "New"
		Response.Write DOMAIN_Link("P")
		%>
		<table cellpadding=0 cellspacing=0 border=0 width=671>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
			<tr>
				<td>
					<font color='<%=DOMAIN_Color("AccountsPageText")%>'>
					<font size=+1><b><%=DOMAIN_Text("ACCOUNTS_INITIALRIGHTS_HEADER")%></b></font>
					<br>
					<table>
						<tr>
							<td><font color='<%=DOMAIN_Color("AccountsPageText")%>'><b><%=DOMAIN_Text("ACCOUNTS_INITIALRIGHTS_DOMAIN")%></b></font></td>
							<td><font color='<%=DOMAIN_Color("AccountsPageText")%>'><b><%=DOMAIN_Text("ACCOUNTS_INITIALRIGHTS_SYSTEM")%></b></font></td>
						</tr>
						<tr>
							<td>
								<%Call DOMAINS_DomainsDropDown("SB_IR_UPDATE", "", "")%>
							</td>
							<td>
								<%Call DOMAINS_SystemsDropDown()%>
							</td>
						</tr>
					</table>
					<table cellpadding=2 cellspacing=0 border=0 width=671>
						<tr>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>'><b><%=DOMAIN_Text("ACCOUNTS_INITIALRIGHTS_RIGHT")%></b></td>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>'><b><%=DOMAIN_Text("ACCOUNTS_INITIALRIGHTS_INITIALRIGHT")%></b></td>
						</tr>
						<%
						While ( NOT rsDB.EOF )
							If ( sBGColor = DOMAIN_Color("AccountsBGColor1") ) Then
								sBGColor = DOMAIN_Color("AccountsPageBGColor")
								sTextColor = DOMAIN_Color("AccountsPageText")
							Else
								sBGColor = DOMAIN_Color("AccountsBGColor1")
								sTextColor = DOMAIN_Color("AccountsTextColor1")
							End If
							sRightsConst = Trim(rsDB("RightsConst"))
							sRightsLvl = Trim(rsDB("RightsLvl"))
							sSQLText = "SELECT * FROM InitialRights (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " AND SystemUnq = " & sSystemUnq & " AND RightsLvl = '" & sRightsLvl & "'"
							Set rsDB2 = CreateObject("ADODB.Recordset")
							rsDB2.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
							If ( rsDB2.EOF ) Then
								sYes = ""
								sNo = "checked"
								sOldInitialRight = "N"
							Else
								sNo = ""
								sYes = "checked"
								sOldInitialRight = "Y"
							End If
							%>
							<tr>
								<td bgcolor=<%=sBGColor%> width=100%><font color='<%=sTextColor%>'><b><%=sRightsLvl%></b>&#151;<%=sRightsConst%></font></td>
								<td bgcolor=<%=sBGColor%>>
									<%If ( ACCNT_SpecificDomain(sRightsLvl, iDomainUnq) ) Then%>
									<table cellpadding=0 cellspacing=0 border=0>
										<tr>
											<td bgcolor=<%=sBGColor%>><font color='<%=sTextColor%>'><%=DOMAIN_Text("ACCOUNTS_INITIALRIGHTS_YES")%></td>
											<td align=center bgcolor=<%=sBGColor%>><input type='radio' name='sInitialRight<%=sRightsLvl%>' value='Y' <%=sYes%>></td>
											<td bgcolor=<%=sBGColor%>>&nbsp;&nbsp;&nbsp;&nbsp;<input type='hidden' name='sOldInitialRight<%=sRightsLvl%>' value='<%=sOldInitialRight%>'></td>
											<td bgcolor=<%=sBGColor%>><font color='<%=sTextColor%>'><%=DOMAIN_Text("ACCOUNTS_INITIALRIGHTS_NO")%></td>
											<td align=center bgcolor=<%=sBGColor%>><input type='radio' name='sInitialRight<%=sRightsLvl%>' value='N' <%=sNo%>></td>
										</tr>
									</table>
									<%Else%>
									<center><%=DOMAIN_Text("NOACCESS")%></center>
									<%End If%>
								</td>
							</tr>
							<%
							rsDB2.Close
							rsDB.MoveNext
						Wend
						%>
					</table>
					<br>
					<font size=-2>
					<%=DOMAIN_Text("ACCOUNTS_INITIALRIGHTS_FOOTER1")%>
				</td>
			</tr>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
		</table>
		</form>
		<%
		Set rsDB2 = Nothing
		rsDB.Close
	End Sub
	'********************************************************************************
%>