<!--#INCLUDE VIRTUAL="/WS_Content/Includes/i_Includes.asp"-->
<%
	Response.Buffer = TRUE
	Dim rsDB, sSQLText, objLogon
	Dim sOldDomain, sNewDomain, sOldDescription, sNewDescription, sDomainUnq
	Dim sReturnURL	' don't remove this or the hidden form field. it's used in DOMAINS_MANAGE_DOMAINS_NEW

	Call DISP_Action("SB_DOMAINS_OPEN")
	Call DISP_Action("SB_DOMAINS_MANAGE_DOMAINS_UPDATE")
	If   (ACCNT_AnyDomain("SB_MD_UPDATE")) Then
		Call Main()
	Else
		Call DOMAIN_Message(DOMAIN_Text("DOM_SYS_RIGHTS"), "ERROR")
	End If
	Call DISP_Action("SB_DOMAINS_CLOSE")
	Response.Flush

	'************************************************************************************
	'*																					*
	'*	This is the main sub.															*
	'*																					*
	'************************************************************************************
	Sub Main()
		Dim sAction, sError, sSuccess, sTemp, x, aServerUnqArray, iSiteID
		Dim sLastServerName

		sAction = Trim(Request("sAction"))
		sDomainUnq = Trim(Request("sDomainUnq"))
		If ( sDomainUnq = "" ) Then
			sDomainUnq = iDomainName
		End If
		
		Set rsDB = Server.CreateObject("ADODB.recordset")
		
		Select Case sAction
			Case "UpdateDomain"
				If ( NOT ACCNT_AnyDomain("SB_MD_UPDATE") ) Then
					sError = DOMAIN_Text("DOM_SYS_RIGHTS")
				Else
					sOldDomain = Trim(Replace(Replace(UCase(Request("sOldDomain")), "HTTP://", ""), "/", ""))
					sNewDomain = Trim(Replace(Replace(UCase(Request("sNewDomain")), "HTTP://", ""), "/", ""))
					sOldDescription = Request("sOldDescription")
					sNewDescription = Request("sNewDescription")
					If ( sOldDomain <> sNewDomain Or sOldDescription <> sNewDescription ) Then
						If ( sNewDomain = "" ) Then
							sError = DOMAIN_Text("DOM_NAME")
						End If
						' Check to see if the domain name is changing and if one of that name already exists.
						If ( sNewDomain <> sOldDomain ) Then
							sTemp = Trim(sNameAlreadyUsed(sNewDomain))
						End If
						If ( sTemp <> "" ) Then
							sError = sError & DOMAIN_Text("DOM_EXISTS") & sNewDomain & "<BR>"
						End If
						If ( sError = "" ) Then
							' Update the domain entry in the database
							DBConnection.Execute "UPDATE DomainInfo SET Description = '" & SQLEncode(sNewDescription) & "', Domain = '" & SQLEncode(sNewDomain) & "' WHERE DomainUnq = " & sDomainUnq
							' log the update
							Call DOMAIN_Log(20, "", sDomainUnq, "", 0, "", 0, "V", "U", SQLEncode(sOldDomain), "")
							Call DOMAIN_Log(21, "", sDomainUnq, "", 0, "", 0, "V", "U", SQLEncode(sOldDescription), "")
							' Update the domain in IIS on the servers that are checked
							If ( sOldDomain <> sNewDomain ) Then 	' only do this if they actually changed the domain name
								aServerUnqArray = Split(Request("sUpdateOnServer"), ", ", -1, 1)
								If ( UBound(aServerUnqArray) > 0 ) Then
									On Error Resume Next
									Set objLogon = Server.CreateObject("Tqc.Runas")
									If ( Err.Number <> 0 ) Then
										Call DOMAIN_Message(DOMAIN_Text("DOMAINS_UPDATE_DOMAIN_NO_TQCRUNAS") & Err.Description, "ERROR")
									Else
										For x = 0 To UBound(aServerUnqArray)	' Loop through all servers
											If ( sLastServerName <> aServerUnqArray(x) ) Then	' this will ensure that each servername is done only once
												sSQLText = "SELECT * FROM Servers (NOLOCK) WHERE ServerUnq = " & aServerUnqArray(x)
												rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
												If ( NOT rsDB.EOF ) Then
												    objLogon.RevertToSelf()
													objLogon.NetOnly = 1
													objLogon.Domain = rsDB("ServerDomain")
													objLogon.TargetComputer = rsDB("ServerName")
													If ( objLogon.ImpersonateUser(rsDB("Login"), rsDB("Password"), rsDB("ServerName")) ) Then
														iSiteID = GetSiteID( aServerUnqArray(x), sDomainUnq )
														If ( Trim(iSiteID) = "-1" ) Then
															' don't try and change it in IIS if its -1. Only change it in the database.
														Else
															If ( UpdateWebSite(rsDB("ServerName"), iSiteID, sNewDomain) ) Then
																
															End IF
														End If
														objLogon.RevertToSelf()	' kill login - but only if the object has been successfully instanciated
													End If
												End If
												rsDB.Close
											End If
											sLastServerName = aServerUnqArray(x)
										Next
									End If
									Set ObjLogon = Nothing
									On Error Goto 0
								End If
								If ( sSuccess = "" ) Then
									sSuccess = DOMAIN_Text("DOM_UPDATED")
								End If
							End If
						End If
					End If
				End If

		End Select
		
		If ( sError <> "" ) Then
			Call DOMAIN_Message(sError, "ERROR")
		End If
		If ( sSuccess <> "" ) Then
			Call DOMAIN_Message(sSuccess, "SUCCESS")
		End If
		
		Call WriteForm()
		Set rsDB = Nothing
	End Sub
	'************************************************************************************
	


	'************************************************************************************
	'*																					*
	'*	This is the function to write out the form.										*
	'*																					*
	'************************************************************************************
	Sub WriteForm()
		Dim sDomain, sDescription
		Dim sBGColor, sFontColor
		%>
		<center>
		<form name='UpdateDomains' action='Update.asp' method='post'>
		<%
		aVariables(0) = "sAction"
		aVariables(1) = "iTtlNumItems"
		aVariables(2) = "iDBLoc"
		aVariables(3) = "sDomainUnq"
		aVariables(4) = "sReturnURL"
		aValues(0) = "UpdateDomain"
		aValues(1) = Request("iTtlNumItems")
		aValues(2) = Request("iDBLoc")
		aValues(3) = sDomainUnq
		aValues(4) = sReturnURL
		Response.Write DOMAIN_Link("P")
		%>
		<table cellpadding=0 cellspacing=0 border=0 width=671>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
			<tr>
				<td>
					<font color='<%=DOMAIN_Color("DomainsPageText")%>'>
					<font size=+1><b><%=DOMAIN_Text("DOMAINS_UPDATE_INTRO")%></b></font>
					<br><br>
					<table cellpadding=2 cellspacing=0 border=0 width=671>
						<%
						sBGColor = DOMAIN_Color("DomainsBGColor1")
						sFontColor = DOMAIN_Color("DomainsTextColor1")
						sSQLText = "SELECT * FROM DomainInfo (NOLOCK) WHERE DomainUnq = " & sDomainUnq
						rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
						sDomain = Replace(rsDB("Domain"), "'", "&#39;")	' convert any single quote into a &#39; for display in the form field
						sDescription = Replace(rsDB("Description"), "'", "&#39;")
						sDomainUnq = rsDB("DomainUnq")
						%>
						<tr>
							<td align=center bgcolor=<%=sBGColor%>><font color='<%=sFontColor%>'><%=sDomainUnq%></font></td>
							<td bgcolor=<%=sBGColor%>>
								<font color='<%=sFontColor%>'><b>
								<%=DOMAIN_Text("DOMAINS_DOMAIN_NAME")%></b>: 
								<input type='hidden' name='sOldDomain' value='<%=sDomain%>'>
								<input type='text' name='sNewDomain' value='<%=sDomain%>' size=40 maxlength=250>
							</td>
						</tr>
						<%
						sBGColor = DOMAIN_Color("DomainsPageBGColor")
						sFontColor = DOMAIN_Color("DomainsPageText")
						%>
						<tr>
							<td colspan=2 bgcolor=<%=sBGColor%>><font color='<%=sFontColor%>'><b><%=DOMAIN_Text("DOMAINS_DOMAIN_DESC")%></b></td>
						</tr>
						<tr>
							<td colspan=2 bgcolor=<%=sBGColor%>>
								<input type='hidden' name='sOldDescription' value='<%=sDescription%>'>
								<input type='text' name='sNewDescription' value='<%=sDescription%>' size=80 maxlength=250>
							</td>
						</tr>
					</table>
					<%
					rsDB.Close
					sBGColor = DOMAIN_Color("DomainsBGColor2")
					sFontColor = DOMAIN_Color("DomainsTextColor2")
					%>
					<table cellpadding=2 cellspacing=0 border=0 width=671>
						<tr>
							<td colspan=4 bgcolor=<%=sBGColor%>><font color='<%=sFontColor%>'><b><%=DOMAIN_Text("DOMAINS_UPDATE_SERVERS")%></b></td>
						</tr>
						<tr>
							<td bgcolor=<%=sBGColor%>><font color='<%=sFontColor%>'><b><%=DOMAIN_Text("DOMAINS_UPDATE_SERVER_NAME")%></b></td>
							<td bgcolor=<%=sBGColor%>><font color='<%=sFontColor%>'><b><%=DOMAIN_Text("DOMAINS_UPDATE_SERVER_IP")%></b></td>
							<td bgcolor=<%=sBGColor%>><font color='<%=sFontColor%>'><b><%=DOMAIN_Text("DOMAINS_UPDATE_SERVER_TYPE")%></b></td>
							<td bgcolor=<%=sBGColor%>><font color='<%=sFontColor%>'><b><%=DOMAIN_Text("DOMAINS_UPDATE_SERVER_UPDATE_ON_SERVER")%></b></td>
						</tr>
						<%
						sBGColor = DOMAIN_Color("DomainsBGColor1")
						sFontColor = DOMAIN_Color("DomainsTextColor1")
						sSQLText = "SELECT * FROM ServerSites T (NOLOCK), Servers S (NOLOCK) WHERE T.DomainUnq = " & sDomainUnq & " AND S.ServerUnq = T.ServerUnq ORDER BY S.ServerName"
						rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
						While ( NOT rsDB.EOF )
							%>
							<tr>
								<td bgcolor=<%=sBGColor%>><font color='<%=sFontColor%>'><%=rsDB("ServerName")%></td>
								<td bgcolor=<%=sBGColor%>><font color='<%=sFontColor%>'><%=rsDB("ServerIP")%></td>
								<td bgcolor=<%=sBGColor%>><font color='<%=sFontColor%>'><%=rsDB("ServerType")%></td>
								<td bgcolor=<%=sBGColor%>><font color='<%=sFontColor%>'><input type='checkbox' name='sUpdateOnServer' value='<%=rsDB("ServerUnq")%>' checked></td>
							</tr>
							<%
							rsDB.MoveNext
						Wend
						rsDB.Close
						%>
						<tr>
							<td colspan=4 bgcolor=<%=DOMAIN_Color("DomainsPageBGColor")%> align=center>
								<input type='submit' value='<%=DOMAIN_Text("DOMAINS_UPDATE_SERVER_SAVE_CHANGES")%>'>
							</td>
						</tr>
					</table>
					<br>
					<font size=-2>
					<%=DOMAIN_Text("DOMAINS_DOMAIN_UPDATE_FOOTER")%>
				</td>
			</tr>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
		</table>
		</form>
		<%
	End Sub
	'************************************************************************************
	


	'************************************************************************************
	'*																					*
	'*	This checks to see if the changed name for the domain we are editing is already	*
	'*		used by another previously existing domain.									*
	'*																					*
	'************************************************************************************
	Function sNameAlreadyUsed(sModifiedDomain)
		Dim rsDomain, sSQLText
		
		sNameAlreadyUsed = ""
		Set rsDomain = CreateObject("ADODB.Recordset")
		sSQLText = "SELECT * FROM DomainInfo (NOLOCK) WHERE Domain = '" & sModifiedDomain & "'"
		rsDomain.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDomain.EOF ) Then
			If ( rsDomain("DomainUnq") <> CDbl(Request("sDomainUnq")) ) Then	' because the modified domain was found, check to see if it's just the original
				sNameAlreadyUsed = rsDomain("Description")	' Unfortunately it already exists and it's a different DomainUnq
			End If
		End If
		rsDomain.Close
		Set rsDomain = Nothing
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Gets the site ID from each server for the domain.								*
	'*																					*
	'************************************************************************************
    Function GetSiteID(sServerUnq, sDomainUnq)

		Dim rsDomain, sSQLText
		
		GetSiteID = ""
		Set rsDomain = CreateObject("ADODB.Recordset")
		sSQLText = "SELECT IISName FROM ServerSites (NOLOCK) WHERE ServerUnq = " & sServerUnq & " AND DomainUnq = " & sDomainUnq
		rsDomain.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDomain.EOF ) Then
			GetSiteID = rsDomain("IISName")
		End If
		rsDomain.Close
		Set rsDomain = Nothing

    End Function
    '************************************************************************************
    

	'************************************************************************************
	'*																					*
	'*	Updates the website's name/domain in IIS.										*
	'*																					*
	'************************************************************************************
    Function UpdateWebSite(sServerName, iSiteID, sNewDomain)
    
		Dim NewApplication
		UpdateWebSite = TRUE
		
		Dim objComp, objNew, IpAddy, objRoot, aServerBindings, x, iPos, iPos2, sTempBinding, sTemp

		On Error Resume Next
		Set NewApplication = GetObject( "IIS://" & sServerName & "/W3SVC/" & iSiteID & "/ROOT" )
		If Err.Number <> 0 Then
			Call DOMAIN_Message(Replace(DOMAIN_Text("DOMAINS_UPDATE_DOMAIN_CANT_GET_IISOBJ"),"1:",sServerName) & Err.Description, "ERROR")
			UpdateWebSite = FALSE
		Else
			NewApplication.AppFriendlyName = sNewDomain
			NewApplication.SetInfo
			If Err.Number <> 0 Then
				UpdateWebSite = FALSE
			Else
				If Err.Number <> 0 Then
					Call DOMAIN_Message(Replace(DOMAIN_Text("DOMAINS_UPDATE_DOMAIN_CANT_GET_IISENTRY"),"1:",sServerName) & Err.Description, "ERROR")
					UpdateWebSite = FALSE
				Else
					Set objComp = GetObject("IIS://" & sServerName & "/W3SVC")
					Set objNew = ObjComp.GetObject("IIsWebServer", iSiteID )
					If Err.Number <> 0 Then
						Call DOMAIN_Message(Replace(DOMAIN_Text("DOMAINS_UPDATE_DOMAIN_CANT_GET_HOSTHEADER"),"1:",sServerName) & Err.Description, "ERROR")
						UpdateWebSite = FALSE
					Else
						objNew.ServerComment = sNewDomain
						aServerBindings = objNew.ServerBindings
						sTemp = sNewDomain
						For x = 0 to UBound(aServerBindings)
							iPos = InStr(aServerBindings(x), ":")
							iPos2 = InStr(iPos+1, aServerBindings(x), ":")	' get the position of the second colon
							sTempBinding = Left(aServerBindings(x), iPos2) & sTemp
							aServerBindings(x) = sTempBinding
							sTemp = Replace(LCase(sTemp), "www.", "")
							If ( x = 1 ) Then
								Exit For	' do not want to deal with any more than the first two host headers - we can't guess at what to change them to
							End If
						Next
						objNew.ServerBindings = aServerBindings
						objNew.SetInfo
					End If
					Set objNew  = Nothing
					Set objComp = Nothing
				End If
			End If
		End If
		
		Set NewApplication = Nothing
    
    End Function
    '************************************************************************************
%>
