<!--#INCLUDE VIRTUAL="/WS_Content/Includes/i_Includes.asp"-->
<%
	Response.Buffer = TRUE
	Server.ScriptTimeout = 20000000
	
	Dim sSQLText, sDirectory, iThumbComponent, intXSize, sGalleryPath
	Dim sAction, sError, sSuccess, sRightsLvl, fso, bMirrorMB
	Dim objItem, objItem2, ObjFSO, intOrigXSize, intOrigYSize
	Dim rsMsgBoard
	
	Const ASPIMAGE					= 1
	Const GFL						= 2

	Call DISP_Action("SB_DOMAINS_OPEN")
	Call DISP_Action("SB_DOMAINS_MANAGE_CONFIGURATIONS")
	If   (ACCNT_AnyDomain("SB_IG_ADMIN_ALL")) Then
		Call Main()
	Else
		Call DOMAIN_Message(DOMAIN_Text("DOM_SYS_RIGHTS"), "ERROR")
	End If
	Call DISP_Action("SB_DOMAINS_CLOSE")
	Response.Flush

	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub Main()
		
		Select Case Trim(Request("sAction"))
			Case "AddImages"
				sDirectory			= Trim(Request("sDirectory"))
				bMirrorMB			= Trim(Request("bMirrorMB"))
				If ( sDirectory <> "" ) Then
					Set ObjFSO			= CreateObject("Scripting.FileSystemObject")
					sRightsLvl			= Trim(Request("sRightsLvl"))
					iThumbComponent		= G_ADMINISTRATION_ASPImageInstalled()
					intXSize			= Int(DOMAIN_Conf("IMAGEGALLERY_THUMBNAIL_WIDTH"))
					sGalleryPath 		= DOMAIN_Conf("IG")
					Set fso				= CreateObject("Scripting.FileSystemObject")
					Call ProcessFiles(sDirectory, 0)
					Set fso						= Nothing
					
					If ( bMirrorMB = "Y" ) Then
						Set rsMsgBoard	= Server.CreateObject("ADODB.recordset")
					End If
				Else
					sError = "Please enter the directory to search for the files."
				End If
		End Select

		If ( sError <> "" ) Then
			Call DOMAIN_Message(sError, "ERROR")
		End If
		If ( sSuccess <> "" ) Then
			Call DOMAIN_Message(sSuccess, "SUCCESS")
		End If

		Call WriteForm()

	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This is the recursive Sub that processes the directories and files.				*
	'*																					*
	'************************************************************************************
	Sub ProcessFiles(sPath, iParentCat)
	
		Dim objFolder, iGalleryUnq, sGalleryName, rsImageGallery, iImageNum

		Set objFolder		= ObjFSO.GetFolder(sPath)
		Set rsImageGallery	= Server.CreateObject("ADODB.recordset")
		
		For Each objItem In objFolder.SubFolders
			If ( ( InStr(objItem, "_vti") = 0 ) And ( InStr(objItem, "Alt") = 0 ) And ( InStr(objItem, "dah_") = 0 ) ) Then
				' do not recurse down galleries! there cannot be sub-galleries
				If ( objItem.Files.Count > 0 ) Then
					sGalleryName	= objItem.Name
					iGalleryUnq		= iCreateGallery(iParentCat, sGalleryName)
					' now because when we insert new images, we need to know the position #, get that for the current gallery (it might alreayd have images in it)
					sSQLText = "SELECT IsNull(MAX(G.Position), 0) FROM Images I (NOLOCK), ImagesInGallery G (NOLOCK) WHERE G.GalleryUnq = " & iGalleryUnq & " AND I.ImageUnq = G.ImageUnq"
					rsImageGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
					If ( NOT rsImageGallery.EOF ) Then
						iImageNum = rsImageGallery(0) + 1
					Else
						iImageNum = 0
					End If
					rsImageGallery.Close

					' create the gallery and return the GalleryUnq so we can add the images to it.
					For Each objItem2 In objItem.Files
						If (InStr(UCase(objItem2.Name), ".JS") = 0) And (InStr(UCase(objItem2.Name), ".HTM") = 0) And (InStr(UCase(objItem2.Name), ".HTML") = 0) And (InStr(UCase(objItem2.Name), ".ASP") = 0) Then
							' add the file to the gallery
							Call CreateImage(iGalleryUnq, objItem2, sGalleryName, iImageNum)
							iImageNum = iImageNum + 1
						End If
					Next
				Else
					' create the category as a child of iParentCat and return the new categories CatUnq to pass as a parameter
					Call ProcessFiles(sPath & "\" & objItem.Name, sCreateCategory(iParentCat, objItem.Name))
				End If
			End If
		Next
		
		Set rsImageGallery = Nothing
	
	End Sub
	'************************************************************************************
	
	
	
	'************************************************************************************
	'*																					*
	'*	This adds the images to the galleries.											*
	'*																					*
	'************************************************************************************
	Sub CreateImage(iGalleryUnq, objItem, sGalleryName, iImageNum)
		Dim rsImageGallery, sThumbName, iFileSize, iTempImageUnq, sOriginalName
		Dim sName, sFilePath, iPos, sExtension, sFixedFileName, bAltExists, f
		Dim objASPImage, iXSize, iYSize, sAltName, iAltFileSize
		
		sName				= objItem.Name
		sOriginalName		= sName	' for use when dealing w/ alt images
		sFilePath			= objItem.Path
		iFileSize			= objItem.Size
		sFixedFileName		= FixFilename(sName, "PRIMARY")
		iPos				= InStrRev(sName, ".")
		sExtension			= Mid(sName, iPos + 1)
		Set rsImageGallery	= Server.CreateObject("ADODB.recordset")
		bAltExists			= FALSE
		
		If ( sName <> sFixedFileName ) Then
			fso.MoveFile sFilePath, Replace(sFilePath, sName, "") & sFixedFileName
		End If
		sName = sFixedFileName
		
		' Check to make sure the file doesn't already exist
		If ( fso.FileExists(Server.Mappath("\" & sGalleryPath & "\" & iLoginAccountUnq & "\" & iGalleryUnq) & "\" & sName) ) Then
			' do not copy it
			Response.Write Replace(DOMAIN_Text("GALLERY_BULK_FILE_EXISTS"),"1:", sName)
		Else

			sThumbName = Thumbnail(sName, sFilePath, iGalleryUnq)
			
			' see if there is an Alt image in the "Alt" directory w/ the same name as the primary image
			If ( fso.FileExists(Replace(sFilePath, sOriginalName, "") & "\Alt\" & sOriginalName) ) Then
				bAltExists = TRUE
				Set f = fso.GetFile(Replace(sFilePath, sOriginalName, "") & "\Alt\" & sOriginalName)
				iAltFileSize = f.size
				Set f = Nothing
				If ( iThumbComponent = ASPIMAGE ) Then
					Set objASPImage = Server.CreateObject("AspImage.Image")
					objASPImage.LoadImage(Replace(sFilePath, sOriginalName, "") & "\Alt\" & sOriginalName)
					iXSize = objASPImage.MaxX	' get this for the database
					iYSize = objASPImage.MaxY
				ElseIf ( iThumbComponent = GFL ) Then
					Set objASPImage = Server.CreateObject("GflAx.GflAx")
					objASPImage.EnableLZW = TRUE
					On Error Resume Next
					objASPImage.LoadBitmap(Replace(sFilePath, sOriginalName, "") & "\Alt\" & sOriginalName)
					If ( Err.Number <> 0 ) Then
						' can't open the image
						iXSize	= 0
						iYSize	= 0
					Else
						iXSize	= objASPImage.Width
						iYSize	= objASPImage.Height
					End If
					On Error Goto 0
				End If
				Set objASPImage = Nothing
				' rename the alt image if necessary (copying the name of the primary image)
				If ( sOriginalName <> sFixedFileName ) Then
					fso.MoveFile Replace(sFilePath, sOriginalName, "") & "\Alt\" & sOriginalName, Replace(sFilePath, sOriginalName, "") & "\Alt\" & sFixedFileName
				End If
				fso.CopyFile Replace(sFilePath, sOriginalName, "") & "\Alt\" & sOriginalName, Server.Mappath("\" & sGalleryPath & "\" & iLoginAccountUnq & "\" & iGalleryUnq) & "\Alt_" & sName, FALSE
				sAltName = "Alt_" & sName
			End If

			fso.CopyFile sFilePath, Server.Mappath("\" & sGalleryPath & "\" & iLoginAccountUnq & "\" & iGalleryUnq) & "\" & sName, FALSE
			If ( sThumbName = "" ) Then
				DBConnection.Execute "INSERT INTO Images VALUES ('" & SQLEncode(sGalleryName) & "', '" & SQLEncode(sGalleryName) & "', '" & SQLEncode(sName) & "', '',0,0,0,'" & Trim(CStr(iFileSize)) & "','" & Trim(Cstr(intOrigXSize)) & "','" & Trim(Cstr(intOrigYSize)) & "'," & Trim(CStr(iImageNum)) & ", '" & sExtension & "', '" & SQLEncode(sAltName) & "', '', '', '', '" & SQLEncode(sGalleryName) & "', '', '', '', '" & SQLEncode(sGalleryName) & "', '', '', '', '" & iXSize & "', '" & iYSize & "', '', '', '', '', '', '', '" & iAltFileSize & "', '', '', '', 0,0,'" & SQLEncode(sGalleryName) & "','" & SQLEncode(sGalleryName) & "', '" & SQLEncode(sGalleryName) & "', " & iLoginAccountUnq & ",0,0,0,0,0,'N')"
			Else
				DBConnection.Execute "INSERT INTO Images VALUES ('" & SQLEncode(sGalleryName) & "', '" & SQLEncode(sGalleryName) & "', '" & SQLEncode(sName) & "', '" & SQLEncode(sName) & "',0,0,0,'" & Trim(CStr(iFileSize)) & "','" & Trim(Cstr(intOrigXSize)) & "','" & Trim(Cstr(intOrigYSize)) & "'," & Trim(CStr(iImageNum)) & ", '" & sExtension & "', '" & SQLEncode(sAltName) & "', '', '', '', '" & SQLEncode(sGalleryName) & "', '', '', '', '" & SQLEncode(sGalleryName) & "', '', '', '', '" & iXSize & "', '" & iYSize & "', '', '', '', '', '', '', '" & iAltFileSize & "', '', '', '', 0,0,'" & SQLEncode(sGalleryName) & "','" & SQLEncode(sGalleryName) & "', '" & SQLEncode(sGalleryName) & "', " & iLoginAccountUnq & "," & iLoginAccountUnq & ",0,0,0,0,'N')"
			End If

			rsImageGallery.Open "SELECT @@IDENTITY", DBConnection
			If (NOT rsImageGallery.EOF) Then
				iTempImageUnq = rsImageGallery(0)
				rsImageGallery.Close
				
				DBConnection.Execute "INSERT INTO ImagesInGallery VALUES (" & iTempImageUnq & ", " & iGalleryUnq & ", GetDate()," & iDomainName & ", " & Trim(CStr(iImageNum)) & ", " & iGalleryUnq & "," & iDomainName & ",0,0,0,0,0)"

				' process any Alternate View images - must send it the original file name
				'Call ProcessAlts(sName, bUseASPImage, iTempImageUnq, sOriginalName)
				
				Response.Write Replace(DOMAIN_Text("GALLERY_BULK_IMAGE_COPIED"),"1:", sName)
			Else
				rsImageGallery.Close
			End If

		End If
		
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This makes a thumbnail.															*
	'*																					*
	'************************************************************************************
	Function Thumbnail(FileName, sFilePath, iGalleryUnq)
		Dim objASPImage, fso, fldr, iPos, intYSize, sTemp
		
		Thumbnail = ""

		If ( Trim(FileName) <> "" ) Then
			
			If ( iThumbComponent = ASPIMAGE ) Then
				Set objASPImage = Server.CreateObject("AspImage.Image")
				objASPImage.LoadImage(sFilePath)
				intOrigXSize = objASPImage.MaxX	' get this for the database
				intOrigYSize = objASPImage.MaxY
				If ((objASPImage.ImageFormat=1) Or (objASPImage.ImageFormat=2) Or (objASPImage.ImageFormat=3)) And (objASPImage.MaxX>0) Then
					intYSize = Int((intXSize / intOrigXSize) * intOrigYSize)
					objASPImage.Resize intXSize, intYSize
					iPos = InStr(FileName, ".")
					sTemp = Left(FileName, iPos) + "jpg"
					objASPImage.FileName = (server.mappath("\" & sGalleryPath & "\" & iLoginAccountUnq & "\" & iGalleryUnq) & "\Thumbnails\" & sTemp)
					objASPImage.SaveImage
					Response.Write Replace(DOMAIN_Text("GALLERY_BULK_THUMB_CREATED"), "1:", sTemp) & "<BR>"
					Thumbnail = sTemp
				End If
			ElseIf ( iThumbComponent = GFL ) Then
				Set objASPImage = Server.CreateObject("GflAx.GflAx")
				objASPImage.EnableLZW = TRUE
				On Error Resume Next
				objASPImage.LoadBitmap(sFilePath)
				If ( Err.Number <> 0 ) Then
					Response.Write "Unable to create thumbnail for file: <b>" & aFileName(iFileNum) & "</b>. The file type is not supported by the GflAx component.<br>"
				Else
					intOrigXSize	= objASPImage.Width
					intOrigYSize	= objASPImage.Height
					intYSize		= Int((intXSize / intOrigXSize) * intOrigYSize)
					objASPImage.Resize intXSize, intYSize
					' must turn this on so it'll convert .jpg images. must save as .jpg because GlfAx IGNORES
					'	the filename's extension you give it and names it whatever the image is. so if it's actually a .gif, the
					'	filename.jpg will be ignored and be saved as filename.gif -- messing up the database!
					objASPImage.SaveFormat = 1
					objASPImage.SaveJPEGQuality = 50
					iPos = InStr(FileName, ".")
					sTemp = Left(FileName, iPos) + "jpg"
					objASPImage.SaveBitmap (server.mappath("\" & sGalleryPath & "\" & iLoginAccountUnq & "\" & iGalleryUnq) & "\Thumbnails\" & sTemp)
					Thumbnail = sTemp
				End If
				On Error Goto 0
			End If
			Set objASPImage = Nothing

		End If

	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This creates the galleries.														*
	'*																					*
	'************************************************************************************
	Function iCreateGallery(iCategoryUnq, ByRef sName)
		Dim iPosition, rsImageGallery, fldr, sDescription
		
		iCreateGallery		= 0
		sName				= GetName(sName)	' process the name
		Set rsImageGallery	= Server.CreateObject("ADODB.recordset")
		
		' see if the gallery already exists in this category
		sSQLText = "SELECT * FROM Galleries (NOLOCK) WHERE CategoryUnq = " & iCategoryUnq & " AND Name = '" & SQLEncode(sName) & "'"

		rsImageGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( rsImageGallery.EOF ) Then
			' it doesn't exist, create it
			rsImageGallery.Close
			
			' get the next position for this category - need to check domain too cuz categoryunq = 0 a lot (ie. not in category)
			sSQLText = "SELECT IsNull(MAX(Position), 0) + 1 FROM Galleries (NOLOCK) WHERE CategoryUnq = " & iCategoryUnq & " AND Domain = " & iDomainName
			rsImageGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If (NOT rsImageGallery.EOF) Then
				iPosition = rsImageGallery(0)
			Else
				iPosition = 1
			End If
			rsImageGallery.Close
			
			sDescription = sName
			If ( Len(sName) > 31 ) Then
				sName = Left(sName, 27) + "..."
			End If
			DBConnection.Execute "INSERT INTO Galleries VALUES (" & iLoginAccountUnq & ", " & iDomainName & ", '" & SQLEncode(sName) & "', '" & SQLEncode(sDescription) & "', '1', " & iCategoryUnq & ", 'FULL', 0, 0, " & iPosition & ", '" & Trim(ACCNT_UserName(iLoginAccountUnq)) & "')"
			' set the gallery images visible to everyone
			rsImageGallery.Open "SELECT @@IDENTITY", DBConnection
			If (NOT rsImageGallery.EOF) Then
				iCreateGallery = rsImageGallery(0)
				DBConnection.Execute "INSERT INTO PrivateAccounts VALUES (" & iCreateGallery & ", -1)"
			End If
			rsImageGallery.Close
			
			' Make sure the directories exist...make them if they don't
			fldr = server.mappath("\" & sGalleryPath & "\")
			If (NOT fso.FolderExists(fldr)) Then
				fso.CreateFolder(fldr)
			End If
			fldr = server.mappath("\" & sGalleryPath & "\" & iLoginAccountUnq & "\")
			If (NOT fso.FolderExists(fldr)) Then
				fso.CreateFolder(fldr)
			End If
			fldr = server.mappath("\" & sGalleryPath & "\" & iLoginAccountUnq & "\" & iCreateGallery)
			If (NOT fso.FolderExists(fldr)) Then
				fso.CreateFolder(fldr)
			End If
			fldr = server.mappath("\" & sGalleryPath & "\" & iLoginAccountUnq & "\" & iCreateGallery & "\Thumbnails\")
			If (NOT fso.FolderExists(fldr)) Then
				fso.CreateFolder(fldr)
			End If
			
			Response.Write "Gallery created: " & sName & "(" & iCreateGallery & ")<BR>"
		Else
			iCreateGallery = rsImageGallery("GalleryUnq")
			Response.Write "Gallery already exists: " & sName & "(" & iCreateGallery & ")<BR>"
			rsImageGallery.Close
		End If
		
	End Function
	'************************************************************************************
	
	
	
	'************************************************************************************
	'*																					*
	'*	This creates the categories.													*
	'*																					*
	'************************************************************************************
	Function sCreateCategory(iParentUnq, sCatName)
		Dim iMaxPos, iTemp, rsImageGallery
	
		sCreateCategory		= 0
		sCatName			= GetName(sCatName)	' process the name
		Set rsImageGallery	= Server.CreateObject("ADODB.recordset")

		' see if the category already exists under the parent
		sSQLText = "SELECT * FROM IGCategories (NOLOCK) WHERE Parent = " & iParentUnq & " AND Name = '" & sCatName & "'"
		rsImageGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( rsImageGallery.EOF ) Then
			' it doesn't exist, create it
			rsImageGallery.Close
			sSQLText = "SELECT IsNull(MAX(Position), 0) FROM IGCategories (NOLOCK) WHERE Parent = " & iParentUnq & " AND DomainUnq = " & iDomainName
			rsImageGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsImageGallery.EOF ) Then
				iMaxPos = CDbl(rsImageGallery(0)) + 1
			Else
				iMaxPos = 1
			End If
			rsImageGallery.Close

			DBConnection.Execute "INSERT INTO IGCategories VALUES (" & iDomainName & ", '" & SQLEncode(sCatName) & "', '" & SQLEncode(sCatName) & "', 'N', " & iMaxPos & ", " & iParentUnq & ", 0, '" & SQLEncode(sRightsLvl) & "')"
			sSQLText = "SELECT @@IDENTITY"
			rsImageGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsImageGallery.EOF ) Then
				sCreateCategory = rsImageGallery(0)
			End If
			rsImageGallery.Close
			
			' add one to the number of children this new conference's parent has (if it's not a top level conf)
			sSQLText = "SELECT NumChildren FROM IGCategories WHERE CategoryUnq = " & iParentUnq
			rsImageGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsImageGallery.EOF And NOT IsNull(rsImageGallery("NumChildren")) ) Then
				iTemp = CDbl(rsImageGallery("NumChildren")) + 1
			Else
				iTemp = 1
			End If
			rsImageGallery.Close
			DBConnection.Execute "UPDATE IGCategories SET NumChildren = " & iTemp & " WHERE CategoryUnq = " & iParentUnq
			Response.Write "Category created: " & sCatName & "(" & sCreateCategory & ")<BR>"
		Else
			' it already exists, just return that categories catunq
			sCreateCategory = rsImageGallery("CategoryUnq")
			Response.Write "Category already exists: " & sCatName & "(" & sCreateCategory & ")<BR>"
			rsImageGallery.Close
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This function cleans up the name for a category or gallery.						*
	'*																					*
	'************************************************************************************
	Function GetName(sName)
		Dim sCrazy, x, cChar, iLen

		sCrazy			= "=+,{};`~!@#$%^() []\/*?:"""	' left out _ -.'
		iLen			= Len(sName)

		' replace the crazy characters AND characters less than Asc 32 or greater than Asc 126
		For x = 1 to iLen
			cChar = Mid(sName, x, 1)
			If ( Asc(cChar) < 32 ) Or ( Asc(cChar) > 126 ) Or ( InStr(sCrazy, cChar) > 0 ) Then
				' Found a character outside the normal range - replace it with a space
				If ( x < iLen ) Then
					sName = Left(sName, x-1) & " " & UCase(Mid(sName, x+1, 1)) & Right(sName, iLen - x-1)
				Else
					sName = Left(sName, x-1) & " "
				End If
				'sName = Left(sName, x-1) & " " & Right(sName, iLen - x)
			End If
		Next
		
		sName = UCase(Left(sName, 1)) & Right(sName, iLen - 1)
		
		GetName = sName
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Replaces crazy characters in file names with underscores.						*
	'*																					*
	'************************************************************************************
	Function FixFilename(sName, sType)
		Dim sCrazy, x, cChar, iLen, lf, sFilePath, iCount, sOriginalName

		sCrazy			= "=+,&{};'`~!@#$%^() []\/*?:"""	' left out . _ -
		iLen			= Len(sName)
		iCount			= 0
		sOriginalName	= sName

		' replace the crazy characters AND characters less than Asc 32 or greater than Asc 126
		For x = 1 to iLen
			cChar = Mid(sName, x, 1)
			If ( Asc(cChar) < 32 ) Or ( Asc(cChar) > 126 ) Or ( InStr(sCrazy, cChar) > 0 ) Then
				' Found a character outside the normal range - replace it with an underscore
				sName = Left(sName, x-1) & "-" & Right(sName, iLen - x)
			End If
		Next

		FixFilename = sName
	End Function
	'************************************************************************************


	
	'************************************************************************************
	'*																					*
	'*	Checks to see if ASPImage is installed or not.									*
	'*																					*
	'************************************************************************************
	Function G_ADMINISTRATION_ASPImageInstalled()
		Dim objASPImage, sTemp
		
		sTemp = UCase(Trim(DOMAIN_Conf("IMAGEGALLERY_THUMBNAIL_GENERATOR")))
		G_ADMINISTRATION_ASPImageInstalled = 0
		
		If ( sTemp = "ASPIMAGE" ) Then
			On Error Resume Next
			Set objASPImage = Server.CreateObject("AspImage.Image")
			If ( Err.Number <> 0 ) Then
				G_ADMINISTRATION_ASPImageInstalled = 0
			Else
				G_ADMINISTRATION_ASPImageInstalled = ASPIMAGE
			End If
			Set objASPImage = Nothing
			On Error Goto 0
		ElseIf ( sTemp = "GFL" ) Then
			On Error Resume Next
			Set objASPImage = Server.CreateObject("GflAx.GflAx")
			If ( Err.Number <> 0 ) Then
				G_ADMINISTRATION_ASPImageInstalled = 0
			Else
				G_ADMINISTRATION_ASPImageInstalled = GFL
			End If
			Set objASPImage = Nothing
			On Error Goto 0
		End If
		
		iThumbComponent = G_ADMINISTRATION_ASPImageInstalled	' set the global variable so other functions can access it
		
	End Function
	'************************************************************************************
	

	'************************************************************************************
	'*																					*
	'*	This is the function to write out the form.										*
	'*																					*
	'************************************************************************************
	Sub WriteForm()
		Dim sBGColor, rsDB, sTemp

		sBGColor = DOMAIN_Color("DomainsBGColor2")
		%>

		<table cellpadding=0 cellspacing=0 border=0 width=671>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
			<tr>
				<td>
					<font color='<%=DOMAIN_Color("DomainsPageText")%>'><font size=+1><b>Add Images</b></font>
					<br>
					This will create categories, galleries and add images according to the directory structure
					at the location provided below.
					<br><br>
					This script is distributed with licensed versions only because it does not check or increment
					gallery or image limitations (image size, disk space, etc.). You must have SB_IG_ADMIN_ALL rights
					to use this script. 
					<br><Br>
					No subscription emails will be sent.
					<br><br>
					Categories will be created as long as their child directories do not have files in them.
					<br>
					Galleries will be created from directories that have files in them.
					<br><br>
					Galleries at the root will not be placed in a category.
					<br><br>
					Categories and galleries will both be created based on the directory name. 
					These characters will be replaced with a space: <code>=+,{};`~!@#$%^()[]\/*?:"</code>
					<br><br>
					If an image (A) is within a directory that also has subdirectories with images in them, then
					image A will not be added to any gallery.
					<br><br>
					The name of the image, it's alt-tag, description and title will all be the name of the gallery.
					<br><br>
					If a category or gallery already exists in it's respective location (gallery "A" in category
					"C" will not be replicated in category "C", BUT can be replicated in category "D" if the
					directory structure calls for it), it will not be replicated.
					<br><br>
					Thumbnails will be created only if ASPImage or GflAx is installed.
					<br><br>
					Alternate View images are not processed.
					<br><br>
					Make sure the directories from which images are being copied has rights setup so that the IUSR_computername
					account has MODIFY rights.
					<br><br>
					<form name='AddImages' action='Images.asp' method='post'>
					<%
					aVariables(0) = "sAction"
					aValues(0) = "AddImages"
					Response.Write DOMAIN_Link("P")
					%>
					<table width=671 cellpadding = 1 cellspacing = 0 border = 0><tr><td bgcolor='<%=DOMAIN_Color("DomainsBorderColor1")%>'>
					<table cellpadding = 5 cellspacing=0 border=0 width=671>
						<tr>
							<td bgcolor='<%=DOMAIN_Color("DomainsPageBGColor")%>'>
								Directory to search for files (eg. c:\test\):<bR>
								<input type='text' name='sDirectory' value="<%=Server.HTMLEncode(sDirectory)%>" size=80 maxlength=255>
							</td>
						</tr>
						<tr>
							<td bgcolor='<%=DOMAIN_Color("DomainsPageBGColor")%>'>
								Optional Rights level for the categories that are created:<br>
								<select name = "sRightsLvl">
									<%
									Set rsDB = CreateObject("ADODB.Recordset")
									sSQLText = "SELECT * FROM RightsLookup (NOLOCK) WHERE DomainUnq = " & iDomainName & "  ORDER BY SystemUnq, RightsLvl"
									rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
									Response.Write "<option value = ''>" & DOMAIN_Text("ACCOUNTS_ADV_NORIGHTSLVL") & "</option>"
									While NOT rsDB.EOF
										If ( Len (rsDB("RightsConst")) > 60 ) Then
											sTemp = Left(rsDB("RightsConst"), 57) & "..."
										Else
											sTemp = rsDB("RightsConst")
										End If
										If ( sRightsLvl = CStr(rsDB("RightsLvl")) ) Then
											Response.Write "<option value = """ & Server.HTMLEncode(Trim(rsDB("RightsLvl"))) & """ Selected>" & rsDB("RightsLvl") & " - " & sTemp & "</option>"
										Else
											Response.Write "<option value = """ & Server.HTMLEncode(Trim(rsDB("RightsLvl"))) & """>" & rsDB("RightsLvl") & " - " & sTemp & "</option>"
										End If
										rsDB.MoveNext
									Wend
									rsDB.Close
									Set rsDB = Nothing
									%>
								</select>
							</td>
						</tr>
						<tr>
							<td bgcolor='<%=DOMAIN_Color("DomainsPageBGColor")%>'>
								Would you like to mirror the categories and galleries in the message boards?<bR>
								Yes! <input type='checkbox' name='sMirrorMB' value='Y'>
							</td>
						</tr>
					</table>
					</td></tr></table>
					<center>
					<input type='submit' value='Add Images'>
					</form>
				</td>
			</tr>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
		</table>
		<%
	End Sub
	'************************************************************************************
%>