<!--#INCLUDE FILE="../Includes/i_ImageGallery.asp"-->
<%
	Response.Buffer = TRUE
	Dim sSQLText, rsDB, sGroupUnq
	
	Call DISP_Action("SB_GALLERIES_ADMINOPEN")
	Call DISP_Action("SB_GALLERIES_PRIVATEGALLERIES_GROUPS")
	Call Main()
	Call DISP_Action("SB_GALLERIES_ADMINCLOSE")
	Response.Flush
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub Main()
		Dim sAction, sOldViewable, sViewable
		Dim sRadio, sError, sSuccess
	
		Set rsDB = CreateObject("ADODB.Recordset")
		Set rsGallery = CreateObject("ADODB.Recordset")
		sGroupUnq = Trim(Request("sGroupUnq"))
		sAction = Request("sAction")
		iGalleryUnq = Trim(Request("iGalleryUnq"))
		If ( iGalleryUnq = "" ) Then
			iGalleryUnq = "-1"
			sSQLText = "SET ROWCOUNT 1 SELECT GalleryUnq, Name FROM Galleries (NOLOCK) WHERE Domain = " & iDomainName & " ORDER BY Name SET ROWCOUNT 0"
			rsGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsGallery.EOF ) Then
				Do While ( NOT rsGallery.EOF )
					' make sure the current user has rights to admin whichever gallery we assign the galleryunq)
					iGalleryUnq = rsGallery("GalleryUnq")
					If ( RightsToGallery(iGalleryUnq) = TRUE ) Then
						Exit Do
					End If
					rsGallery.MoveNext
				Loop
			End If
			rsGallery.Close
		End If
		
		' Pagination variables -- begin
		iNumPerPage = 40
		iTtlNumItems = CDbl(Request("iTtlNumItems"))
		If IsNull(Request("iDBLoc")) Or Trim(Request("iDBLoc"))="" Then
			iDBLoc = 0
		Else
			iDBLoc = CDbl(Request("iDBLoc"))
			If (iDBLoc<0) Then
				iDBLoc = 0
			End If
		End If

		' Get ttl num of items from the database if it's not already in the QueryString
		if (iTtlNumItems = 0) then
			sSQLText = "SELECT COUNT(*) FROM Groups (NOLOCK) WHERE DomainUnq = " & iDomainName
			rsDB.Open sSQLText, DBConnection
			If Not(rsDB.EOF) Then
				iTtlNumItems = rsDB(0)
			End If
			rsDB.Close
		end if
		' Pagination variables -- end
		
		sError = ""
		sSuccess = ""
		Select Case sAction
			Case "UpdateGalleryUnq"
				iDBLoc = 0
			Case "SetGroups"
				If ( iGalleryUnq <> "-1" ) Then
					If ( RightsToGallery(iGalleryUnq) = TRUE ) Then	' make sure they have rights to edit this gallery - this is probably overkill
			            For Each sRadio In Request.Form
			            	If ( InStr(sRadio, "sGroupUnq") > 0 ) Then
			            		sGroupUnq = Trim(Request(sRadio))
								sOldViewable = Trim(Request("sOldViewable" & sGroupUnq))
								sViewable = Trim(Request("sViewable" & sGroupUnq))
								If ( sOldViewable <> sViewable ) Then
									' delete it regardless, in case they already submitted the form
									DBConnection.Execute "DELETE FROM PrivateGroups WHERE GroupUnq = " & sGroupUnq & " AND GalleryUnq = " & iGalleryUnq
									If ( sViewable = "Y" ) Then
										DBConnection.Execute "INSERT INTO PrivateGroups VALUES (" & iGalleryUnq & ", " & sGroupUnq & ")"
									End If
									If ( sSuccess = "" ) Then
										sSuccess = "T"
										Call DOMAIN_Message(DOMAIN_Text("GALLERIES_MANAGE_GROUPS_SUCCESS"), "SUCCESS")
									End If
								End If
			            	End If
			            Next
					End If
				End If
		End Select
		
		If ( iGalleryUnq <> "-1" ) Then	' so if there are no galleries, nothing is displayed
			Call WriteForm()
		Else
			Call DOMAIN_Message(DOMAIN_Text("GALLERIES_MANAGE_GROUPS_CREATEFIRST"), "ERROR")
		End If
		Set rsDB = Nothing
		Set rsGallery = Nothing
	End Sub
	'************************************************************************************

	
	'************************************************************************************
	'*																					*
	'*	This is the function to write out the form.										*
	'*																					*
	'************************************************************************************
	Sub WriteForm()
		Dim sBGColor, x, iMax, sGroupName, sType, sDesc
		Dim rsGallery2, bCanView, bYesGroup, iTempGalleryUnq, bTemp
		
		sSQLText = "SET ROWCOUNT " & (CDbl(iDBLoc) + CDbl(iNumPerPage)) & " SELECT GroupUnq, Name, Description, Type FROM Groups (NOLOCK) WHERE DomainUnq = " & iDomainName & " ORDER BY NAME SET ROWCOUNT 0"
		Set rsDB = CreateObject("ADODB.Recordset")
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		sBGColor = DOMAIN_Color("GalleriesBGColor2")
		For x = 1 To CDbl(iDBLoc)
			rsDB.MoveNext
		Next
		iMax = iNumPerPage
		%>
		<script language='JavaScript1.2' type='text/javascript'>
	
			function SubmitForm(sAction){
				document.ManagePrivateGalleries.sAction.value = sAction;
				document.ManagePrivateGalleries.submit();
			}
			
		</script>
		<form name='ManagePrivateGalleries' action='Groups.asp' method='post'>
		<%
		aVariables(0) = "sAction"
		aVariables(1) = "iTtlNumItems"
		aVariables(2) = "iDBLoc"
		aValues(0) = "New"
		aValues(1) = iTtlNumItems
		aValues(2) = iDBLoc
		Response.Write DOMAIN_Link("P")
		
		Call DOMAIN_Link_Clear()
		%>
		<table cellpadding=0 cellspacing=0 border=0 width=671>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
			<tr>
				<td>
					<font color='<%=DOMAIN_Color("GalleriesPageText")%>'>
					<font size=+1><b><%=DOMAIN_Text("GALLERIES_MANAGE_GROUPS_HEAD")%></b></font>
					<br>
					<font color='<%=DOMAIN_Color("GalleriesPageText")%>'>
					Individual user rights to view galleries override these Group rights.
					<br><Br>
					This means that if a user is in a Group that doesn't have rights
					to view a gallery, but that individual has been given the right
					on the "Manage Private Galleries - Users" page, then that user
					can view the gallery. The same holds for when the "Gallery images are viewable by all users"
					radio button has been set.
					<br><br>
					<table cellpadding=2 cellspacing=0 border=0 width=671>
						<tr>
							<td>
								<font color='<%=DOMAIN_Color("GalleriesPageText")%>'>
								<%=DOMAIN_Text("GALLERIES_MANAGE_GROUPS_IG")%>: 
								<%
								Response.Write "<select name='iGalleryUnq' onChange='SubmitForm(""UpdateGalleryUnq"");'>"
									sSQLText = "SELECT GalleryUnq, Name FROM Galleries (NOLOCK) WHERE Domain = " & iDomainName & " ORDER BY Name"
									rsGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
									If ( NOT rsGallery.EOF ) Then
										bTemp = FALSE
										While ( NOT rsGallery.EOF )
											iTempGalleryUnq = rsGallery("GalleryUnq")
											If ( RightsToGallery(iTempGalleryUnq) = TRUE ) Then
												bTemp = TRUE
												If ( Trim(CStr(iGalleryUnq)) = Trim(CStr(iTempGalleryUnq)) ) Then
													Response.Write "<option value='" & iTempGalleryUnq & "' Selected>" & rsGallery("Name") & "</option>"
												Else
													Response.Write "<option value='" & iTempGalleryUnq & "'>" & rsGallery("Name") & "</option>"
												End If
											End If
											rsGallery.MoveNext
										Wend
										If ( bTemp = FALSE ) Then
											Response.Write "<option value=''>" & DOMAIN_Text("GALLERIES_MANAGE_NO_GAL") & "</option>"
										End If
									Else
										Response.Write "<option value=''>" & DOMAIN_Text("GALLERIES_MANAGE_NO_GAL") & "</option>"
									End If
									rsGallery.Close
								Response.Write "</select>"
								%>
							</td>
						</tr>
					</table>
					<br><br>
					<table cellpadding=0 cellspacing=0 border=0 width=671>
						<tr>
							<td bgcolor=<%=sBGColor%>><img src='/WS_Content/Images/Blank.gif' Width=5 Height=15><font color='<%=DOMAIN_Color("GalleriesTextColor2")%>'><b><%=DOMAIN_Text("GALLERIES_MANAGE_GROUPS_NAME")%></b></td>
							<td bgcolor=<%=sBGColor%>><img src='/WS_Content/Images/Blank.gif' Width=5 Height=15><font color='<%=DOMAIN_Color("GalleriesTextColor2")%>'><b><%=DOMAIN_Text("GALLERIES_MANAGE_GROUPS_DESC")%></b></td>
							<td bgcolor=<%=sBGColor%> align=center><img src='/WS_Content/Images/Blank.gif' Width=5 Height=15><font color='<%=DOMAIN_Color("GalleriesTextColor2")%>'><b><%=DOMAIN_Text("GALLERIES_MANAGE_GROUPS_TYPE")%></b></td>
							<td bgcolor=<%=sBGColor%> align=center><font color='<%=DOMAIN_Color("GalleriesTextColor2")%>'><b><%=DOMAIN_Text("GALLERIES_MANAGE_GROUPS_CANSEE")%></b></td>
						</tr>
						<tr><td colspan=4 bgcolor=<%=sBGColor%>><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
						<%
						Set rsGallery2 = CreateObject("ADODB.Recordset")
						While ( NOT rsDB.EOF )
							If ( sBGColor = DOMAIN_Color("GalleriesBGColor1") ) Then
								sBGColor = DOMAIN_Color("GalleriesPageBGColor")
							Else
								sBGColor = DOMAIN_Color("GalleriesBGColor1")
							End If
							sGroupName = Replace(rsDB("Name"), "'", "&#39;")
							sDesc = Replace(rsDB("Description"), "'", "&#39;")
							sGroupUnq = rsDB("GroupUnq")
							sType = Replace(rsDB("Type"), "'", "&#39;")
				
							sSQLText = "SELECT * FROM PrivateGroups (NOLOCK) WHERE GroupUnq = " & sGroupUnq & " AND GalleryUnq = " & iGalleryUnq
							rsGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
							If ( NOT rsGallery.EOF ) Then
								bCanView = TRUE
							Else
								bCanView = FALSE
							End If
							rsGallery.Close
							%>
							<tr><td colspan=4 bgcolor=<%=sBGColor%>><img src='/WS_Content/Images/Blank.gif' Width=1 Height=2></td></tr>
							<tr>
								<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("GalleriesTextColor1")%>'><%=sGroupName%></td>
								<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("GalleriesTextColor1")%>'><%=sDesc%></td>
								<td bgcolor=<%=sBGColor%> align=center><img src='/WS_Content/Images/Blank.gif' Width=5 Height=5><font color='<%=DOMAIN_Color("GalleriesTextColor1")%>'><%=sType%></td>
								<td bgcolor=<%=sBGColor%> align=center>
									<%=DOMAIN_Text("GALLERIES_MANAGE_YES")%> <input type='radio' name='sViewable<%=sGroupUnq%>' value='Y'<%If ( bCanView = TRUE ) Then Response.Write " checked" End If%>>
									<img src='/WS_Content/Images/Blank.gif' Width=15 Height=10>
									<%=DOMAIN_Text("GALLERIES_MANAGE_NO")%> <input type='radio' name='sViewable<%=sGroupUnq%>' value='N'<%If ( bCanView <> TRUE ) Then Response.Write " checked" End If%>>
									<input type='hidden' name='sOldViewable<%=sGroupUnq%>' value='<%If ( bCanView = TRUE ) Then Response.Write "Y" Else Response.Write "N" End If%>'>
									<input type='hidden' name='sGroupUnq<%=sGroupUnq%>' value='<%=sGroupUnq%>'>
								</td>
							</tr>
							<tr><td colspan=4 bgcolor=<%=sBGColor%>><img src='/WS_Content/Images/Blank.gif' Width=1 Height=2></td></tr>
							<%
							rsDB.MoveNext
						Wend
						Set rsGallery2 = Nothing
						%>
						<tr>
							<td colspan=4 align=right>
								<%Call PrintRecordsetNav( iNumPerPage, "DBConnection", "Accounts", "", "Default.asp", "iGalleryUnq=" & iGalleryUnq )%>
							</td>
						</tr>
					</table>
				</td>
			</tr>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
		</table>
		</form>
		<%
		rsDB.Close
	End Sub
	'********************************************************************************

	
	'********************************************************************************
	'*																				*
	'*	Returns TRUE if the current user has rights to change the users who can		*
	'*		view this galleries images.												*
	'*																				*
	'********************************************************************************
	Function RightsToGallery(iTempGalleryUnq)
	
		Dim rsGallery2
	
		RightsToGallery = FALSE
		If ( ACCNT_SpecificDomain("SB_IG_ADMIN_ALL", iDomainName) ) Then
			RightsToGallery = TRUE
		Else
			If ( bHasAccount ) Then
				Set rsGallery2 = CreateObject("ADODB.Recordset")
				sSQLText = "SELECT AccountUnq FROM Galleries (NOLOCK) Where Domain = " & iDomainName & " AND AccountUnq = " & iLoginAccountUnq & " AND GalleryUnq = " & iTempGalleryUnq
				rsGallery2.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
				If ( NOT rsGallery2.EOF ) Then
					RightsToGallery = TRUE
				Else
					RightsToGallery = FALSE
				End If
				rsGallery2.Close
				Set rsGallery2 = Nothing
			Else
				RightsToGallery = FALSE
			End If
		End If
	
	End Function
	'********************************************************************************

	
	'********************************************************************************
	'*																				*
	'*	iNumPerPage is the number of items to display on each page					*
	'*	sURL is the page to put with the link, sQuerystring is additional qs stuff	*
	'*	adodbConnection, adodbCommand, sTable are all for the table to get the		*
	'*		row count from.															*
	'*																				*
	'*	Print out the numbers (if any) between the "previous" and "next" buttons	*
	'*	It'll act like this (current # is in bold):									*
	'*	1 2 3 4 5 6 7 8 9 <b>10</b> >> next											*
	'*	previous << <b>11</b> 12 13 14 15 16 17 18									*
	'*																				*
	'********************************************************************************
	Sub PrintRecordsetNav( iNumPerPage, adodbConnection, sTable, sWhere, sURL, sQuerystring )

		Dim sSqlTemp, iTtlTemp
		Dim iDBLocTemp, sURLBeg, iA, iB, x, iTemp, rsObj

		iTtlTemp = iTtlNumItems \ iNumPerPage	' this is the number of numbers overall (use the "\" to return int)
		iDBLocTemp = iDBLoc \ iNumPerPage		' this is which number we are currently on (use the "\" to return int)
		
		If (sQuerystring <> "") Then
			sURLBeg = "<a href = """ & sURL & "?" & DOMAIN_Link("G") & "&" & sQuerystring & "&iTtlNumItems=" & iTtlNumItems & "&iDBLoc="
		Else
			sURLBeg = "<a href = """ & sURL & "?" & DOMAIN_Link("G") & "&iTtlNumItems=" & iTtlNumItems & "&iDBLoc="
		End If

		'***** BEGIN DISPLAY *****
		' Print the "Previous"
		if (iDBLoc <> 0) then
			Response.Write sURLBeg & (iDBLoc - iNumPerPage) & """ class='MediumNavPage'><span style=""text-decoration:none;""> &#8592; </span></a>&nbsp;&nbsp;"
		end if
		' Print the <<
		if (iDBLocTemp >= iNumPerPage) then
			Response.Write sURLBeg & (( iDBLocTemp \ iNumPerPage ) * iNumPerPage ^ 2) - (iNumPerPage * 9) & """  class='MediumNavPage'>&lt;&lt;</a>&nbsp;"
		end if

		' Print the numbers in between. Print them out in sets of 10.
		iA = ( iDBLocTemp \ iNumPerPage ) * iNumPerPage
		iB = ( iDBLocTemp \ iNumPerPage ) * iNumPerPage + iNumPerPage
		for x = iA to iB
			iTemp = (x * iNumPerPage)
			if (iTemp < iTtlNumItems) then	' takes care of extra numbers after the overall final number
				if (iDBLoc = iTemp) then
					Response.Write "&nbsp;<font color='" & DOMAIN_Color("GalleriesPageText") & "' size=+1>" & x+1 & "</font>"
				else
					Response.Write "&nbsp;" & sURLBeg & (x * iNumPerPage) & """  class='MediumNavPage'>" & x+1 & "</a>"
				end if
			else
				exit for
			end if
		next

		' Print the >>
		if (iTtlTemp > iDBLocTemp) then
			if ((iDBLocTemp + iNumPerPage) <= iTtlTemp) then
				Response.Write "&nbsp;" & sURLBeg & (( iDBLocTemp \ iNumPerPage ) * iNumPerPage + iNumPerPage ) * iNumPerPage & """  class='MediumNavPage'>&gt;&gt;</a>&nbsp;"
			end if
		end if
		' Print the "Next"
		if ((iDBLoc + iNumPerPage) < iTtlNumItems) then
			Response.Write "&nbsp;&nbsp;" & sURLBeg & (iDBLoc + iNumPerPage) & """  class='MediumNavPage'><span style=""text-decoration:none;""> &#8594; </span></a>"
		end if
		'***** END DISPLAY *****

	End Sub
	'********************************************************************************
%>
