<%
	'************************************************************************************
	'*																					*
	'*	Enters in the Accounting Data Variables (ADV).									*
	'*																					*
	'************************************************************************************
	Sub ADV()

		' Insert the actual ADV's
		' Insert each ADV into it's own group on this first domain - by making each of the last numbers unique
		' ADVs associated with uploading attachments to messages
		DBConnection.Execute "INSERT INTO AccountMap SELECT 'SB_IG_NUMUPLOAD_LASTDATE','V','Last date/time the user uploaded a file: ','N','N',DomainUnq,7,'',0 FROM DomainInfo"
		DBConnection.Execute "INSERT INTO AccountMap SELECT 'SB_IG_UPLOADTYPE','V','File types user can upload (seperate with space): ','N','N',DomainUnq,7,'',0 FROM DomainInfo"
		DBConnection.Execute "INSERT INTO AccountMap SELECT 'SB_IG_UPLOADBYTES','V','Max file size user can upload in bytes (-1 infinite): ','N','N',DomainUnq,7,'',0 FROM DomainInfo"
		DBConnection.Execute "INSERT INTO AccountMap SELECT 'SB_IG_TTLUPLOADABLE','V','Num bytes user allows to upload (-1 infinite): ','N','N',DomainUnq,7,'',0 FROM DomainInfo"
		DBConnection.Execute "INSERT INTO AccountMap SELECT 'SB_IG_TTLUPLOADED','V','Num bytes user has uploaded: ','N','N',DomainUnq,7,'',0 FROM DomainInfo"
		DBConnection.Execute "INSERT INTO AccountMap SELECT 'SB_IG_NUMALLOWED','V','Num files user is allowed to upload (-1 infinite): ','N','N',DomainUnq,7,'',0 FROM DomainInfo"
		DBConnection.Execute "INSERT INTO AccountMap SELECT 'SB_IG_NUMUPLOADED','V','Num files user has uploaded: ','N','N',DomainUnq,7,'',0 FROM DomainInfo"
		DBConnection.Execute "INSERT INTO AccountMap SELECT 'SB_IG_NUM_DL_DAY','V','Num files user is allowed to download each day (-1 infinite): ','N','N',DomainUnq,7,'',0 FROM DomainInfo"
		DBConnection.Execute "INSERT INTO AccountMap SELECT 'SB_IG_NUM_HAS_DL','V','Num files user has downloaded today: ','N','N',DomainUnq,7,'',0 FROM DomainInfo"
		DBConnection.Execute "INSERT INTO AccountMap SELECT 'SB_IG_DL_LASTDATE','V','Last date/time user downloaded an image: ','N','N',DomainUnq,7,'',0 FROM DomainInfo"
		DBConnection.Execute "INSERT INTO AccountMap SELECT 'SB_IG_MAXZIPSIZE','V','Num bytes .zip files can be when uploading in batch (-1 infinite): ','N','N',DomainUnq,7,'',0 FROM DomainInfo"
		DBConnection.Execute "INSERT INTO AccountMap SELECT 'SB_IG_NUM_GALLERIES','V','Num galleris user may create (-1 infinite): ','N','N',DomainUnq,7,'',0 FROM DomainInfo"
		
		DBConnection.Execute "INSERT INTO AccountData SELECT 'SB_IG_NUMUPLOAD_LASTDATE',AccountUnq,'','','PRIVATE', HomeDomain, 'T', GetDate() FROM Accounts"
		DBConnection.Execute "INSERT INTO AccountData SELECT 'SB_IG_UPLOADTYPE',AccountUnq,'gif jpg png txt zip bmp jpeg pdf doc','','PRIVATE', HomeDomain, 'T', GetDate() FROM Accounts"
		DBConnection.Execute "INSERT INTO AccountData SELECT 'SB_IG_UPLOADBYTES',AccountUnq,'250000','','PRIVATE', HomeDomain, 'T', GetDate() FROM Accounts"
		DBConnection.Execute "INSERT INTO AccountData SELECT 'SB_IG_TTLUPLOADABLE',AccountUnq,'10000000','','PRIVATE', HomeDomain, 'T', GetDate() FROM Accounts"
		DBConnection.Execute "INSERT INTO AccountData SELECT 'SB_IG_TTLUPLOADED',AccountUnq,'','','PRIVATE', HomeDomain, 'T', GetDate() FROM Accounts"
		DBConnection.Execute "INSERT INTO AccountData SELECT 'SB_IG_NUMALLOWED',AccountUnq,'-1','','PRIVATE', HomeDomain, 'T', GetDate() FROM Accounts"
		DBConnection.Execute "INSERT INTO AccountData SELECT 'SB_IG_NUMUPLOADED',AccountUnq,'','','PRIVATE', HomeDomain, 'T', GetDate() FROM Accounts"
		DBConnection.Execute "INSERT INTO AccountData SELECT 'SB_IG_NUM_DL_DAY',AccountUnq,'-1','','PRIVATE', HomeDomain, 'T', GetDate() FROM Accounts"
		DBConnection.Execute "INSERT INTO AccountData SELECT 'SB_IG_NUM_HAS_DL',AccountUnq,'','','PRIVATE', HomeDomain, 'T', GetDate() FROM Accounts"
		DBConnection.Execute "INSERT INTO AccountData SELECT 'SB_IG_DL_LASTDATE',AccountUnq,'','','PRIVATE', HomeDomain, 'T', GetDate() FROM Accounts"
		DBConnection.Execute "INSERT INTO AccountData SELECT 'SB_IG_MAXZIPSIZE',AccountUnq,'-1','','PRIVATE', HomeDomain, 'T', GetDate() FROM Accounts"
		DBConnection.Execute "INSERT INTO AccountData SELECT 'SB_IG_NUM_GALLERIES',AccountUnq,'-1','','PRIVATE', HomeDomain, 'T', GetDate() FROM Accounts"

	End Sub
	'************************************************************************************
%>