<%
	' *********************************************************************************************************************************************
	' * This displays the conferences.
	' ---------------------------------------------------------------------------------------------------------------------------------------------
	' * 	iStartConfUnq -- if this is 0 then display all conferences
	' * 		if it's not zero, then just display that conference and all it's children
	' * 	iAction = Tells what sort of action to take w/ the output.
	' *				1 = Display for web page viewing and admin
	' *				2 = String the ConfUnq's together in a comma-delimited format for use elsewhere.
	' *				3 = Display for Selecting in a multi-pick pick list AND displays all conferences - for creating CMB's
	' *********************************************************************************************************************************************
	Sub ListConferences(iStartConfUnq, iAction)
	
		Dim OC, OpenConf, sBreadCrumb, iModifier, sBgColor, sTemp, sqlText
		Dim rs1, rs2, rs3, rs4, rs5, rs6, rs7, rs8, rs9, rs10, rs11

		OC = Request("OC")
		' This adds the ConfUnq to the OpenConf session variable and makes it so it's children are displayed
		if OC = "O" then
			sTempConfUnq = DOMAIN_FixD(Request("iConfUnq"), 0)
			Session("OpenConf") = Session("OpenConf") & ":" & sTempConfUnq & ":"
		end if

		' This removes the ConfUnq from the OpenConf session variable and makes it so it doesn't display it's children
		if OC = "C" then
			sTempConfUnq = DOMAIN_FixD(Request("iConfUnq"), 0)
			Session("OpenConf") = Replace(Session("OpenConf"), ":" & sTempConfUnq & ":", "")
			Session("OpenConf") = Replace(Session("OpenConf"), "::::", "")
		end if
		
		OpenConf = Session("OpenConf")

		if iAction <> 2  then
			sBreadCrumb = ""
			if iStartConfUnq <> "0" then
				Response.Write "<a href = '" & sPath & "ViewConferences/Deafult.asp?" & DOMAIN_Link("G") & "&iConfUnq=0&iThreadUnq=" & iThreadUnq & "&iMsgUnq=" & iMsgUnq & "&iNumPerPage=" & iNumPerPage & "&iDisplayXDays=" & iDisplayXDays & "&iSortOrder=" & iSortOrder & "&bDisplayExpanded=" & bDisplayExpanded & "&sDisplay=" & sDisplay & "&sOpt=" & sOpt & "&sSortDate=" & sSortDate & "&sSortRating=" & sSortRating & "&sSortNumRead=" & sSortNumRead & "&sSortTopic=" & sSortTopic & "' class='MediumNavPage'>" & DOMAIN_Text("MSGBOARD_RETURNTOINDEX") & "</a> <img src = '" & sPath & "Images/ColorBased/" & iColorScheme & "/Arrow.gif'> "
			end if
			Call DisplayBreadCrumbs(sBreadCrumb, "", "", iStartConfUnq)
			Response.Write sBreadCrumb & "<br>"
		end if

		Set rs1 = Server.CreateObject("ADODB.recordset")
		Set rs2 = Server.CreateObject("ADODB.recordset")
		Set rs3 = Server.CreateObject("ADODB.recordset")
		Set rs4 = Server.CreateObject("ADODB.recordset")
		Set rs5 = Server.CreateObject("ADODB.recordset")
		Set rs6 = Server.CreateObject("ADODB.recordset")
		Set rs7 = Server.CreateObject("ADODB.recordset")
		Set rs8 = Server.CreateObject("ADODB.recordset")
		Set rs9 = Server.CreateObject("ADODB.recordset")
		Set rs10 = Server.CreateObject("ADODB.recordset")
		Set rs11 = Server.CreateObject("ADODB.recordset")
		
		iModifier = 0	' this is here because if we begin at any other conference other than 0, then we r printing out an extra level, so we need to pass that on to all the subsequent levels
		
		' If the iStartConfUnq <> 0 then print it out as the first conference
		if iStartConfUnq <> 0 then
			iModifier = 1
		end if
		
		if iAction = 1 then
			' only print out the table stuff if this is for displaying on the web
			%>
			<table width=<%=iTableWidth%> cellpadding = 1 cellspacing = 0 border = 0><tr><td bgcolor = <%=DOMAIN_Color("MsgBoardBorderColor1")%> align=center>
			<table cellpadding=5 width=<%=iTableWidth%> cellspacing = 0 border = 0>
				<tr>
					<td bgcolor = <%=DOMAIN_Color("MsgBoardBGColor2")%>><b><font color='<%=DOMAIN_Color("MsgBoardTextColor2")%>'>&nbsp;<b><%=DOMAIN_Text("MSGBOARD_LC_MB")%>&nbsp;</b></td>
					<td bgcolor = <%=DOMAIN_Color("MsgBoardBGColor2")%>><b><font color='<%=DOMAIN_Color("MsgBoardTextColor2")%>'><font size=-2>&nbsp;<b><%=DOMAIN_Text("MSGBOARD_LC_MSG")%>/<%=DOMAIN_Text("MSGBOARD_POSTS")%>&nbsp;</b></td>
					<td bgcolor = <%=DOMAIN_Color("MsgBoardBGColor2")%>><b><font color='<%=DOMAIN_Color("MsgBoardTextColor2")%>'><font size=-2>&nbsp;<b><%=DOMAIN_Text("MSGBOARD_LC_SUBBOARDS")%>&nbsp;</b></td>
					<td bgcolor = <%=DOMAIN_Color("MsgBoardBGColor2")%>><b><font color='<%=DOMAIN_Color("MsgBoardTextColor2")%>'><font size=-2>&nbsp;<b><%=DOMAIN_Text("MSGBOARD_LC_SUBMSG")%>&nbsp;</b></td>
				</tr>
			<%
		end if
		
		'------BEG STAGE 1 OF 1-----------
		sqlText = "SELECT * FROM Conference WHERE Parent = " & iStartConfUnq & " ORDER BY Name"
		DBCommand.CommandText = sqlText
		rs1.Open DBCommand
		if not rs1.EOF then
			while not rs1.EOF
				Call PrintIndividualCategory(1 + iModifier, rs1.Fields("Name"), rs1.Fields("NumThreads"), iAction, rs1.Fields("ConfUnq"), rs1.Fields("NumChildren"), iStartConfUnq, rs1.Fields("Description"), rs1.Fields("NumMessages"))
		'------END STAGE 1 OF 1-----------
				
			'------BEG STAGE 1 OF 2-----------
			sqlText = "SELECT * FROM Conference WHERE Parent = " & rs1.Fields("ConfUnq") & " ORDER BY Name"
			DBCommand.CommandText = sqlText
			rs2.Open DBCommand
			if not rs2.EOF and (InStr(OpenConf, ":" & rs1.Fields("ConfUnq") & ":") or iAction = 3) and iAction <> 1 then
				while not rs2.EOF
					Call PrintIndividualCategory(2 + iModifier, rs2.Fields("Name"), rs2.Fields("NumThreads"), iAction, rs2.Fields("ConfUnq"), rs2.Fields("NumChildren"), iStartConfUnq, rs2.Fields("Description"), rs2.Fields("NumMessages"))
			'------END STAGE 1 OF 2-----------
			
				'------BEG STAGE 1 OF 3-----------
				sqlText = "SELECT * FROM Conference WHERE Parent = " & rs2.Fields("ConfUnq") & " ORDER BY Name"
				DBCommand.CommandText = sqlText
				rs3.Open DBCommand
				if not rs3.EOF and (InStr(OpenConf, ":" & rs2.Fields("ConfUnq") & ":") or iAction = 3) then
					while not rs3.EOF
						Call PrintIndividualCategory(3 + iModifier, rs3.Fields("Name"), rs3.Fields("NumThreads"), iAction, rs3.Fields("ConfUnq"), rs3.Fields("NumChildren"), iStartConfUnq, rs3.Fields("Description"), rs3.Fields("NumMessages"))
				'------END STAGE 1 OF 3-----------

					'------BEG STAGE 1 OF 4-----------
					sqlText = "SELECT * FROM Conference WHERE Parent = " & rs3.Fields("ConfUnq") & " ORDER BY Name"
					DBCommand.CommandText = sqlText
					rs4.Open DBCommand
					if not rs4.EOF and (InStr(OpenConf, ":" & rs3.Fields("ConfUnq") & ":") or iAction = 3) then
						while not rs4.EOF
							Call PrintIndividualCategory(4 + iModifier, rs4.Fields("Name"), rs4.Fields("NumThreads"), iAction, rs4.Fields("ConfUnq"), rs4.Fields("NumChildren"), iStartConfUnq, rs4.Fields("Description"), rs4.Fields("NumMessages"))
					'------END STAGE 1 OF 4-----------
	
						'------BEG STAGE 1 OF 5-----------
						sqlText = "SELECT * FROM Conference WHERE Parent = " & rs4.Fields("ConfUnq") & " ORDER BY Name"
						DBCommand.CommandText = sqlText
						rs5.Open DBCommand
						if not rs5.EOF and (InStr(OpenConf, ":" & rs4.Fields("ConfUnq") & ":") or iAction = 3) then
							while not rs5.EOF
								Call PrintIndividualCategory(5 + iModifier, rs5.Fields("Name"), rs5.Fields("NumThreads"), iAction, rs5.Fields("ConfUnq"), rs5.Fields("NumChildren"), iStartConfUnq, rs5.Fields("Description"), rs5.Fields("NumMessages"))
						'------END STAGE 1 OF 5-----------
		
							'------BEG STAGE 1 OF 6-----------
							sqlText = "SELECT * FROM Conference WHERE Parent = " & rs5.Fields("ConfUnq") & " ORDER BY Name"
							DBCommand.CommandText = sqlText
							rs6.Open DBCommand
							if not rs6.EOF and (InStr(OpenConf, ":" & rs5.Fields("ConfUnq") & ":") or iAction = 3) then
								while not rs6.EOF
									Call PrintIndividualCategory(6 + iModifier, rs6.Fields("Name"), rs6.Fields("NumThreads"), iAction, rs6.Fields("ConfUnq"), rs6.Fields("NumChildren"), iStartConfUnq, rs6.Fields("Description"), rs6.Fields("NumMessages"))
							'------END STAGE 1 OF 6-----------
			
								'------BEG STAGE 1 OF 7-----------
								sqlText = "SELECT * FROM Conference WHERE Parent = " & rs6.Fields("ConfUnq") & " ORDER BY Name"
								DBCommand.CommandText = sqlText
								rs7.Open DBCommand
								if not rs7.EOF and (InStr(OpenConf, ":" & rs6.Fields("ConfUnq") & ":") or iAction = 3) then
									while not rs7.EOF
										Call PrintIndividualCategory(7 + iModifier, rs7.Fields("Name"), rs7.Fields("NumThreads"), iAction, rs7.Fields("ConfUnq"), rs7.Fields("NumChildren"), iStartConfUnq, rs7.Fields("Description"), rs7.Fields("NumMessages"))
								'------END STAGE 1 OF 7-----------
				
									'------BEG STAGE 1 OF 8-----------
									sqlText = "SELECT * FROM Conference WHERE Parent = " & rs7.Fields("ConfUnq") & " ORDER BY Name"
									DBCommand.CommandText = sqlText
									rs8.Open DBCommand
									if not rs8.EOF and (InStr(OpenConf, ":" & rs7.Fields("ConfUnq") & ":") or iAction = 3) then
										while not rs8.EOF
											Call PrintIndividualCategory(8 + iModifier, rs8.Fields("Name"), rs8.Fields("NumThreads"), iAction, rs8.Fields("ConfUnq"), rs8.Fields("NumChildren"), iStartConfUnq, rs8.Fields("Description"), rs8.Fields("NumMessages"))
									'------END STAGE 1 OF 8-----------
					
										'------BEG STAGE 1 OF 9-----------
										sqlText = "SELECT * FROM Conference WHERE Parent = " & rs8.Fields("ConfUnq") & " ORDER BY Name"
										DBCommand.CommandText = sqlText
										rs9.Open DBCommand
										if not rs9.EOF and (InStr(OpenConf, ":" & rs8.Fields("ConfUnq") & ":") or iAction = 3) then
											while not rs9.EOF
												Call PrintIndividualCategory(9 + iModifier, rs9.Fields("Name"), rs9.Fields("NumThreads"), iAction, rs9.Fields("ConfUnq"), rs9.Fields("NumChildren"), iStartConfUnq, rs9.Fields("Description"), rs9.Fields("NumMessages"))
										'------END STAGE 1 OF 9-----------
						
											'------BEG STAGE 1 OF 10-----------
											sqlText = "SELECT * FROM Conference WHERE Parent = " & rs9.Fields("ConfUnq") & " ORDER BY Name"
											DBCommand.CommandText = sqlText
											rs10.Open DBCommand
											if not rs10.EOF and (InStr(OpenConf, ":" & rs9.Fields("ConfUnq") & ":") or iAction = 3) then
												while not rs10.EOF
													Call PrintIndividualCategory(10 + iModifier, rs10.Fields("Name"), rs10.Fields("NumThreads"), iAction, rs10.Fields("ConfUnq"), rs10.Fields("NumChildren"), iStartConfUnq, rs10.Fields("Description"), rs10.Fields("NumMessages"))
											'------END STAGE 1 OF 10-----------
							
												sqlText = "SELECT * FROM Conference WHERE Parent = " & rs10.Fields("ConfUnq") & " ORDER BY Name"
												DBCommand.CommandText = sqlText
												rs11.Open DBCommand
												if not rs11.EOF and (InStr(OpenConf, ":" & rs10.Fields("ConfUnq") & ":") or iAction = 3) then
													while not rs11.EOF
														Call PrintIndividualCategory(11 + iModifier, rs11.Fields("Name"), rs11.Fields("NumThreads"), iAction, rs11.Fields("ConfUnq"), rs11.Fields("NumChildren"), iStartConfUnq, rs11.Fields("Description"), rs11.Fields("NumMessages"))
														rs11.MoveNext
													wend
												end if
												rs11.Close
							
											'------BEG STAGE 2 OF 10-----------
													rs10.MoveNext
												wend
											end if
											rs10.Close
											'------END STAGE 2 OF 10-----------
						
										'------BEG STAGE 2 OF 9-----------
												rs9.MoveNext
											wend
										end if
										rs9.Close
										'------END STAGE 2 OF 9-----------
					
									'------BEG STAGE 2 OF 8-----------
											rs8.MoveNext
										wend
									end if
									rs8.Close
									'------END STAGE 2 OF 8-----------
				
								'------BEG STAGE 2 OF 7-----------
										rs7.MoveNext
									wend
								end if
								rs7.Close
								'------END STAGE 2 OF 7-----------
			
							'------BEG STAGE 2 OF 6-----------
									rs6.MoveNext
								wend
							end if
							rs6.Close
							'------END STAGE 2 OF 6-----------
		
						'------BEG STAGE 2 OF 5-----------
								rs5.MoveNext
							wend
						end if
						rs5.Close
						'------END STAGE 2 OF 5-----------
	
					'------BEG STAGE 2 OF 4-----------
							rs4.MoveNext
						wend
					end if
					rs4.Close
					'------END STAGE 2 OF 4-----------

				'------BEG STAGE 2 OF 3-----------
						rs3.MoveNext
					wend
				end if
				rs3.Close
				'------END STAGE 2 OF 3-----------
			
			'------BEG STAGE 2 OF 2-----------
					rs2.MoveNext
				wend
			end if
			rs2.Close
			'------END STAGE 2 OF 2-----------
				
		'------BEG STAGE 2 OF 1-----------
				rs1.MoveNext
			wend
		end if
		rs1.Close
		'------END STAGE 2 OF 1-----------
		
		Set rs1 = nothing
		Set rs2 = nothing
		Set rs3 = nothing
		Set rs4 = nothing
		Set rs5 = nothing
		Set rs6 = nothing
		Set rs7 = nothing
		Set rs8 = nothing
		Set rs9 = nothing
		Set rs10 = nothing
		Set rs11 = nothing
		if iAction = 1 then
			' only print out the table stuff if this is for displaying on the web
			%>
			</table>
			</td></tr></table>
			<%
		end if
	
		if bHasAccount and iAction = 1 then
			Call ViewCMB()
		end if

	End Sub


	' *********************************************************************************************************************************************
	' * This displays the individual lines with the conference info on them.
	' ---------------------------------------------------------------------------------------------------------------------------------------------
	' * 	iLevel = the level the category is on
	' * 	sName = the name of the category
	' * 	iNumThreads = the number of threads in the category
	' * 	iAction = Tells what sort of action to take w/ the output.
	' *				0 = Display for Selecting in a multi-pick pick list
	' *				1 = Display for web page viewing and admin
	' *				2 = String the ConfUnq's together in a comma-delimited format for use elsewhere. (saves to the sConfUnqList)
	' *				3 = Display for Selecting in a multi-pick pick list - displays all the conferences for creating CMB's
	' * 	iConfUnq = this is used whenever the confunq is needed (to know what conf to add/edit/delete/moderate or "open" or "close")
	' *		iNumChildren = the number of children this conference has (includes all children and their children)
	' *		sDescription = the description of the conference
	' *********************************************************************************************************************************************
	Sub PrintIndividualCategory(iLevel, sName, iNumThreads, iAction, iConfUnq, iNumChildren, iStartConfUnq, sDescription, sNumMessages)
	
		Dim sCurPage, sConfText, sNumThreads, sConfNumThreads, sNumChildren, sTemp, sTemp1, PICrs, sqlText
	
		select case iAction
			Case 1
				' Print it out for the webpage
				
				sCurPage = Request.ServerVariables("SCRIPT_NAME")
				if iNumChildren = 0 then
					' This is the bottom level, so now it's messages and threads.
					' Check their settings to see if they want to view the threads collapsed or expanded
					sConfText = "<a href = '" & sPath & "ViewMessages/Default.asp?" & DOMAIN_Link("G") & "&sAction=1&iConfUnq=" & iConfUnq & "&iThreadUnq=" & iThreadUnq & "&iMsgUnq=" & iMsgUnq & "&iNumPerPage=" & iNumPerPage & "&iDisplayXDays=" & iDisplayXDays & "&iSortOrder=" & iSortOrder & "&bDisplayExpanded=" & bDisplayExpanded & "&sDisplay=" & sDisplay & "&sOpt=" & sOpt & "&sSortDate=" & sSortDate & "&sSortRating=" & sSortRating & "&sSortNumRead=" & sSortNumRead & "&sSortTopic=" & sSortTopic & "' class='MediumNav1'>" & sName & "</a><br>&nbsp;" & sDescription
					sNumThreads = ""
					sConfNumThreads = CStr(iNumThreads)
				else
					sConfText = "<a href = '" & sPath & "ViewMessages/Default.asp?" & DOMAIN_Link("G") & "&sAction=1&iConfUnq=" & iConfUnq & "&iThreadUnq=" & iThreadUnq & "&iMsgUnq=" & iMsgUnq & "&iNumPerPage=" & iNumPerPage & "&iDisplayXDays=" & iDisplayXDays & "&iSortOrder=" & iSortOrder & "&bDisplayExpanded=" & bDisplayExpanded & "&sDisplay=" & sDisplay & "&sOpt=" & sOpt & "&sSortDate=" & sSortDate & "&sSortRating=" & sSortRating & "&sSortNumRead=" & sSortNumRead & "&sSortTopic=" & sSortTopic & "' class='MediumNav1'>" & sName & "</a><br>&nbsp;" & sDescription
					sNumChildren = iNumChildren & "&nbsp;-&nbsp;<a href = '" & sCurPage & "?" & DOMAIN_Link("G") & "&sAction=" & sAction & "&iConfUnq=" & iConfUnq & "&iThreadUnq=" & iThreadUnq & "&iMsgUnq=" & iMsgUnq & "&iNumPerPage=" & iNumPerPage & "&iDisplayXDays=" & iDisplayXDays & "&iSortOrder=" & iSortOrder & "&bDisplayExpanded=" & bDisplayExpanded & "&sDisplay=" & sDisplay & "&sOpt=" & sOpt & "&sSortDate=" & sSortDate & "&sSortRating=" & sSortRating & "&sSortNumRead=" & sSortNumRead & "&sSortTopic=" & sSortTopic & "' class='MediumNav1'>View</a>&nbsp;"
					' Get the number of threads just in this conference
					Set PICrs = Server.CreateObject("ADODB.recordset")
					sqlText = "SELECT Count(*) FROM Thread A, Message B WHERE A.Confunq = " & iConfUnq & " and A.ThreadUnq = B.ThreadUnq"
					DBCommand.CommandText = sqlText
					PICrs.Open DBCommand
					if not PICrs.EOF then
						sConfNumThreads = CStr(PICrs.Fields(0))
					else
						sConfNumThreads = "0"
					end if
					PICrs.Close

					sqlText = "SELECT Count(*) FROM Thread A, Message B, Conference C WHERE A.Confunq = C.ConfUnq AND C.Parent = " & iConfUnq & " and A.ThreadUnq = B.ThreadUnq"
					DBCommand.CommandText = sqlText
					PICrs.Open DBCommand
					if not PICrs.EOF then
						sNumThreads = PICrs.Fields(0)
					end if
					PICrs.Close
					Set PICrs = nothing
					
				end if
				%>
				<tr>
					<td bgcolor=<%=DOMAIN_Color("MsgBoardBGColor1")%> valign=top><font color='<%=DOMAIN_Color("MsgBoardTextColor1")%>'>&nbsp;<%=sConfText%>&nbsp;</td>
					<td bgcolor=<%=DOMAIN_Color("MsgBoardBGColor1")%> valign=top><font color='<%=DOMAIN_Color("MsgBoardTextColor1")%>'><center>&nbsp;<%=sConfNumThreads%>/<%=sNumMessages%>&nbsp;</td>
					<td bgcolor=<%=DOMAIN_Color("MsgBoardBGColor1")%> valign=top><font color='<%=DOMAIN_Color("MsgBoardTextColor1")%>'>&nbsp;<%=sNumChildren%>&nbsp;</td>
					<td bgcolor=<%=DOMAIN_Color("MsgBoardBGColor1")%> valign=top><font color='<%=DOMAIN_Color("MsgBoardTextColor1")%>'>&nbsp;<%=sNumThreads%>&nbsp;</td>
				</tr>
				<%
				
			Case 2
				' Just string it together in a global variable
				' This is so it can tell which conferences are the bottom level ones w/o having to re-check (just look for "x" as 1st char)
				if iNumChildren = 0 then
					sTemp = "x"
				end if
				if sConfUnqList = "" then
					sConfUnqList = sTemp & iConfUnq
				else
					sConfUnqList = sConfUnqList & "," & sTemp & iConfUnq
				end if
			Case 3
				' Print it out for the select form
				' With ALL conferences for CMB's. (Remember that they can add messages to any level conference)
				if iNumChildren = 0 then
					sTemp = "x"
					sName = sName
				end if
				
				if len(sName) >= 30 then
					sName = left(sName, 27) & "..."
				end if
			
				Response.Write "<option value = """ & sTemp & iConfUnq & """"
				if Session("iConfUnq") = iConfUnq then Response.Write " selected" end if
				Response.Write ">"

				for x = 1 to iLevel - 1
					Response.Write "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
				next

				Response.Write sName & "</option>" & VbCrlf

		end select
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This displays all the top-level conferences for use in the drop-down list.		*
	'*																					*
	'************************************************************************************
	Sub ListConferences_DropDown(iStartConfUnq)
	
		Dim sSQLText, rsMsgBoard, sName, sAccess
		
		Set rsMsgBoard = Server.CreateObject("ADODB.recordset")

		sSQLText = "SELECT * FROM Conference (NOLOCK) WHERE DomainUnq = " & iDomainName & " AND Parent = " & iStartConfUnq & " ORDER BY Name"
'response.write sSQLText
		DBCommand.CommandText = sSQLText
		rsMsgBoard.Open DBCommand
		if ( NOT rsMsgBoard.EOF ) then
			While ( NOT rsMsgBoard.EOF )
				sAccess = GetBoardAccess(rsMsgBoard("ConfUnq"))
				If ( sAccess = "V" ) Or ( sAccess = "CV" ) Then
					sName = rsMsgBoard("Name")
					if len(sName) >= 30 then
						sName = left(rsMsgBoard("Name"), 27) & "..."
					end if
					%><option value='<%=rsMsgBoard("ConfUnq")%>' <%if Session("iConfUnq") = rsMsgBoard("ConfUnq") then Response.Write " selected" end if%>><%=sName%></option><%
				End If
				rsMsgBoard.MoveNext
			Wend
		end if
		rsMsgBoard.Close
		
		Set rsMsgBoard = nothing
	End Sub
	'************************************************************************************
%>
