<%

	REM *********************************************************************************************************************************************
	REM * This displays the CMB's and possibly links to edit them.
	REM ---------------------------------------------------------------------------------------------------------------------------------------------
	REM * 	bEdit - if it's true then display stuff to edit it. if false, display links to view the conferences's threads.
	REM *********************************************************************************************************************************************
	Sub DisplayCMB(bEdit)
		
		Dim rs1
		Dim sqlText
	
		REM See if they have any existing CMB's and display them if they do
		Set rs1 = Server.CreateObject("ADODB.recordset")
		sqlText = "SELECT B.ConfUnq, B.MBSetID, A.CMBName FROM CMB A, CMBSets B WHERE A.MBSetID = B.MBSetID AND A.AccountUnq = " & iLoginAccountUnq & " ORDER BY B.MBSetID"
		DBCommand.CommandText = sqlText
		rs1.Open DBCommand
		if not rs1.EOF then
			if bEdit then
				Response.Write "<b>Existing CMB's</b><br>"
			else
				Response.Write "<br><b>Personal Combined Message Boards (CMB's)</b><ol>"
			end if
			REM This person has some CMB's
			iCurConfUnq = rs1.Fields("MBSetID")
			while not rs1.EOF
				bEnd = false
				REM No editing of CMB's because its a pain. Because the display of the conferences is re-used code, to change the re-used code to
				REM	select whatever conferences they already have in their CMB is not worth it. Just make them delete and recreate it if they need to.
				if bEdit then
					Response.Write "<table border=0 cellpadding=0 cellspacing=0><TR><td bgcolor=""#000000""><table border=0 cellpadding=4 border=0 cellspacing=1><tr><td bgcolor = ffffff>"
					Response.Write "<b>" & rs1.Fields("CMBName") & "</b><BR>"
					Response.Write "<a href = 'ModifyCMB.asp?sAction=2&MBSetID=" & rs1.Fields("MBSetID") & "'>Delete the """ & rs1.Fields("CMBName") & """ CMB</a><br>"
					Response.Write "</td></tr><tr><td bgcolor = ffffff>Message Boards in the """ & rs1.Fields("CMBName") & """ CMB:<br>"
				else
					Response.Write "<li><a href = ""Messages.asp?sAction=1&ConfUnq=CMB" & rs1.Fields("MBSetID") & """>" & rs1.Fields("CMBName") & "</a>"
				end if
				while not rs1.EOF and bEnd = false
					if iCurConfUnq = rs1.Fields("MBSetID") then
						if bEdit then
							REM Display the breadcrumbs.
							sBreadCrumb = ""
							Call DisplayBreadCrumbs(sBreadCrumb, "", "", rs1.Fields("ConfUnq"))
							Response.Write sBreadCrumb & ":<bR>"
						end if
						rs1.MoveNext
					else
						bEnd = true
					end if
				wend
				if bEdit then
					Response.Write "</td></tr></table></td></tr></table>"
				end if
			
				Response.Write "<BR>"
				if not rs1.EOF then
					iCurConfUnq = rs1.Fields("MBSetID")
				end if
			wend
			if not bEdit then
				Response.Write "</ol>"
			end if
		end if
		rs1.Close
		Set rs1 = nothing
		
	End Sub


	REM *********************************************************************************************************************************************
	REM * This deletes a CMB that's passed to it and displays the page asking if they are sure.
	REM ---------------------------------------------------------------------------------------------------------------------------------------------
	REM *		sCMBAction - if it's blank then it'll display the confirmation, otherwise it'll try and do the deletion
	REM *		MBSetID - this is the CMB they are considering to delete
	REM *********************************************************************************************************************************************
	Sub DeleteCMB(sCMBAction, MBSetID)
		if sCMBAction <> "" then
			REM Test the data coming from the form and see if it's ok.
			DBConnection.Execute "DELETE FROM CMB WHERE MBSetID = " & MBSetID & " AND AccountUnq = " & iLoginAccountUnq
			DBConnection.Execute "DELETE FROM CMBSets WHERE MBSetID = " & MBSetID
			Response.Write "CMB Removed successfully."
		end if
		
		if sCMBAction = "" then
			REM Display the confirmation
			Response.Write "Are you sure you want to delete this CMB?<br>"
			Set rs1 = Server.CreateObject("ADODB.recordset")
			sqlText = "SELECT ConfUnq FROM CMBSets WHERE MBSetID = " & MBSetID
			DBCommand.CommandText = sqlText
			rs1.Open DBCommand
			while not rs1.EOF
				sBreadCrumb = ""
				Call DisplayBreadCrumbs(sBreadCrumb, "", "", rs1.Fields("ConfUnq"))
				Response.Write sBreadCrumb & "<bR>"
				rs1.MoveNext
			wend
			rs1.Close
			Set rs1 = nothing
			Response.Write "<form action = ""ModifyCMB.asp?" & DOMAIN_Link("G") & """>"
			Response.Write "<input type = ""hidden"" value = ""2"" name = ""sAction"">"
			Response.Write "<input type = ""hidden"" value = ""1"" name = ""sCMBAction"">"
			Response.Write "<input type = ""hidden"" value = """ & MBSetID & """ name = ""MBSetID"">"
			Response.Write "<input type = ""submit"" value = ""Yes"">"
			Response.Write "</form>"
		end if
	End Sub



	REM *********************************************************************************************************************************************
	REM * This adds CMB's. It lets them pick the conferences and name the CMB. It only lets them combinations that don't
	REM * already exist.
	REM ---------------------------------------------------------------------------------------------------------------------------------------------
	REM *		sCMBAction - if it's blank then it'll display the form, otherwise it'll try and do the addition
	REM *********************************************************************************************************************************************
	Sub AddCMB(sCMBAction)
		if sCMBAction <> "" then
			REM Test the data coming from the form and if it's ok, enter it into the db else re-display the form to add
			sError = ""
			iTtlConf = 0	' count how many they have picked and only add those
			x = 0
			ReDim ConfUnqArray(20)
			ReDim MatchArray(20)
			
			if Request.Form("ConfUnq").Count <= 1 then
				sError = "Please select at least two Message Boards to combine to make your CMB.<br>"
			end if
			
			if Request("sCMBName") = "" then
				sError = sError + "Please enter a name for your CMB.<br>"
			end if
			
			if sError = "" then
				for each sTempConfUnq in Request.Form("ConfUnq")
					x = x + 1
					if x >= 20 then
						x = Request.Form("ConfUnq").Count + 1
						sError = sError + "The maximum number of Message Boards in one CMB is 20.<bR>"
					else
						if InStr(sTempConfUnq, "x") = 1 then
							REM It's a leaf conference, so remove the "x"
							iTtlConf = iTtlConf + 1
							ConfUnqArray(iTtlConf) = right(sTempConfUnq, len(sTempConfUnq) - 1)
							MatchArray(iTtlConf) = ConfUnqArray(iTtlConf)
						else
							iTtlConf = iTtlConf + 1
							ConfUnqArray(iTtlConf) = sTempConfUnq
							MatchArray(iTtlConf) = ConfUnqArray(iTtlConf)
						end if
					end if
				next
				
				if iTtlConf > 1 then
					REM now make sure that this combination doesn't already exist.
					Set rs1 = Server.CreateObject("ADODB.recordset")
					Set rs2 = Server.CreateObject("ADODB.recordset")
					bFoundMatch = false
					sqlText = "SELECT MBSetID FROM CMB WHERE AccountUnq = " & iLoginAccountUnq
					DBCommand.CommandText = sqlText
					rs1.Open DBCommand
					while not rs1.EOF and bFoundMatch = false
						sqlText = "SELECT ConfUnq FROM CMBSets WHERE MBSetID = " & rs1.Fields("MBSetID")
						DBCommand.CommandText = sqlText
						rs2.Open DBCommand
						while not rs2.EOF
							for x = 1 to iTtlConf
								if ConfUnqArray(x) = CStr(rs2.Fields("ConfUnq")) then
									MatchArray(x) = "m"
								end if
							next
							rs2.MoveNext
						wend
						rs2.Close
						iNumMatches = 0
						for x = 1 to iTtlConf
							if MatchArray(x) = "m" then
								iNumMatches = iNumMatches + 1
							end if
						next
						REM Make sure they have the same number of conferences, so it doesn't exclude subsets of existing CMB's
						sqlText = "SELECT Count(*) FROM CMBSets WHERE MBSetID = " & rs1.Fields("MBSetID")
						DBCommand.CommandText = sqlText
						rs2.Open DBCommand
						if iNumMatches = iTtlConf and rs2.Fields(0) = iTtlConf then
							REM the CMB's match.
							bFoundMatch = true
						else
							REM reset the MatchArray
							for x = 1 to iTtlConf
								MatchArray(x) = ConfUnqArray(x)
							next
						end if
						rs2.Close
						rs1.MoveNext
					wend
					rs1.Close
					Set rs2 = nothing

					if bFoundMatch = true then
						Response.Write "This combination already exists."
					else
						REM It's not there, so add it
						Set MsgBoardConnection2 = Server.CreateObject("ADODB.Connection")
						MsgBoardConnection2.Open "MsgBoard", "MsgBoardUser", "userMsgBoard"
						MsgBoardConnection2.Execute "INSERT INTO CMB VALUES (" & iLoginAccountUnq & ", '" & SQLEncode(Request("sCMBName")) & "')"
						sqlText = "SELECT @@IDENTITY"
						rs1.Open sqlText, MsgBoardConnection2
						if not rs1.EOF then
							for x = 1 to iTtlConf
								DBConnection.Execute "INSERT INTO CMBSets VALUES (" & rs1.Fields(0) & ", " & ConfUnqArray(x) & ")"
							next
							Response.Write "Your CMB has been successfully added."
						else
							Response.Write "Error adding your CMB to the CMB table."
						end if
						MsgBoardConnection2.Close
						Set MsgBoardConnection2 = nothing
					end if
					Set rs1 = nothing
				else
					REM no or only one conference picked
					Response.Write "You need to pick more than one Message Board."
				end if
			end if
			
			if sError <> "" then
				sCMBAction = ""
				Response.Write sError
				REM Make sure this combination is not already there and then add it
			end if
		end if

		if sCMBAction = "" then
			REM Display the form to add one
			%>
			<form action = "ModifyCMB.asp?<%=DOMAIN_Link("G")%>&sAction=1&sCMBAction=1" method = "post">
				CMB Name:
				<br>
				<input type = "text" name = "sCMBName" value = "<%=sCMBName%>" size = 50>
				<br><br>
				Conferences to add to your new CMB:
				<Br>
				<select name = "ConfUnq" size = 20 multiple>
					<%
					Call ListConferences(0, 3)
					%>
				</select>
				<br><br>
				<input type = "submit" value = "Add this combination">
			</form>
			<%
		end if
	End Sub

%>