<!--#INCLUDE FILE="../Includes/i_News.asp"-->
<%
	Response.Buffer = TRUE
	Dim iDomainUnq, rsNews, iNewsUnq

	iNewsUnq = Trim(Request("iNewsUnq"))
	
	Call DISP_Action("SB_NEWS_OPEN")
	Call DISP_Action("SB_NEWS_MANAGE_NEWS_RELATEDARTICLES")
	If ( iNewsUnq = "" ) Then
		Call DOMAIN_Message(DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_MISSINGNEWSUNQ"), "ERROR")
	Else
		If   (ACCNT_AnyDomain("SB_NEWS_ADMIN_EDITNEWS")) Then
			Call Main()
		Else
			If ( IsEditor() ) Then	
				' check to make sure this is their article
				If ( IsArticle() ) Then
					Call Main()
				Else
					Call DOMAIN_Message(DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_NOTURARTICLE"), "ERROR")
				End If
			Else
				Call DOMAIN_Message(DOMAIN_Text("NEWS_SYS_RIGHTS"), "ERROR")
			End If
		End If
	End If
	Call DISP_Action("SB_NEWS_CLOSE")
	Response.Flush
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub Main()
		Dim sAction, sSQLText, sError, sSuccess, sCheckbox, sTextField
		Dim sOffsiteURL, sOffsiteTitle, aRelatedNewsUnq
		Dim iIDUnq, sOldURL, sNewURL, sOldTitle, sNewTitle, x
		
		sAction = Trim(Request("sAction"))

		Set rsNews = Server.CreateObject("ADODB.recordset")

		Select Case sAction
			Case "AddOnsite"
				aRelatedNewsUnq = Split(Request("iRelatedNewsUnq"), ", ", -1, 1)
				If ( UBound(aRelatedNewsUnq) >= 0 ) Then
					for x = 0 to UBound(aRelatedNewsUnq)
						DBConnection.Execute "INSERT INTO RelatedArticles VALUES (" & iNewsUnq & ", " & aRelatedNewsUnq(x) & ", '', '')"
					next
				End If
			Case "DeleteOnsite"
				aRelatedNewsUnq = Split(Request("iRelatedNewsUnq"), ", ", -1, 1)
				If ( UBound(aRelatedNewsUnq) >= 0 ) Then
					for x = 0 to UBound(aRelatedNewsUnq)
						DBConnection.Execute "DELETE FROM RelatedArticles WHERE NewsUnq = " & iNewsUnq & " AND RelatedNewsUnq = " & aRelatedNewsUnq(x)
					next
				End If
			Case "AddOffsite"
				sOffsiteURL		= Trim(Request("sOffsiteURL"))
				sOffsiteTitle	= Trim(Request("sDescription"))
				If ( sOffsiteURL = "" ) Then
					sError = DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_ENTERURL")
				Else
					If ( sOffsiteTitle = "" ) Then
						sError = DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_ENTERDESC")
					Else
						DBConnection.Execute "INSERT INTO RelatedArticles VALUES (" & iNewsUnq & ", -1, '" & SQLEncode(sOffsiteURL) & "', '" & SQLEncode(sOffsiteTitle) & "')"
						sSuccess = DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_OFFSITEADDED")
					End If
				End If
			Case "UpdateOffsite"
				For Each sTextField In Request.Form
					If ( InStr(sTextField, "sOldURL") > 0 ) Then
						iIDUnq = Replace(sTextField, "sOldURL", "")
						sOldURL = Request(sTextField)
						sNewURL = Request("sNewURL" & iIDUnq)
						sOldTitle = Request("sOldTitle" & iIDUnq)
						sNewTitle = Request("sNewTitle" & iIDUnq)
						
						If ( sOldURL <> sNewURL Or sOldTitle <> sNewTitle ) Then
							DBConnection.Execute "UPDATE RelatedArticles SET OffsiteURL = '" & SQLEncode(sNewURL) & "', OffsiteTitle = '" & SQLEncode(sNewTitle) & "' WHERE IDUnq = " & iIDUnq
							If ( sSuccess = "" ) Then
								sSuccess = DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_OFFSITEUPDATED")
							End If
						End If
					ElseIf ( InStr(sTextField, "sDelete") > 0 ) Then
						iIDUnq = Replace(sTextField, "sDelete", "")
						DBConnection.Execute "DELETE FROM RelatedArticles WHERE IDUnq = " & iIDUnq
						If ( sSuccess = "" ) Then
							sSuccess = DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_OFFSITEUPDATED")
						End If
					End If
				Next
			Case "DeleteOffsite"
				For Each sCheckbox In Request.Form
					If ( InStr(sCheckbox, "sDelete") > 0 ) Then
						iIDUnq = Replace(sCheckbox, "sDelete", "")
						DBConnection.Execute "DELETE FROM RelatedArticles WHERE IDUnq = " & iIDUnq
						If ( sSuccess = "" ) Then
							sSuccess = DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_OFFSITEDELETED")
						End If
					End If
				Next
		End Select

		If ( sError <> "" ) Then
			Call DOMAIN_Message(sError, "ERROR")
		End If
		If ( sSuccess <> "" ) Then
			Call DOMAIN_Message(sSuccess, "SUCCESS")
		End If
		
		Call WriteForm()
		Set rsNews = Nothing
	End Sub
	'************************************************************************************

	'************************************************************************************
	'*																					*
	'*	This is the function to write out the form.										*
	'*																					*
	'************************************************************************************
	Sub WriteForm()
		Dim sSQLText, sBGColor, sColor1, sColor2, rsNews2
		Dim iIDUnq, sOffsiteURL, sOffsiteTitle
		
		sBGColor = DOMAIN_Color("NewsBGColor2")
		%>
		<table cellpadding=0 cellspacing=0 border=0 width=671>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
			<tr>
				<td>
					<font color='<%=DOMAIN_Color("NewsPageText")%>'><font size=+1><b><%=DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_HEADER")%></b></font>
					<br>
					<b><%=DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_SUBHEADER")%></b> <%=ReturnHeadline(iNewsUnq)%>
					<br><br>
					<form name='AddOnsite' action='RelatedArticles.asp' method='post'>
					<%=DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_ADDARTICLES")%><br>
					<%
					aVariables(0) = "sAction"
					aVariables(1) = "iNewsUnq"
					aVariables(2) = "iTtlNumItems"
					aVariables(3) = "iDBLoc"
					aVariables(4) = "iDomainUnq"
					aValues(0) = "AddOnsite"
					aValues(1) = iNewsUnq
					aValues(2) = Request("iTtlNumItems")
					aValues(3) = Request("iDBLoc")
					aValues(4) = Request("iDomainUnq")
					Response.Write DOMAIN_Link("P")
					%>
					<SELECT NAME='iRelatedNewsUnq' MULTIPLE size=6>
						<%
						Set rsNews = CreateObject("ADODB.Recordset")
						sSQLText = "SELECT NewsUnq, Headline FROM News (NOLOCK) WHERE NewsUnq NOT IN (SELECT RelatedNewsUnq FROM RelatedArticles WHERE NewsUnq = " & iNewsUnq & ") AND NewsUnq <> " & iNewsUnq & " AND DomainUnq = " & iDomainName
						rsNews.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
						While ( NOT rsNews.EOF )
							Response.Write "<option value='" & rsNews("NewsUnq") & "'>" & rsNews("Headline") & "</option>"
							rsNews.MoveNext
						Wend
						rsNews.Close
						%>
					</select>
					<br>
					<input type='submit' value='<%=DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_ADDSUBMIT")%>'>
					</form>
					
					<form name='DeleteOnsite' action='RelatedArticles.asp' method='post'>
					<%=DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_REMOVEARTICLES")%><br>
					<%
					aValues(0) = "DeleteOnsite"
					Response.Write DOMAIN_Link("P")
					%>
					<SELECT NAME='iRelatedNewsUnq' MULTIPLE size=6>
						<%
						Set rsNews = CreateObject("ADODB.Recordset")
						sSQLText = "SELECT NewsUnq, Headline FROM News (NOLOCK) WHERE NewsUnq IN (SELECT RelatedNewsUnq FROM RelatedArticles WHERE NewsUnq = " & iNewsUnq & ") AND NewsUnq <> " & iNewsUnq & " AND DomainUnq = " & iDomainName
						rsNews.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
						While ( NOT rsNews.EOF )
							Response.Write "<option value='" & rsNews("NewsUnq") & "'>" & rsNews("Headline") & "</option>"
							rsNews.MoveNext
						Wend
						rsNews.Close
						%>
					</select>
					<br>
					<input type='submit' value='<%=DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_REMOVESUBMIT")%>'>
					</form>
					
					<form name='AddOffsite' action='RelatedArticles.asp' method='post'>
					<%=DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_ADDOFFSITE")%>
					<%
					aValues(0) = "AddOffsite"
					Response.Write DOMAIN_Link("P")
					%>
					<table width=100%>
						<tr>
							<td><%=DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_OFFURL")%></td>
							<td><input type='text' name='sOffsiteURL' value=''></td>
							<td><%=DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_OFFDESC")%></td>
							<td><input type='text' name='sDescription' value=''></td>
							<td><input type='submit' value='<%=DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_OFFSUBMIT")%>'></td>
						</tr>
					</table>
					</form>
					
					<form name='ManageOffsite' action='RelatedArticles.asp' method='post'>
					<%
					aValues(0) = "UpdateOffsite"
					Response.Write DOMAIN_Link("P")
					%>
					<table cellpadding=2 cellspacing=0 border=0 width=671>
						<tr>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("NewsTextColor2")%>'><b><%=DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_OFFURLTITLE")%></b></td>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("NewsTextColor2")%>'><b><%=DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_OFFTITLE")%></b></td>
							<td align=center bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("NewsTextColor2")%>'><b><%=DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_OFFDEL")%></b></td>
						</tr>
						<%
						sColor1 = DOMAIN_Color("NewsBGColor1")
						sColor2 = DOMAIN_Color("NewsPageBGColor")
						
						sSQLText = "SELECT * FROM RelatedArticles (NOLOCK) WHERE NewsUnq = " & iNewsUnq & " AND OffSiteURL <> ''"
						Set rsNews = CreateObject("ADODB.Recordset")
						rsNews.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
						While ( NOT rsNews.EOF )
							If ( sBGColor = sColor1 ) Then
								sBGColor = sColor2
							Else
								sBGColor = sColor1
							End If

							iIDUnq			= rsNews("IDUnq")
							sOffsiteURL		= Server.HTMLEncode(rsNews("OffsiteURL"))
							sOffsiteTitle	= Server.HTMLEncode(rsNews("OffsiteTitle"))
							%>
							<tr>
								<td bgcolor=<%=sBGColor%> valign=top>
									<input type='hidden' name='sOldURL<%=iIDUnq%>' value='<%=sOffsiteURL%>'>
									<input type='text' name='sNewURL<%=iIDUnq%>' value='<%=sOffsiteURL%>' size=40 maxlength=250>
								</td>
								<td bgcolor=<%=sBGColor%> valign=top>
									<input type='hidden' name='sOldTitle<%=iIDUnq%>' value='<%=sOffsiteTitle%>'>
									<input type='text' name='sNewTitle<%=iIDUnq%>' value='<%=sOffsiteTitle%>' size=40 maxlength=250>
								</td>
								<td align=center bgcolor=<%=sBGColor%> valign=top><input type='checkbox' name="sDelete<%=iIDUnq%>" value="<%=iIDUnq%>"></td>
							</tr>
							<%
							rsNews.MoveNext
						Wend
						%>
					</table>
					<center>
					<input type='submit' value='<%=DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_UPDATEOFFSUBMIT")%>'>
					</form>
				</td>
			</tr>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
		</table>
		<%
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This checks to see if the user currenly logged in is an editor - on any domain.	*
	'*																					*
	'************************************************************************************
	Function IsEditor()
	
		Dim sSQLText, rsNews
		
		Set rsNews = CreateObject("ADODB.Recordset")
		sSQLText = "SELECT DISTINCT E.AccountUnq FROM Editors E (NOLOCK), Categories C (NOLOCK) WHERE C.DomainUnq = " & iDomainName & " AND C.CatUnq = E.CatUnq AND E.AccountUnq = " & iLoginAccountUnq
		rsNews.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsNews.EOF ) Then
			IsEditor = TRUE
		Else
			IsEditor = FALSE
		End If
		rsNews.Close
		Set rsNews = Nothing
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This checks to see if the article is the currently logged in users article.		*
	'*																					*
	'************************************************************************************
	Function IsArticle()
	
		Dim sSQLText, rsNews
		
		Set rsNews = CreateObject("ADODB.Recordset")
		sSQLText = "SELECT AccountUnq From News (NOLOCK) WHERE NewsUnq = " & iNewsUnq & " AND OriginalEditor = " & iLoginAccountUnq
		rsNews.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsNews.EOF ) Then
			IsArticle = TRUE
		Else
			IsArticle = FALSE
		End If
		rsNews.Close
		Set rsNews = Nothing
	
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This returns the headline for the iNewsUnq passed it.							*
	'*																					*
	'************************************************************************************
	Function ReturnHeadline(iNewsUnq)
	
		Dim sSQLText, rsNews
		
		Set rsNews = CreateObject("ADODB.Recordset")
		sSQLText = "SELECT Headline From News (NOLOCK) WHERE NewsUnq = " & iNewsUnq
		rsNews.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsNews.EOF ) Then
			ReturnHeadline = rsNews("Headline")
		Else
			ReturnHeadline = DOMAIN_Text("NEWS_MANAGENEWS_RELATEDARTICLES_NOHEADLINE")
		End If
		rsNews.Close
		Set rsNews = Nothing
	
	End Function
	'************************************************************************************
%>