<!--#INCLUDE VIRTUAL="/WS_Content/Includes/i_Includes.asp"-->
<%
	Response.Buffer = TRUE
	Dim iDomainUnq, sVisible, sRequired, sDataType, sDescription, sOldMapName, sSystemUnq, sRightsLvl
	
	Dim sSQLText, rsDB, rs1
	Dim iNumPerPage, iTtlNumItems, iDBLoc
	
	Call DISP_Action("SB_ACCOUNTS_ADMIN_OPEN")
	Call DISP_Action("SB_ACCOUNTS_MANAGE_ADV")
	If   (ACCNT_AnyDomain("SB_MADV_DELETE")) Or _
		 (ACCNT_AnyDomain("SB_MADV_EDIT")) Then
		Call Main()
	Else
		Call DOMAIN_Message(DOMAIN_Text("ACCT_SYS_RIGHTS"), "ERROR")
	End If
	Call DISP_Action("SB_ACCOUNTS_CLOSE")
	Response.Flush
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub Main()
		Dim sAction, sError, sADVField, sSuccess, sTemp
		
		Set rsDB = CreateObject("ADODB.Recordset")	
		Set rs1 = CreateObject("ADODB.Recordset")	
		sAction = Request("sAction")
		
		iDomainUnq = Trim(Request("iDomainUnq"))
		If ( iDomainUnq = "" ) Then
			iDomainUnq = ACCNT_GetDomainW_Rights("SB_MADV_EDIT", "SB_MADV_DELETE", "")
		End If
		
		If ( sVisible = "" ) Then
			sVisible = "N"
		End If
		If ( sRequired = "" ) Then
			sRequired = "N"
		End If

		Select Case sAction
			Case "EditADV"
				If ( iDomainUnq <> iDomainName ) AND (NOT ACCNT_SpecificDomain("SB_MADV_EDIT", iDomainUnq)) Then
					sError = DOMAIN_Text("DOM_SYS_RIGHTS")
				Else
					For Each sADVField In Request.Form
						If (InStr(sADVField, "sOldMapName") > 0 ) Then
							' Right now it's illegal to change the MapName of the ADV because it'll have to change all the user data and copy the data over if it's a different datatype
							sOldMapName = Replace(sADVField, "sOldMapName", "")
							sDescription = Request("sDescription" & sOldMapName)
							sRequired = Request("sRequired" & sOldMapName)
							sVisible = Request("sVisible" & sOldMapName)
							sDataType = Request("sDataType" & sOldMapName)
							sSystemUnq = Request("sSystemUnq" & sOldMapName)
							sRightsLvl = Request("sRightsLvl" & sOldMapName)
							
							If ( sError = "" ) Then
								If ( sError = "" ) Then
									sTemp = Trim(Request("sOldDescription" & sOldMapName))
									If ( sDescription <> sTemp ) Then
										DBConnection.Execute "UPDATE AccountMap SET Description = '" & SQLEncode(sDescription) & "' WHERE MapName = '" & SQLEncode(sOldMapName) & "' AND DomainUnq = " & iDomainUnq
										Call DOMAIN_Log(47, SQLEncode(sOldMapName), iDomainUnq, "", 0, "", 0, "V", "U", SQLEncode(sTemp), "")
									End If
							
									sTemp = Trim(Request("sOldRequired" & sOldMapName))
									If ( sRequired <> sTemp ) Then
										DBConnection.Execute "UPDATE AccountMap SET Required = '" & SQLEncode(sRequired) & "' WHERE MapName = '" & SQLEncode(sOldMapName) & "' AND DomainUnq = " & iDomainUnq
										Call DOMAIN_Log(48, SQLEncode(sOldMapName), iDomainUnq, "", 0, "", 0, "V", "U", SQLEncode(sTemp), "")
									End If
							
									sTemp = Trim(Request("sOldVisible" & sOldMapName))
									If ( sVisible <> sTemp ) Then
										DBConnection.Execute "UPDATE AccountMap SET Visible = '" & SQLEncode(sVisible) & "' WHERE MapName = '" & SQLEncode(sOldMapName) & "' AND DomainUnq = " & iDomainUnq
										Call DOMAIN_Log(49, SQLEncode(sOldMapName), iDomainUnq, "", 0, "", 0, "V", "U", SQLEncode(sTemp), "")
									End If
							
									sTemp = Trim(Request("sOldDataType" & sOldMapName))
									If ( sDataType <> sTemp ) Then
										DBConnection.Execute "UPDATE AccountMap SET DataType = '" & SQLEncode(sDataType) & "' WHERE MapName = '" & SQLEncode(sOldMapName) & "' AND DomainUnq = " & iDomainUnq
										Call DOMAIN_Log(50, SQLEncode(sOldMapName), iDomainUnq, "", 0, "", 0, "V", "U", SQLEncode(sTemp), "")
									End If
							
									sTemp = Trim(Request("sOldSystemUnq" & sOldMapName))
									If ( sSystemUnq <> sTemp ) Then
										DBConnection.Execute "UPDATE AccountMap SET SystemUnq = " & sSystemUnq & " WHERE MapName = '" & SQLEncode(sOldMapName) & "' AND DomainUnq = " & iDomainUnq
										Call DOMAIN_Log(51, SQLEncode(sOldMapName), iDomainUnq, "", 0, "", 0, "V", "U", SQLEncode(sTemp), "")
									End If
							
									sTemp = Trim(Request("sOldRightsLvl" & sOldMapName))
									If ( sRightsLvl <> sTemp ) Then
										DBConnection.Execute "UPDATE AccountMap SET RightsLvl = '" & SQLEncode(sRightsLvl) & "' WHERE MapName = '" & SQLEncode(sOldMapName) & "' AND DomainUnq = " & iDomainUnq
										Call DOMAIN_Log(52, SQLEncode(sOldMapName), iDomainUnq, "", 0, "", 0, "V", "U", SQLEncode(sTemp), "")
									End If
									sSuccess = DOMAIN_Text("ADV_CHANGED")
								End If
							End If
						End If
					Next
				End If
			Case "DeleteADV"
				If ( iDomainUnq <> iDomainName ) AND (NOT ACCNT_SpecificDomain("SB_MADV_DELETE", iDomainUnq)) Then
					sError = DOMAIN_Text("DOM_SYS_RIGHTS")
				Else			
					For Each sADVField In Request.Form
						If (InStr(sADVField, "sDelete") > 0 ) Then
							sOldMapName = Replace(sADVField, "sDelete", "")
							
							If (sOldMapName <> "") Then
'								If (InStr(sOldMapName, "SB_")) Then
'									sError = DOMAIN_Text("NO_DELETE_SB_ADV")
'								Else
									DBConnection.Execute "DELETE FROM AccountMap WHERE MapName = '" & SQLEncode(sOldMapName) & "' AND DomainUnq = " & iDomainUnq
									sDescription = Request("sOldDescription" & sOldMapName)
									sRequired = Request("sOldRequired" & sOldMapName)
									sVisible = Request("sOldVisible" & sOldMapName)
									sDataType = Request("sOldDataType" & sOldMapName)
									sSystemUnq = Request("sOldSystemUnq" & sOldMapName)
									sRightsLvl = Request("sOldRightsLvl" & sOldMapName)
									sTemp = Request("sGroupUnq" & sOldMapName)
									
									Call DOMAIN_Log(46, SQLEncode(sOldMapName), iDomainUnq, "", 0, "", 0, "V", "D", SQLEncode(sOldMapName), "")
									Call DOMAIN_Log(47, SQLEncode(sOldMapName), iDomainUnq, "", 0, "", 0, "V", "D", SQLEncode(sDescription), "")
									Call DOMAIN_Log(48, SQLEncode(sOldMapName), iDomainUnq, "", 0, "", 0, "V", "D", SQLEncode(sRequired), "")
									Call DOMAIN_Log(49, SQLEncode(sOldMapName), iDomainUnq, "", 0, "", 0, "V", "D", SQLEncode(sVisible), "")
									Call DOMAIN_Log(50, SQLEncode(sOldMapName), iDomainUnq, "", 0, "", 0, "V", "D", SQLEncode(sDataType), "")
									Call DOMAIN_Log(51, SQLEncode(sOldMapName), iDomainUnq, "", 0, "", 0, "V", "D", SQLEncode(sSystemUnq), "")
									Call DOMAIN_Log(52, SQLEncode(sOldMapName), iDomainUnq, "", 0, "", 0, "V", "D", SQLEncode(sRightsLvl), "")
									Call DOMAIN_Log(53, SQLEncode(sOldMapName), iDomainUnq, "", sTemp, "", 0, "V", "D", SQLEncode(sOldMapName), "")
									sSuccess = DOMAIN_Text("ADV_DELETED")
'								End If
							Else
								sError = DOMAIN_Text("DEL_ADV")
							End If
						End If
					Next
				End If

		End Select
	
		
		' Pagination variables -- begin
		iNumPerPage = 10
		iTtlNumItems = CDbl(Request("iTtlNumItems"))
		If IsNull(Request("iDBLoc")) Or Trim(Request("iDBLoc"))="" Then
			iDBLoc = 0
		Else
			iDBLoc = CDbl(Request("iDBLoc"))
			If (iDBLoc<0) Then
				iDBLoc = 0
			End If
		End If
		
		If ( sAction = "DeleteADV" ) Then
			' must reset this when ADV's are deleted to recalculate the number of pages
			iTtlNumItems = 0
		End If

		' Get ttl num of items from the database if it's not already in the QueryString
		if (iTtlNumItems = 0) then
			sSQLText = "SELECT Count(*) FROM AccountMap (NOLOCK) WHERE DomainUnq = " & iDomainUnq
			rsDB.Open sSQLText, DBConnection
			If Not(rsDB.EOF) Then
				iTtlNumItems = rsDB(0)
			End If
			rsDB.Close
		end if
		' Pagination variables -- end
		
		If ( sError <> "" ) Then
			Call DOMAIN_Message(sError, "ERROR")
		End If
		If ( sSuccess <> "" ) Then
			Call DOMAIN_Message(sSuccess, "SUCCESS")
		End If
		
		Call WriteForm()
		Set rsDB = Nothing
		Set rs1 = Nothing
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This is the function to write out the form.										*
	'*																					*
	'************************************************************************************
	Sub WriteForm()
		Dim sBGColor, sFontColor, x, iMax, iCount, rsDomain, sTemp
		Dim sMapName, sRequired, sVisible, sDataType, sDescription, sLinkColor
		ReDim aSystemUnq(1,10), aRightsLvl(1,0)
		Dim iUBoundSystemUnq, iUBoundRightsLvl
		
		' Get the list of Systems
		x = 0
		sSQLText = "SELECT * FROM Systems (NOLOCK) WHERE SystemUnq IN (SELECT SystemUnq FROM RightsLookup (NOLOCK) WHERE DomainUnq = " & iDomainUnq & ") ORDER BY SystemUnq"
		rs1.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		While NOT rs1.EOF
			aSystemUnq(0,x) = rs1("SystemUnq")
			aSystemUnq(1,x) = rs1("Description")
			x = x + 1
			rs1.MoveNext
		Wend
		rs1.Close
		iUBoundSystemUnq = x
		
		' Get the list of Rights Levels
		x = 0
		sSQLText = "SELECT * FROM RightsLookup (NOLOCK) WHERE DomainUnq = " & iDomainName & "  ORDER BY SystemUnq"
		rs1.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		ReDim aRightsLvl(1,rs1.RecordCount+1)
		While NOT rs1.EOF
			If ( Len (rs1("RightsConst")) > 65 ) Then
				sTemp = Left(rs1("RightsConst"), 62) & "..."
			Else
				sTemp = rs1("RightsConst")
			End If
			aRightsLvl(0,x) = rs1("RightsLvl")
			aRightsLvl(1,x) = sTemp
			x = x + 1
			rs1.MoveNext
		Wend
		rs1.Close
		iUBoundRightsLvl = x
		
		
		sSQLText = "SET ROWCOUNT " & (CDbl(iDBLoc) + CDbl(iNumPerPage)) & " SELECT * FROM AccountMap (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " ORDER BY MapName SET ROWCOUNT 0"
		Set rsDB = CreateObject("ADODB.Recordset")
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		sBGColor = DOMAIN_Color("AccountsBGColor2")
		For x = 1 To CDbl(iDBLoc)
			rsDB.MoveNext
		Next
		iMax = iNumPerPage
		%>
		<script language='JavaScript1.2' type='text/javascript'>
	
			function SubmitForm(sAction){
				document.ManageADV.sAction.value = sAction;
				document.ManageADV.submit();
			}
			
			function PaginationLink(sQueryString){
				document.location = "Default.asp?<%=DOMAIN_Link("G")%>&iDomainUnq=" + document.ManageADV.iDomainUnq.value + sQueryString;
			}
			
		</script>
		<form name='ManageADV' action='Default.asp' method='post'>
		<%
		aVariables(0) = "sAction"
		aVariables(1) = "iTtlNumItems"
		aVariables(2) = "iDBLoc"
		aValues(0) = "New"
		aValues(1) = iTtlNumItems
		aValues(2) = iDBLoc
		Response.Write DOMAIN_Link("P")
		%>
		<table cellpadding=0 cellspacing=0 border=0 width=671>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
			<tr>
				<td>
					<font color='<%=DOMAIN_Color("AccountsPageText")%>'>
					<font size=+1><b><%=DOMAIN_Text("ACCOUNTS_ADV_HEADER")%></b></font>
					<br>
					<table>
						<tr>
							<td><font color='<%=DOMAIN_Color("AccountsPageText")%>'><b><%=DOMAIN_Text("ACCOUNTS_ADV_DOMAIN")%></b></font></td>
						</tr>
						<tr>
							<td>
								<%Call DOMAINS_DomainsDropDown("SB_MADV_DELETE", "SB_MADV_EDIT", "")%>
							</td>
						</tr>
					</table>
					<table cellpadding=2 cellspacing=0 border=0 width=671>
						<tr>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>'><b><%=DOMAIN_Text("ACCOUNTS_ADV_NAME")%></b></td>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>'><b><%=DOMAIN_Text("ACCOUNTS_ADV_DESCRIPTION")%></b></td>
							<td align=center bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>'><b><%=DOMAIN_Text("ACCOUNTS_ADV_REQUIRED")%></b></td>
							<td align=center bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>'><b><%=DOMAIN_Text("ACCOUNTS_ADV_VISIBLE")%></b></td>
							<td align=center bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>' size=-2><%=DOMAIN_Text("ACCOUNTS_ADV_TEXTFIELD")%></td>
							<td align=center bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>' size=-2><%=DOMAIN_Text("ACCOUNTS_ADV_NOTESFIELD")%></td>
							<td align=center bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>'><b><%=DOMAIN_Text("ACCOUNTS_ADV_DELETE")%></b></td>
						</tr>
						<tr>
						<%
						While ( NOT rsDB.EOF )
							If ( sBGColor = DOMAIN_Color("AccountsBGColor1") ) Then
								sBGColor = DOMAIN_Color("AccountsPageBGColor")
								sFontColor = DOMAIN_Color("AccountsPageText")
								sLinkColor = "LargeNavPage"
							Else
								sBGColor = DOMAIN_Color("AccountsBGColor1")
								sFontColor = DOMAIN_Color("AccountsTextColor1")
								sLinkColor = "LargeNav1"
							End If
							sMapName = rsDB("MapName")
							sRequired = Trim(UCase(rsDB("Required")))
							sVisible = Trim(UCase(rsDB("Visible")))
							sDataType = Trim(UCase(rsDB("DataType")))
							sSystemUnq = Trim(UCase(rsDB("SystemUnq")))
							sRightsLvl = rsDB("RightsLvl")
							sDescription = rsDB("Description")
							%>
							<input type='hidden' name='sOldDescription<%=sMapName%>' value="<%=Server.HTMLEncode(sDescription)%>">
							<input type='hidden' name='sOldRequired<%=sMapName%>' value='<%=sRequired%>'>
							<input type='hidden' name='sOldVisible<%=sMapName%>' value='<%=sVisible%>'>
							<input type='hidden' name='sOldDataType<%=sMapName%>' value='<%=sDataType%>'>
							<input type='hidden' name='sOldSystemUnq<%=sMapName%>' value='<%=sSystemUnq%>'>
							<input type='hidden' name='sOldRightsLvl<%=sMapName%>' value='<%=sRightsLvl%>'>
							<input type='hidden' name='sGroupUnq<%=sMapName%>' value='<%=rsDB("GroupUnq")%>'>
							<tr><td colspan=7 bgcolor='<%=sBGColor%>'><img src='/WS_Content/Images/Blank.gif' width=3 height=7></td></tr>
							<tr>
								<td bgcolor=<%=sBGColor%>><input type='hidden' name='sOldMapName<%=sMapName%>' value='<%=sMapName%>'><font color='<%=sFontColor%>' size=+1><%=sMapName%></font></td>
								<td bgcolor=<%=sBGColor%>><input type='text' name='sDescription<%=sMapName%>' value="<%=Server.HTMLEncode(sDescription)%>" size=25 maxlength=250></td>
								<td align=center bgcolor=<%=sBGColor%>><input type='checkbox' name='sRequired<%=sMapName%>' value='Y' <%If ( sRequired = "Y" ) Then Response.Write "checked" End If%>></td>
								<td align=center bgcolor=<%=sBGColor%>><input type='checkbox' name='sVisible<%=sMapName%>' value='Y' <%If ( sVisible = "Y" ) Then Response.Write "checked" End If%>></td>
								<td align=center bgcolor=<%=sBGColor%>><input type='radio' name='sDataType<%=sMapName%>' value='V' <%If ( sDataType = "V" ) Then Response.Write "checked" End If%>></td>
								<td align=center bgcolor=<%=sBGColor%>><input type='radio' name='sDataType<%=sMapName%>' value='T' <%If ( sDataType = "T" ) Then Response.Write "checked" End If%>></td>
								<td align=center bgcolor=<%=sBGColor%>><input type='checkbox' name='sDelete<%=sMapName%>' value='DELETE'></td>
							</tr>
							<tr>
								<td colspan=7 bgcolor=<%=sBGColor%>>
									<font color='<%=sFontColor%>'><b><%=DOMAIN_Text("ACCOUNTS_ADV_SYSTEM")%></b>&nbsp;
									<select name = "sSystemUnq<%=sMapName%>">
									<%
									Response.Write "<option value = '0'>" & DOMAIN_Text("ACCOUNTS_ADV_NOSYSTEMUNQ") & "</option>"
									For x = 0 to iUBoundSystemUnq - 1
										If ( sSystemUnq = CStr(aSystemUnq(0,x)) ) Then
											Response.Write "<option value = '" & Server.HTMLEncode(aSystemUnq(0,x)) & "' Selected>" & Server.HTMLEncode(aSystemUnq(1,x)) & " - " & Server.HTMLEncode(aSystemUnq(0,x)) & "</option>"
										Else
											Response.Write "<option value = '" & Server.HTMLEncode(aSystemUnq(0,x)) & "'>" & Server.HTMLEncode(aSystemUnq(1,x)) & " - " & Server.HTMLEncode(aSystemUnq(0,x)) & "</option>"
										End If
									Next
									%>
									</select>
									<br>
									<b><%=DOMAIN_Text("ACCOUNTS_ADV_RIGHTSLVL")%></b>
									<br>
									<select name = "sRightsLvl<%=sMapName%>">
										<%
										Response.Write "<option value = ''>" & DOMAIN_Text("ACCOUNTS_ADV_NORIGHTSLVL") & "</option>"
										For x = 0 to iUBoundRightsLvl - 1
											If ( sRightsLvl = CStr(aRightsLvl(0,x)) ) Then
												Response.Write "<option value = """ & Server.HTMLEncode(aRightsLvl(0,x)) & """ Selected>" & Server.HTMLEncode(aRightsLvl(0,x)) & " - " & Server.HTMLEncode(aRightsLvl(1,x)) & "</option>"
											Else
												Response.Write "<option value = """ & Server.HTMLEncode(aRightsLvl(0,x)) & """>" & Server.HTMLEncode(aRightsLvl(0,x)) & " - " & Server.HTMLEncode(aRightsLvl(1,x)) & "</option>"
											End If
										Next
										%>
									</select>
								</td>
							</tr>
							<tr><td colspan=7 bgcolor='<%=sBGColor%>'><img src='/WS_Content/Images/Blank.gif' width=3 height=7></td></tr>
							<%
							rsDB.MoveNext
							iCount = iCount + 1
						Wend
						%>
						<tr>
							<td colspan=8 align=right>
								<%Call PrintRecordsetNav( iNumPerPage, "DBConnection", "Accounts", "", "Default.asp", "" )%>
							</td>
						</tr>
					</table>
					<br>
					<font size=-2>
					<%=DOMAIN_Text("ACCOUNTS_ADV_FOOTER1")%>
				</td>
			</tr>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
		</table>
		</form>
		<%
		rsDB.Close
	End Sub
	'********************************************************************************
	
	
	
	'********************************************************************************
	'*																				*
	'*	iNumPerPage is the number of items to display on each page					*
	'*	sURL is the page to put with the link, sQuerystring is additional qs stuff	*
	'*	adodbConnection, adodbCommand, sTable are all for the table to get the		*
	'*		row count from.															*
	'*																				*
	'*	Print out the numbers (if any) between the "previous" and "next" buttons	*
	'*	It'll act like this (current # is in bold):									*
	'*	1 2 3 4 5 6 7 8 9 <b>10</b> >> next											*
	'*	previous << <b>11</b> 12 13 14 15 16 17 18									*
	'*																				*
	'********************************************************************************
	Sub PrintRecordsetNav( iNumPerPage, adodbConnection, sTable, sWhere, sURL, sQuerystring )

		Dim sSqlTemp, iTtlTemp
		Dim iDBLocTemp, sURLBeg, iA, iB, x, iTemp, rsObj

		iTtlTemp = iTtlNumItems \ iNumPerPage	' this is the number of numbers overall (use the "\" to return int)
		iDBLocTemp = iDBLoc \ iNumPerPage		' this is which number we are currently on (use the "\" to return int)
		
		If (sQuerystring <> "") Then
			sURLBeg = "<a href = ""JavaScript:PaginationLink('&" & sQuerystring & "&iTtlNumItems=" & iTtlNumItems & "&iDBLoc="
		Else
			sURLBeg = "<a href = ""JavaScript:PaginationLink('&iTtlNumItems=" & iTtlNumItems & "&iDBLoc="
		End If

		'***** BEGIN DISPLAY *****
		' Print the "Previous"
		if (iDBLoc <> 0) then
			Response.Write sURLBeg & (iDBLoc - iNumPerPage) & "')"" class='MediumNavPage'><span style=""text-decoration:none;""> &#8592; </span></a>&nbsp;&nbsp;"
		end if
		' Print the <<
		if (iDBLocTemp >= iNumPerPage) then
			Response.Write sURLBeg & (( iDBLocTemp \ iNumPerPage ) * iNumPerPage ^ 2) - (iNumPerPage * 9) & "')""  class='MediumNavPage'>&lt;&lt;</a>&nbsp;"
		end if

		' Print the numbers in between. Print them out in sets of 10.
		iA = ( iDBLocTemp \ iNumPerPage ) * iNumPerPage
		iB = ( iDBLocTemp \ iNumPerPage ) * iNumPerPage + iNumPerPage
		for x = iA to iB
			iTemp = (x * iNumPerPage)
			if (iTemp < iTtlNumItems) then	' takes care of extra numbers after the overall final number
				if (iDBLoc = iTemp) then
					Response.Write "&nbsp;<font color='" & DOMAIN_Color("AccountsPageText") & "' size=+1>" & x+1 & "</font>"
				else
					Response.Write "&nbsp;" & sURLBeg & (x * iNumPerPage) & "')""  class='MediumNavPage'>" & x+1 & "</a>"
				end if
			else
				exit for
			end if
		next

		' Print the >>
		if (iTtlTemp > iDBLocTemp) then
			if ((iDBLocTemp + iNumPerPage) <= iTtlTemp) then
				Response.Write "&nbsp;" & sURLBeg & (( iDBLocTemp \ iNumPerPage ) * iNumPerPage + iNumPerPage ) * iNumPerPage & "')""  class='MediumNavPage'>&gt;&gt;</a>&nbsp;"
			end if
		end if
		' Print the "Next"
		if ((iDBLoc + iNumPerPage) < iTtlNumItems) then
			Response.Write "&nbsp;&nbsp;" & sURLBeg & (iDBLoc + iNumPerPage) & "')""  class='MediumNavPage'><span style=""text-decoration:none;""> &#8594; </span></a>"
		end if
		'***** END DISPLAY *****

	End Sub
	'********************************************************************************
%>
