<!--#INCLUDE VIRTUAL="/WS_Content/Includes/i_Includes.asp"-->
<%
	Response.Buffer = TRUE
	Dim iDomainUnq, sNewDescription, sActionsConst
	Dim rsDB, sSystemUnq, sTextField, sCheckbox
	Dim iNumPerPage, iTtlNumItems, iDBLoc

	Call DISP_Action("SB_DOMAINS_OPEN")
	Call DISP_Action("SB_DOMAINS_MANAGE_ACTIONS")
	If   (ACCNT_AnyDomain("SB_MACT_DELETE")) Or _
		 (ACCNT_AnyDomain("SB_MACT_UPDATE")) Then
		Call Main()
	Else
		Call WriteScripts()
		Call DOMAIN_Message(DOMAIN_Text("DOM_SYS_RIGHTS"), "ERROR")
	End If
	Call DISP_Action("SB_DOMAINS_CLOSE")
	Response.Flush
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub Main()
		Dim sAction, rsDomain, sSQLText, sError, sSuccess, bTemp
		Dim sOldActionsConst, sNewActionsConst, sOldDescription, sTemp
		
		sAction = Trim(Request("sAction"))
		sSystemUnq = Trim(Request("sSystemUnq"))
		If ( sSystemUnq = "" ) Then
			sSystemUnq = "1"
		End If
		iDomainUnq = Trim(Request("iDomainUnq"))
		If ( iDomainUnq = "" ) Then
			iDomainUnq = ACCNT_GetDomainW_Rights("SB_MACT_DELETE", "SB_MACT_UPDATE", "")
		End If
		
		Set rsDB = Server.CreateObject("ADODB.recordset")		

		Select Case sAction
			Case "DeleteAction"
				If ( iDomainUnq <> iDomainName ) And (NOT ACCNT_SpecificDomain("SB_MACT_DELETE", iDomainUnq)) Then
					sError = DOMAIN_Text("DOM_SYS_RIGHTS")
				Else
					For Each sCheckbox In Request.Form
						If ( InStr(sCheckbox, "sActionsConst") > 0 ) Then
							sTemp = SQLEncode(Replace(sCheckbox, "sActionsConst", ""))
							
							' log the deletion by saving the last version of the const, desc, and code
							Call DOMAIN_Log(1, sTemp, iDomainUnq, "", sSystemUnq, "", 0, "V", "D", sTemp, "")
							sSQLText = "SELECT * FROM Actions (NOLOCK) WHERE ActionsConst = '" & sTemp & "' AND DomainUnq = " & iDomainUnq & " AND SystemUnq = " & sSystemUnq
							rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
							If ( NOT rsDB.EOF ) Then
								Call DOMAIN_Log(3, sTemp, iDomainUnq, "", sSystemUnq, "", 0, "T", "D", "", SQLEncode(rsDB("Code")))
								Call DOMAIN_Log(2, sTemp, iDomainUnq, "", sSystemUnq, "", 0, "V", "D", SQLEncode(rsDB("Description")), "")
							End If
							rsDB.Close
							
							DBConnection.Execute "DELETE FROM Actions WHERE ActionsConst = '" & sTemp & "' AND DomainUnq = " & iDomainUnq & " AND SystemUnq = " & sSystemUnq
							If ( sSuccess = "" ) Then
								sSuccess = DOMAIN_Text("ACTION_DELETED")
							End If
						End If
					Next
				End If
			Case "UpdateAction"
				If ( iDomainUnq <> iDomainName ) And (NOT ACCNT_SpecificDomain("SB_MACT_UPDATE", iDomainUnq)) Then
					sError = DOMAIN_Text("DOM_SYS_RIGHTS")
				Else
					For Each sTextField In Request.Form
						If ( InStr(sTextField, "sOldConst") > 0 ) Then
							sOldActionsConst = Request(sTextField)
							sActionsConst = Replace(sTextField, "sOldConst", "")
							sNewActionsConst = Request("sNewConst" & sActionsConst)
							sOldDescription = Request("sOldDescription" & sActionsConst)
							sNewDescription = Request("sNewDescription" & sActionsConst)
							If ( sOldActionsConst <> sNewActionsConst Or sOldDescription <> sNewDescription ) Then
								If ( InStr(sNewActionsConst, "'") > 0 ) Then
									sError = DOMAIN_Text("ACTION_NO_SINGLE_QUOTES")
								Else
									If ( sOldActionsConst <> sNewActionsConst ) Then
										bTemp = DoesntExist(sNewActionsConst)
									Else
										bTemp = TRUE
									End If
									If ( bTemp ) Then
										DBConnection.Execute "UPDATE Actions SET Description = '" & SQLEncode(sNewDescription) & "', ActionsConst = '" & SQLEncode(sNewActionsConst) & "' WHERE SystemUnq = " & sSystemUnq & " AND DomainUnq = " & iDomainUnq & " AND ActionsConst = '" & SQLEncode(sOldActionsConst) & "'"
										If ( sOldActionsConst <> sNewActionsConst ) Then	' log change to the Action Constant
											Call DOMAIN_Log(1, SQLEncode(sNewActionsConst), iDomainUnq, "", sSystemUnq, "", 0, "V", "U", SQLEncode(sOldActionsConst), "")
										End If
										If ( sOldDescription <> sNewDescription ) Then		' log changes to the description
											Call DOMAIN_Log(2, SQLEncode(sNewActionsConst), iDomainUnq, "", sSystemUnq, "", 0, "V", "U", SQLEncode(sOldDescription), "")
										End If
										If ( sSuccess = "" ) Then
											sSuccess = DOMAIN_Text("ACTION_UPDATED")
										End If
									Else
										If ( sError = "" ) Then
											sError = DOMAIN_Text("ACTION_ID_EXISTS")
										End If
									End If
								End If
							End If
						End If
					Next
				End If
			Case Else
		End Select
		
		' Pagination variables -- begin
		iNumPerPage = 20
		iTtlNumItems = CDbl(Request("iTtlNumItems"))
		If IsNull(Request("iDBLoc")) Or Trim(Request("iDBLoc"))="" Then
			iDBLoc = 0
		Else
			iDBLoc = CDbl(Request("iDBLoc"))
			If (iDBLoc<0) Then
				iDBLoc = 0
			End If
		End If
		' must reset the position in the db and the ttlnumitems when changing the domain or system drop-down menu
		Select Case sAction
			Case "UpdateDomainUnq"
				iDBLoc = 0
				iTtlNumItems = 0
			Case "DeleteAction"
				iTtlNumItems = 0
			Case "UpdateSystemUnq"
				iDBLoc = 0
				iTtlNumItems = 0
		End Select
		
		' Get ttl num of items from the database if it's not already in the QueryString
		if (iTtlNumItems = 0) then
			sSQLText = "SELECT Count(*) FROM Actions WHERE DomainUnq = " & iDomainUnq & " AND SystemUnq = " & sSystemUnq
			rsDB.Open sSQLText, DBConnection
			If Not(rsDB.EOF) Then
				iTtlNumItems = rsDB(0)
			End If
			rsDB.Close
		end if
		' Pagination variables -- end
		
		If ( sError <> "" ) Then
			Call DOMAIN_Message(sError, "ERROR")
		End If
		If ( sSuccess <> "" ) Then
			Call DOMAIN_Message(sSuccess, "SUCCESS")
		End If
		
		Call WriteScripts()
		Call WriteForm()
		Set rsDB = Nothing
	End Sub
	'************************************************************************************
	

	'************************************************************************************
	'*																					*
	'*	This is the function to write out the form.										*
	'*																					*
	'************************************************************************************
	Sub WriteForm()
		Dim sSQLText, rs1, rsDomain, sDescription, sTextColor
		Dim sBGColor, sLinkColor, x, iMax, sCode
		
		sSQLText = "SET ROWCOUNT " & (CDbl(iDBLoc) + CDbl(iNumPerPage)) & " SELECT * FROM Actions WHERE DomainUnq = " & iDomainUnq & " AND SystemUnq = " & sSystemUnq & " ORDER BY ActionsConst SET ROWCOUNT 0"
		Set rsDB = CreateObject("ADODB.Recordset")
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		sBGColor = DOMAIN_Color("DomainsBGColor2")
		For x = 1 To CDbl(iDBLoc)
			rsDB.MoveNext
		Next
		iMax = iNumPerPage
		%>
		<form name='ManageActions' action='Default.asp' method='post'>
		<%
		aVariables(0) = "sAction"
		aVariables(1) = "iTtlNumItems"
		aVariables(2) = "iDBLoc"
		aValues(0) = "New"
		aValues(1) = iTtlNumItems
		aValues(2) = iDBLoc
		Response.Write DOMAIN_Link("P")
		
		Call DOMAIN_Link_Clear()
		%>
		<table cellpadding=0 cellspacing=0 border=0 width=671>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
			<tr>
				<td>
					<font color='<%=DOMAIN_Color("DomainsPageText")%>'>
					<font size=+1><b><%=DOMAIN_Text("DOMAINS_ACTIONS_HEADER")%></b></font>
					<br>
					<table>
						<tr>
							<td><font color='<%=DOMAIN_Color("DomainsPageText")%>'><b><%=DOMAIN_Text("DOMAINS_ACTIONS_DOMAIN")%></b></font></td>
							<td><font color='<%=DOMAIN_Color("DomainsPageText")%>'><b><%=DOMAIN_Text("DOMAINS_ACTIONS_SYSTEM")%></b></font></td>
						</tr>
						<tr>
							<td>
								<%Call DOMAINS_DomainsDropDown("SB_MACT_DELETE", "SB_MACT_UPDATE", "")%>
							</td>
							<td>
								<%Call DOMAINS_SystemsDropDown()%>
							</td>
						</tr>
					</table>
					<br><br>
					<table cellpadding=2 cellspacing=0 border=0 width=671>
						<tr>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("DomainsTextColor2")%>'><b><%=DOMAIN_Text("DOMAINS_MANAGE_ACTIONS_CONSTANT")%></b></td>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("DomainsTextColor2")%>'><b><%=DOMAIN_Text("DOMAINS_MANAGE_ACTIONS_DESCRIPTION")%></b></td>
							<td bgcolor=<%=sBGColor%>><b>&nbsp;</b></td>
							<td align=center bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("DomainsTextColor2")%>'><b><%=DOMAIN_Text("DOMAINS_MANAGE_ACTIONS_DELETE")%></b></td>
						</tr>
						<%
						While ( NOT rsDB.EOF )
							If ( sBGColor = DOMAIN_Color("DomainsBGColor1") ) Then
								sBGColor = DOMAIN_Color("DomainsPageBGColor")
								sLinkColor = "MediumNavPage"
								sTextColor = DOMAIN_Color("DomainsPageText")
							Else
								sBGColor = DOMAIN_Color("DomainsBGColor1")
								sLinkColor = "MediumNav1"
								sTextColor = DOMAIN_Color("DomainsTextColor1")
							End If
							sActionsConst = rsDB("ActionsConst")
							sDescription = rsDB("Description")
							sCode = rsDB("Code")
							%>
							<tr>
								<td bgcolor=<%=sBGColor%>><input type='hidden' name="sOldConst<%=Server.HTMLEncode(sActionsConst)%>" value="<%=Server.HTMLEncode(sActionsConst)%>"><input type='text' name="sNewConst<%=Server.HTMLEncode(sActionsConst)%>" value="<%=Server.HTMLEncode(sActionsConst)%>" size=35 maxlength=250></td>
								<td bgcolor=<%=sBGColor%>><input type='hidden' name="sOldDescription<%=Server.HTMLEncode(sActionsConst)%>" value="<%=Server.HTMLEncode(sDescription)%>"><input type='text' name="sNewDescription<%=Server.HTMLEncode(sActionsConst)%>" value="<%=Server.HTMLEncode(sDescription)%>" size=44 maxlength=250></td>
								<td align=center bgcolor=<%=sBGColor%>>
									<%
									If ( NOT ACCNT_SpecificDomain("SB_MACT_USE_ASP", iDomainUnq) ) Then
										If ( InStr(sCode, DOMAIN_Conf("cCODE_DELIMITER")) > 0 ) Then
											Response.Write "<font color='" & sTextColor & "'>" & DOMAIN_Text("DOMAINS_MANAGE_ACTIONS_NO_ASP") & "</font>"
										Else
											%><a href='JavaScript:EditCode("<%=Server.HTMLEncode(sActionsConst)%>")' class='<%=sLinkColor%>'><%=DOMAIN_Text("DOMAINS_MANAGE_ACTIONS_EDIT_CODE")%></a><%
										End If
									Else
									%>
									<a href='JavaScript:EditCode("<%=Server.HTMLEncode(sActionsConst)%>")' class='<%=sLinkColor%>'><%=DOMAIN_Text("DOMAINS_MANAGE_ACTIONS_EDIT_CODE")%></a>
									<%End If%>
								</td>
								<td align=center bgcolor=<%=sBGColor%>><input type='checkbox' name="sActionsConst<%=Server.HTMLEncode(sActionsConst)%>" value="<%=Server.HTMLEncode(sActionsConst)%>"></td>
							</tr>
							<%
							rsDB.MoveNext
						Wend
						%>
						<tr>
							<td colspan=8 align=right>
								<%Call PrintRecordsetNav( iNumPerPage, "DBConnection", "Domains", "", "Default.asp", "" )%>
							</td>
						</tr>
					</table>
					<br>
					<font size=-2>
					<%=DOMAIN_Text("DOMAINS_ACTIONS_FOOTER1")%>
				</td>
			</tr>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
		</table>
		</form>
		<%
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This writes the JavaScript out even if the Main() Sub isn't called in case the	*
	'*		admin has creation rights, but not edit rights.								*
	'*																					*
	'************************************************************************************
	Sub WriteScripts()
		%>
		<script language='JavaScript1.2' type='text/javascript'>
	
			function SubmitForm(sAction){
				document.ManageActions.sAction.value = sAction;
				document.ManageActions.submit();
			}
			
			function PaginationLink(sQueryString){
				document.location = "Default.asp?<%=DOMAIN_Link("G")%>&sSystemUnq=" + document.ManageActions.sSystemUnq.value + "&iDomainUnq=" + document.ManageActions.iDomainUnq.value + sQueryString;
			}
			
			function EditCode(sActionConst){
				document.location = "Edit.asp?<%=DOMAIN_Link("G")%>&bAdvanced=T&iDBLoc=" + document.ManageActions.iDBLoc.value + "&sActionsConst=" + sActionConst + "&sSystemUnq=" + document.ManageActions.sSystemUnq.value + "&iDomainUnq=" + document.ManageActions.iDomainUnq.value;
			}
			
			function NewCode(){
				document.location = "New.asp?<%=DOMAIN_Link("G")%>&iDBLoc2=" + document.ManageActions.iDBLoc.value + "&sSystemUnq2=" + document.ManageActions.sSystemUnq.value + "&iDomainUnq2=" + document.ManageActions.iDomainUnq.value;
			}
			
		</script>
		<%
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This checks to see if the action they are trying to add is already in the DB.	*
	'*																					*
	'************************************************************************************	
	Function DoesntExist(sAID)
		Dim sSQLText, rsDomain

		DoesntExist = FALSE
		Set rsDomain = CreateObject("ADODB.Recordset")
		sSQLText = "SELECT * FROM Actions (NOLOCK) WHERE SystemUnq = " & sSystemUnq & " AND DomainUnq = " & iDomainUnq & " AND ActionsConst = '" & SQLEncode(sAID) & "'"
		rsDomain.Open sSQLText, DBConnection
		If ( rsDomain.EOF ) Then
			DoesntExist = TRUE
		End If
		rsDomain.Close
		Set rsDomain = Nothing
	End Function
	'************************************************************************************	
	
	
	
	'********************************************************************************
	'*																				*
	'*	iNumPerPage is the number of items to display on each page					*
	'*	sURL is the page to put with the link, sQuerystring is additional qs stuff	*
	'*	adodbConnection, adodbCommand, sTable are all for the table to get the		*
	'*		row count from.															*
	'*																				*
	'*	Print out the numbers (if any) between the "previous" and "next" buttons	*
	'*	It'll act like this (current # is in bold):									*
	'*	1 2 3 4 5 6 7 8 9 <b>10</b> >> next											*
	'*	previous << <b>11</b> 12 13 14 15 16 17 18									*
	'*																				*
	'********************************************************************************
	Sub PrintRecordsetNav( iNumPerPage, adodbConnection, sTable, sWhere, sURL, sQuerystring )

		Dim sSqlTemp, iTtlTemp
		Dim iDBLocTemp, sURLBeg, iA, iB, x, iTemp, rsObj

		iTtlTemp = iTtlNumItems \ iNumPerPage	' this is the number of numbers overall (use the "\" to return int)
		iDBLocTemp = iDBLoc \ iNumPerPage		' this is which number we are currently on (use the "\" to return int)
		
		If (sQuerystring <> "") Then
			sURLBeg = "<a href = ""JavaScript:PaginationLink('&" & sQuerystring & "&iTtlNumItems=" & iTtlNumItems & "&iDBLoc="
		Else
			sURLBeg = "<a href = ""JavaScript:PaginationLink('&iTtlNumItems=" & iTtlNumItems & "&iDBLoc="
		End If

		'***** BEGIN DISPLAY *****
		' Print the "Previous"
		if (iDBLoc <> 0) then
			Response.Write sURLBeg & (iDBLoc - iNumPerPage) & "')"" class='MediumNavPage'><span style=""text-decoration:none;""> &#8592; </span></a>&nbsp;&nbsp;"
		end if
		' Print the <<
		if (iDBLocTemp >= iNumPerPage) then
			Response.Write sURLBeg & (( iDBLocTemp \ iNumPerPage ) * iNumPerPage ^ 2) - (iNumPerPage * 9) & "')""  class='MediumNavPage'>&lt;&lt;</a>&nbsp;"
		end if

		' Print the numbers in between. Print them out in sets of 10.
		iA = ( iDBLocTemp \ iNumPerPage ) * iNumPerPage
		iB = ( iDBLocTemp \ iNumPerPage ) * iNumPerPage + iNumPerPage
		for x = iA to iB
			iTemp = (x * iNumPerPage)
			if (iTemp < iTtlNumItems) then	' takes care of extra numbers after the overall final number
				if (iDBLoc = iTemp) then
					Response.Write "&nbsp;<font color='" & DOMAIN_Color("DomainsPageText") & "' size=+1>" & x+1 & "</font>"
				else
					Response.Write "&nbsp;" & sURLBeg & (x * iNumPerPage) & "')""  class='MediumNavPage'>" & x+1 & "</a>"
				end if
			else
				exit for
			end if
		next

		' Print the >>
		if (iTtlTemp > iDBLocTemp) then
			if ((iDBLocTemp + iNumPerPage) <= iTtlTemp) then
				Response.Write "&nbsp;" & sURLBeg & (( iDBLocTemp \ iNumPerPage ) * iNumPerPage + iNumPerPage ) * iNumPerPage & "')""  class='MediumNavPage'>&gt;&gt;</a>&nbsp;"
			end if
		end if
		' Print the "Next"
		if ((iDBLoc + iNumPerPage) < iTtlNumItems) then
			Response.Write "&nbsp;&nbsp;" & sURLBeg & (iDBLoc + iNumPerPage) & "')""  class='MediumNavPage'><span style=""text-decoration:none;""> &#8594; </span></a>"
		end if
		'***** END DISPLAY *****

	End Sub
	'********************************************************************************
%>