<!--#INCLUDE VIRTUAL="/WS_Content/Includes/i_Includes.asp"-->
<%
	Dim rsDB, sSQLText, fsoFileObject
	Dim iDomainUnq, sDestDir, sColorSchemesDir, sRightsDir, sTextSchemesDir, sActionsDir, sGroupsDir
	Dim sIGDir, sRadioDir, sMBDir
	
	Dim sDomainDir, fsoTextFile

	Call DISP_Action("SB_DOMAINS_OPEN")
	Call DISP_Action("SB_DOMAINS_MANAGE_DOMAINS_EXPORT")
	If   (ACCNT_AnyDomain("SB_MD_EXPORT")) Then
		Call Main()
	Else
		Call DOMAIN_Message(DOMAIN_Text("DOM_SYS_RIGHTS"), "ERROR")
	End If
	Call DISP_Action("SB_DOMAINS_CLOSE")

	'************************************************************************************
	'*																					*
	'*	This is the main sub.															*
	'*																					*
	'************************************************************************************
	Sub Main()
		Dim sAction, sError, sError2, sSuccess

		sAction = Trim(Request("sAction"))
	
		Set rsDB = Server.CreateObject("ADODB.recordset")
		
		Select Case sAction
			Case "ExportDomain"
				iDomainUnq = Request("iDomainUnq")
				If ( ACCNT_SpecificDomain("SB_MD_EXPORT", iDomainUnq) ) Then
					sDestDir = Trim(Request("sDestDir"))
					If ( sDestDir = "" ) Then
						sError = DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_ENTERPATH")
					End If
					Set fsoFileObject = CreateObject("Scripting.FileSystemObject")
					sDestDir = Replace(sDestDir, "/", "\")
					If ( Right(sDestDir, 1) = "\" ) Then
						sDestDir = Left(sDestDir, Len(sDestDir)-1)
					End If
					If ( sDestDir = "" ) Then
						sError = DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_NOBLANKPATH")
					Else
						If ( fsoFileObject.FolderExists(sDestDir) = FALSE ) Then
							If ( fsoFileObject.CreateFolder(sDestDir) = "" ) Then
								sError = DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_NOEXIST")
							End If
						End If
					End If

					If ( sError = "" ) Then
						' export the data
						sError = CreateDomainDir()
						If ( sError = "" ) Then
							Call CreateDomainTxt()
							Call CreateUsersTxt()
							Call CreateAccessibleDomainsTxt()
							Call CreateDomainGroupsTxt()
							Call CreateADVsTxt()
							Call CreateUserDataTxt()
							Call CreateConfigurationsTxt()
							
							sError = CreateColorSchemesDir()
							If ( sError = "" ) Then
								Call CreateCSchemeFiles()
							End If
							sError2 = CreateRightsDir()
							If ( sError2 = "" ) Then
								Call CreateRightsTxt()
								Call CreateAssignedRightsTxt()
								Call CreateInitialRightsTxt()
							Else
								sError = sError & sError2
								sError2 = ""
							End If
							sError2 = CreateTextSchemesDir()
							If ( sError2 = "" ) Then
								Call CreateTSchemeFiles()
							Else
								sError = sError & sError2
								sError2 = ""
							End If
							sError2 = CreateActionsDir()
							If ( sError2 = "" ) Then
								Call CreateActionFiles()
							Else
								sError = sError & sError2
								sError2 = ""
							End If
							sError2 = CreateGroupDir()
							If ( sError2 = "" ) Then
								Call CreateGroupFiles()
								Call DOMAIN_Message(DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_SUCCESS"), "SUCCESS")
							Else
								sError = sError & sError2
								sError2 = ""
							End If
							
							' see if they have Image Gallery installed and export that
							If ( ACCNT_ReturnSystemUnq("IMAGEGALLERY_SYSTEMUNQ") ) Then
								sError2 = CreateImageGalleryDir()
								If ( sError2 = "" ) Then
									Call CreateImageGalleryFiles()
									Call DOMAIN_Message("Image Gallery data successfully exported.", "SUCCESS")
								Else
									sError = sError & sError2
									sError2 = ""
								End If
							End If
							
							' see if they have Online MP3 Radio installed and export that
							If ( ACCNT_ReturnSystemUnq("RADIO_SYSTEMUNQ") ) Then
								sError2 = CreateRadioDir()
								If ( sError2 = "" ) Then
									Call CreateRadioFiles()
									Call DOMAIN_Message("Online MP3 Radio data successfully exported.", "SUCCESS")
								Else
									sError = sError & sError2
									sError2 = ""
								End If
							End If
							
							' see if they have Message Board installed and export that
							If ( ACCNT_ReturnSystemUnq("MSGBOARD_SYSTEMUNQ") ) Then
								sError2 = CreateMsgBoardDir()
								If ( sError2 = "" ) Then
									Call CreateMsgBoardFiles()
									Call DOMAIN_Message("Message Board data successfully exported.", "SUCCESS")
								Else
									sError = sError & sError2
									sError2 = ""
								End If
							End If
							
						End If
					End If
				End If

		End Select
		
		If ( sError <> "" ) Then
			Call DOMAIN_Message(sError, "ERROR")
		End If
		
		Call WriteForm()
		Set rsDB = Nothing
	End Sub
	'************************************************************************************
	

	'************************************************************************************
	'*																					*
	'*	Create the Domain directory and populate the sDomainDir variable for later use.	*
	'*																					*
	'************************************************************************************
	Function CreateDomainDir()
	
		sSQLText = "SELECT Domain FROM DomainInfo (NOLOCK) WHERE DomainUnq = " & iDomainUnq
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			sDomainDir = sDestDir & "\" & Replace(rsDB("Domain"),".","_")
			If ( NOT fsoFileObject.FolderExists(sDomainDir) ) Then
				If ( fsoFileObject.CreateFolder(sDomainDir) = "" ) Then
					CreateDomainDir = DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_CANTCREATE")
				End If
			End If
		Else
			CreateDomainDir = DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_CANTFIND")
		End If
		rsDB.Close
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the Domain.txt file and add the Domain's info.							*
	'*																					*
	'************************************************************************************
	Sub CreateDomainTxt()
		sSQLText = "SELECT * FROM DomainInfo (NOLOCK) WHERE DomainUnq = " & iDomainUnq
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			' Create the file in the sDomainDir directory
			Set fsoTextFile = fsoFileObject.CreateTextFile(sDomainDir & "\Domain.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("DomainUnq,Description,Domain,Type")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("DomainUnq") & vbTab & rsDB("Description") & vbTab & rsDB("Domain") & vbTab & rsDB("Type"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the Users.txt file and add all the users to it whom this is their Home	*
	'*		Domain.																		*
	'*																					*
	'************************************************************************************
	Sub CreateUsersTxt()
		sSQLText = "SELECT * FROM Accounts (NOLOCK) WHERE HomeDomain = " & iDomainUnq & " ORDER BY AccountUnq"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			' Create the file in the sDomainDir directory
			Set fsoTextFile = fsoFileObject.CreateTextFile(sDomainDir & "\Users.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("AccountUnq,Login,Password,AddDate,RemoveDate,HomeDomain,IgnoreGlobal")
			While ( NOT rsDB.EOF )
				' delimit with tab because users can put anything in their login and pw, including , | ~ ^ etc..which r usually delimiters
				fsoTextFile.WriteLine(rsDB("AccountUnq") & vbTab & rsDB("Login") & vbTab & rsDB("Password") & vbTab & rsDB("AddDate") & vbTab & rsDB("RemoveDate") & vbTab & rsDB("HomeDomain") & vbTab & rsDB("IgnoreGlobal"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
	End Sub
	'************************************************************************************


	'************************************************************************************
	'*																					*
	'*	Create the AccessibleDomains.txt file and add all the users and the list of		*
	'*		Domains they can log onto (Accessible Domains).								*
	'*																					*
	'************************************************************************************
	Sub CreateAccessibleDomainsTxt()
		sSQLText = "SELECT M.AccountUnq, M.DomainUnq FROM Accounts A (NOLOCK), AccountDomainMap M (NOLOCK) WHERE A.HomeDomain = " & iDomainUnq & " AND A.AccountUnq = M.AccountUnq ORDER BY M.AccountUnq"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			' Create the file in the sDomainDir directory
			Set fsoTextFile = fsoFileObject.CreateTextFile(sDomainDir & "\AccessibleDomains.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("AccountUnq,DomainUnq")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("AccountUnq") & vbTab & rsDB("DomainUnq"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the DomainGroups.txt file and add the Domain Groups this Domain 			*
	'*		should be in.																*
	'*																					*
	'************************************************************************************
	Sub CreateDomainGroupsTxt()
		sSQLText = "SELECT DomainUnq, GroupUnq FROM DomainGroups (NOLOCK) WHERE DomainUnq = " & iDomainUnq
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			' Create the file in the sDomainDir directory
			Set fsoTextFile = fsoFileObject.CreateTextFile(sDomainDir & "\DomainGroups.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("DomainUnq,GroupUnq")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("DomainUnq") & vbTab & rsDB("GroupUnq"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the ADVs.txt file and add all the ADV information.						*
	'*																					*
	'************************************************************************************
	Sub CreateADVsTxt()
		sSQLText = "SELECT * FROM AccountMap (NOLOCK) WHERE DomainUnq = " & iDomainUnq
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			' Create the file in the sDomainDir directory
			Set fsoTextFile = fsoFileObject.CreateTextFile(sDomainDir & "\ADVs.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("MapName,DataType,Description,Required,Visible,DomainUnq,SystemUnq,RightsLvl,GroupUnq")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("MapName") & vbTab & rsDB("DataType") & vbTab & rsDB("Description") & vbTab & rsDB("Required") & vbTab & rsDB("Visible") & vbTab & rsDB("DomainUnq") & vbTab & rsDB("SystemUnq") & vbTab & rsDB("RightsLvl") & vbTab & rsDB("GroupUnq"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
	End Sub
	'************************************************************************************
	

	'************************************************************************************
	'*																					*
	'*	Create the UserData.txt file and add all the users ADV information whose Home	*
	'*		Domain is the iDomainUnq Domain.											*
	'*																					*
	'************************************************************************************
	Sub CreateUserDataTxt()
		sSQLText = "SELECT * FROM AccountData (NOLOCK) WHERE DomainUnq = " & iDomainUnq
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			' Create the file in the sDomainDir directory
			Set fsoTextFile = fsoFileObject.CreateTextFile(sDomainDir & "\UserData.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("TextSize,VarCharSize,MapName,AccountUnq,ViewLvl,DomainUnq,HomeDomain,LastChange,VarCharData,TextData")
			While ( NOT rsDB.EOF )
				' delimit with tab
				' TextSize is the number of characters the TextData is.
				' VarCharSize is the number of chars the VarCharData is. both these are needed because both fields can have any character in them.
				fsoTextFile.WriteLine(Len(rsDB("TextData")) & vbTab & Len(rsDB("VarCharData")) & vbTab & rsDB("MapName") & vbTab & rsDB("AccountUnq") & vbTab & rsDB("ViewLvl") & vbTab & rsDB("DomainUnq") & vbTab & rsDB("HomeDomain") & vbTab & rsDB("LastChange") & vbTab & rsDB("VarCharData") & vbTab & rsDB("TextData") )
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the Configurations.txt file and add all the Configuration Variables.		*
	'*																					*
	'************************************************************************************
	Sub CreateConfigurationsTxt()
		sSQLText = "SELECT * FROM Configurations (NOLOCK) WHERE DomainUnq = " & iDomainUnq
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			' Create the file in the sDomainDir directory
			Set fsoTextFile = fsoFileObject.CreateTextFile(sDomainDir & "\Configurations.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("ConfConst,Value,Description,DomainUnq")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("ConfConst") & vbTab & rsDB("Value") & vbTab & rsDB("Description") & vbTab & rsDB("DomainUnq"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the ColorSchemes directory and populate the sColorSchemesDir variable for*
	'*		 later use.																	*
	'*																					*
	'************************************************************************************
	Function CreateColorSchemesDir()
	
		sColorSchemesDir = sDomainDir & "\ColorSchemes"
		If ( NOT fsoFileObject.FolderExists(sColorSchemesDir) ) Then
			If ( fsoFileObject.CreateFolder(sColorSchemesDir) = "" ) Then
				CreateColorSchemesDir = DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_NOCREATECOLOR")
			End If
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create each of the color scheme files with all of the color information.		*
	'*																					*
	'************************************************************************************
	Sub CreateCSchemeFiles()
		Dim sCurSchemeName, sLastSchemeName
		
		sSQLText = "SELECT S.SchemeName, M.* FROM ColorMap M (NOLOCK), ColorSchemes S (NOLOCK) WHERE M.DomainUnq = " & iDomainUnq & " AND M.SchemeUnq = S.SchemeUnq ORDER BY M.SchemeUnq, M.ColorConst"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			' Create the file in the sColorSchemesDir directory
			sCurSchemeName = ""
			While ( NOT rsDB.EOF )
				sCurSchemeName = Trim(rsDB("SchemeName"))
				If ( sCurSchemeName <> sLastSchemeName ) Then
					Set fsoTextFile = fsoFileObject.CreateTextFile(sColorSchemesDir & "\" & sCurSchemeName & ".txt", TRUE)
					fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
					fsoTextFile.WriteLine("ColorConst,Value,SchemeUnq,DomainUnq")
				End If
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("ColorConst") & vbTab & rsDB("Value") & vbTab & rsDB("SchemeUnq") & vbTab & rsDB("DomainUnq"))
				sLastSchemeName = sCurSchemeName
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
	End Sub
	'************************************************************************************


	'************************************************************************************
	'*																					*
	'*	Create the Rights directory and populate the sRightsDir variable for			*
	'*		 later use.																	*
	'*																					*
	'************************************************************************************
	Function CreateRightsDir()
	
		sRightsDir = sDomainDir & "\Rights"
		If ( NOT fsoFileObject.FolderExists(sRightsDir) ) Then
			If ( fsoFileObject.CreateFolder(sRightsDir) = "" ) Then
				CreateRightsDir = DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_NOCREATERIGHTS")
			End If
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the Rights.txt file.														*
	'*																					*
	'************************************************************************************
	Sub CreateRightsTxt()
		' Create the Rights.txt
		sSQLText = "SELECT * FROM RightsLookup (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " ORDER BY SystemUnq"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			' Create the file in the sRightsDir directory
			Set fsoTextFile = fsoFileObject.CreateTextFile(sRightsDir & "\Rights.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("DomainUnq,RightsLvl,RightsConst,SystemUnq")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("DomainUnq") & vbTab & rsDB("RightsLvl") & vbTab & rsDB("RightsConst") & vbTab & rsDB("SystemUnq"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the AssignedRights.txt file.												*
	'*																					*
	'************************************************************************************
	Sub CreateAssignedRightsTxt()
		' Create the 
		sSQLText = "SELECT * FROM Rights (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " ORDER BY SystemUnq"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			' Create the file in the sRightsDir directory
			Set fsoTextFile = fsoFileObject.CreateTextFile(sRightsDir & "\AssignedRights.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("AccountUnq,GroupUnq,SystemUnq,DomainUnq,RightsLvl,GrantDate,RevokeDate")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("AccountUnq") & vbTab & rsDB("GroupUnq") & vbTab & rsDB("SystemUnq") & vbTab & rsDB("DomainUnq") & vbTab & rsDB("RightsLvl") & vbTab & rsDB("GrantDate") & vbTab & rsDB("RevokeDate"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the InitialRights.txt file.												*
	'*																					*
	'************************************************************************************
	Sub CreateInitialRightsTxt()
		' Create the 
		sSQLText = "SELECT * FROM InitialRights (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " ORDER BY SystemUnq"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			' Create the file in the sRightsDir directory
			Set fsoTextFile = fsoFileObject.CreateTextFile(sRightsDir & "\InitialRights.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("DomainUnq,SystemUnq,RightsLvl")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("DomainUnq") & vbTab & rsDB("SystemUnq") & vbTab & rsDB("RightsLvl"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the TextSchemes directory and populate the sTextSchemesDir variable for	*
	'*		 later use.																	*
	'*																					*
	'************************************************************************************
	Function CreateTextSchemesDir()
	
		sTextSchemesDir = sDomainDir & "\TextSchemes"
		If ( NOT fsoFileObject.FolderExists(sTextSchemesDir) ) Then
			If ( fsoFileObject.CreateFolder(sTextSchemesDir) = "") Then
				CreateTextSchemesDir = DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_NOCREATETEXT")
			End If
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create each of the text scheme files with all of the text information.			*
	'*																					*
	'************************************************************************************
	Sub CreateTSchemeFiles()
		Dim sCurSchemeName, sLastSchemeName
		
		sSQLText = "SELECT S.SchemeName, M.* FROM TextMap M (NOLOCK), TextSchemes S (NOLOCK) WHERE M.DomainUnq = " & iDomainUnq & " AND M.SchemeUnq = S.SchemeUnq ORDER BY M.SchemeUnq, M.TextConst"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			' Create the file in the sTextSchemesDir directory
			sCurSchemeName = ""
			While ( NOT rsDB.EOF )
				sCurSchemeName = Trim(rsDB("SchemeName"))
				If ( sCurSchemeName <> sLastSchemeName ) Then
					Set fsoTextFile = fsoFileObject.CreateTextFile(sTextSchemesDir & "\" & sCurSchemeName & ".txt", TRUE)
					fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
					fsoTextFile.WriteLine("TextSize,VarCharSize,TextConst,DataType,VarCharData,TextData,SchemeUnq,DomainUnq")
				End If
				' delimit with tab
				fsoTextFile.WriteLine(Len(rsDB("TextData")) & vbTab & Len(rsDB("VarCharData")) & vbTab & rsDB("TextConst") & vbTab & rsDB("DataType") & vbTab & rsDB("VarCharData") & vbTab & rsDB("TextData") & vbTab & rsDB("SchemeUnq") & vbTab & rsDB("DomainUnq"))
				sLastSchemeName = sCurSchemeName
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
	End Sub
	'************************************************************************************
	

	'************************************************************************************
	'*																					*
	'*	Create the Actions directory and populate the sActionsDir variable for			*
	'*		 later use.																	*
	'*																					*
	'************************************************************************************
	Function CreateActionsDir()
	
		sActionsDir = sDomainDir & "\Actions"
		If ( NOT fsoFileObject.FolderExists(sActionsDir) ) Then
			If ( fsoFileObject.CreateFolder(sActionsDir) = "" ) Then
				CreateActionsDir = DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_NOCREATEACTIONS")
			End If
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the Action files.														*
	'*																					*
	'************************************************************************************
	Sub CreateActionFiles()
		Dim iCount
	
		sSQLText = "SELECT * FROM Actions (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " ORDER BY SystemUnq"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			iCount = 0
			While ( NOT rsDB.EOF )
				iCount = iCount + 1
				Set fsoTextFile = fsoFileObject.CreateTextFile(sActionsDir & "\" & iCount & ".txt", TRUE)
				fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
				fsoTextFile.WriteLine(rsDB("Description"))
				fsoTextFile.WriteLine(rsDB("ActionsConst"))
				fsoTextFile.WriteLine(rsDB("DomainUnq"))
				fsoTextFile.WriteLine(rsDB("SystemUnq"))
				fsoTextFile.WriteLine(rsDB("Code"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the Groups directory and populate the sGroupsDir variable for			*
	'*		 later use.																	*
	'*																					*
	'************************************************************************************
	Function CreateGroupDir()
	
		sGroupsDir = sDomainDir & "\Groups"
		If ( NOT fsoFileObject.FolderExists(sGroupsDir) ) Then
			If ( fsoFileObject.CreateFolder(sGroupsDir) = "" ) Then
				CreateActionsDir = DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_NOCREATEGROUP")
			End If
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the GroupMap.txt and Groups.txt files.									*
	'*																					*
	'************************************************************************************
	Sub CreateGroupFiles()

		sSQLText = "SELECT * FROM GroupMap (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " ORDER BY GroupUnq, AccountUnq"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			' Create the file in the sGroupsDir directory
			Set fsoTextFile = fsoFileObject.CreateTextFile(sGroupsDir & "\GroupMap.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("GroupUnq,AccountUnq,NumDays,Position,IgnoreGlobal,DomainUnq")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("GroupUnq") & vbTab & rsDB("AccountUnq") & vbTab & rsDB("NumDays") & vbTab & rsDB("Position") & vbTab & rsDB("IgnoreGlobal") & vbTab & rsDB("DomainUnq"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
		
		sSQLText = "SELECT * FROM Groups (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " ORDER BY GroupUnq"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			' Create the file in the sGroupsDir directory
			Set fsoTextFile = fsoFileObject.CreateTextFile(sGroupsDir & "\Groups.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("GroupUnq,DomainUnq,Name,Description,Type,Rotations,DateBegin")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("GroupUnq") & vbTab & rsDB("DomainUnq") & vbTab & rsDB("Name") & vbTab & rsDB("Description") & vbTab & rsDB("Type") & vbTab & rsDB("Rotations") & vbTab & rsDB("DateBegin"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
	End Sub
	'************************************************************************************


	'************************************************************************************
	'*																					*
	'*	Create the ImageGallery directory and populate the sIGDir variable for			*
	'*		 later use.																	*
	'*																					*
	'************************************************************************************
	Function CreateImageGalleryDir()
	
		sIGDir = sDomainDir & "\ImageGallery"
		If ( NOT fsoFileObject.FolderExists(sIGDir) ) Then
			If ( fsoFileObject.CreateFolder(sIGDir) = "" ) Then
				CreateImageGalleryDir = "Unable to create the Image Gallery directory. No Image Gallery System data has been exported.<br>"
			End If
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the Image Gallery files.													*
	'*																					*
	'************************************************************************************
	Sub CreateImageGalleryFiles()
		Dim DBConnection
	
		Set DBConnection = Server.CreateObject("ADODB.Connection")
		DBConnection.Open DOMAIN_Conf("DSN_IMAGEGALLERY_NAME"), DOMAIN_Conf("DSN_IMAGEGALLERY_LOGIN"), DOMAIN_Conf("DSN_IMAGEGALLERY_PASSWORD")
		sSQLText = "SELECT * FROM Galleries (NOLOCK) WHERE Domain = " & iDomainUnq
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			Set fsoTextFile = fsoFileObject.CreateTextFile(sIGDir & "\Galleries.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("DescriptionSize,GalleryUnq,AccountUnq,Domain,Name,Description,Visibility")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(Len(rsDB("Description")) & vbTab & rsDB("GalleryUnq") & vbTab & rsDB("AccountUnq") & vbTab & rsDB("Domain") & vbTab & rsDB("Name") & vbTab & rsDB("Description") & vbTab & rsDB("Visibility"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
		
		sSQLText = "SELECT N.* FROM Galleries G (NOLOCK), ImagesInGallery N (NOLOCK) WHERE G.Domain = " & iDomainUnq & " AND G.GalleryUnq = N.GalleryUnq"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			Set fsoTextFile = fsoFileObject.CreateTextFile(sIGDir & "\ImagesInGallery.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("ImageUnq,GalleryUnq,AddDate")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("ImageUnq") & vbTab & rsDB("GalleryUnq") & vbTab & rsDB("AddDate"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
		
		sSQLText = "SELECT I.* FROM Galleries G (NOLOCK), ImagesInGallery N (NOLOCK), Images I (NOLOCK) WHERE G.Domain = " & iDomainUnq & " AND G.GalleryUnq = N.GalleryUnq AND I.ImageUnq = N.ImageUnq"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			Set fsoTextFile = fsoFileObject.CreateTextFile(sIGDir & "\Images.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("CommentsSize,ImageUnq,Comments,AltTag,Image,Thumbnail,Rating,NumRaters,NumViews,ImageSize,XSize,YSize,ImageNum")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(Len(rsDB("Comments")) & vbTab & rsDB("ImageUnq") & vbTab & rsDB("Comments") & vbTab & rsDB("AltTag") & vbTab & rsDB("Image") & vbTab & rsDB("Thumbnail") & vbTab & rsDB("Rating") & vbTab & rsDB("NumRaters") & vbTab & rsDB("NumViews") & vbTab & rsDB("ImageSize") & vbTab & rsDB("XSize") & vbTab & rsDB("YSize") & vbTab & rsDB("ImageNum"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
		
		Set DBConnection = Nothing
	End Sub
	'************************************************************************************

	
	'************************************************************************************
	'*																					*
	'*	Create the Radio directory and populate the sRadioDir variable for				*
	'*		 later use.																	*
	'*																					*
	'************************************************************************************
	Function CreateRadioDir()
	
		sRadioDir = sDomainDir & "\Radio"
		If ( NOT fsoFileObject.FolderExists(sRadioDir) ) Then
			If ( fsoFileObject.CreateFolder(sRadioDir) = "" ) Then
				CreateImageGalleryDir = "Unable to create the Radio directory. No Online MP3 Radio System data has been exported.<br>"
			End If
		End If
		
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the Radio files.															*
	'*																					*
	'************************************************************************************
	Sub CreateRadioFiles()
		Dim RadioConnection
	
		Set RadioConnection = Server.CreateObject("ADODB.Connection")
		RadioConnection.Open DOMAIN_Conf("DSN_RADIO_NAME"), DOMAIN_Conf("DSN_RADIO_LOGIN"), DOMAIN_Conf("DSN_RADIO_PASSWORD")
		sSQLText = "SELECT * FROM PlayLists (NOLOCK) WHERE DomainUnq = " & iDomainUnq
		rsDB.Open sSQLText, RadioConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			Set fsoTextFile = fsoFileObject.CreateTextFile(sRadioDir & "\PlayLists.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("DescriptionSize,PlayListUnq,AccountUnq,Name,Description,Genre,Visibility,DomainUnq")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(Len(rsDB("Description")) & vbTab & rsDB("PlayListUnq") & vbTab & rsDB("AccountUnq") & vbTab & rsDB("Name") & vbTab & rsDB("Description") & vbTab & rsDB("Genre") & vbTab & rsDB("Visibility") & vbTab & rsDB("DomainUnq"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
		
		sSQLText = "SELECT N.* FROM PlayLists P (NOLOCK), SongsInPL N (NOLOCK) WHERE P.DomainUnq = " & iDomainUnq & " AND P.PlayListUnq = N.PlayListUnq"
		rsDB.Open sSQLText, RadioConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			Set fsoTextFile = fsoFileObject.CreateTextFile(sRadioDir & "\SongsInPL.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("SongUnq,PlayListUnq,AddDate")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("SongUnq") & vbTab & rsDB("PlayListUnq") & vbTab & rsDB("AddDate"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
		
		sSQLText = "SELECT S.* FROM PlayLists P (NOLOCK), SongsInPL N (NOLOCK), Songs S (NOLOCK) WHERE P.DomainUnq = " & iDomainUnq & " AND P.PlayListUnq = N.PlayListUnq AND S.SongUnq = N.SongUnq"
		rsDB.Open sSQLText, RadioConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			Set fsoTextFile = fsoFileObject.CreateTextFile(sRadioDir & "\Songs.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("DescriptionSize,SongUnq,Description,Rating,NumRaters,Artist,CD,FileName,Directory,Title,Year,Genre,Track,DomainUnq")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(Len(rsDB("Description")) & vbTab & rsDB("SongUnq") & vbTab & rsDB("Description") & vbTab & rsDB("Rating") & vbTab & rsDB("NumRaters") & vbTab & rsDB("Artist") & vbTab & rsDB("CD") & vbTab & rsDB("FileName") & vbTab & rsDB("Directory") & vbTab & rsDB("Title") & vbTab & rsDB("Year") & vbTab & rsDB("Genre") & vbTab & rsDB("Track") & vbTab & rsDB("DomainUnq"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
		
		Set RadioConnection = Nothing
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Create the MessageBoard directory and populate the sMBDir variable for			*
	'*		 later use.																	*
	'*																					*
	'************************************************************************************
	Function CreateMsgBoardDir()
	
		sMBDir = sDomainDir & "\MessageBoard"
		If ( NOT fsoFileObject.FolderExists(sMBDir) ) Then
			If ( fsoFileObject.CreateFolder(sMBDir) = "" ) Then
				CreateImageGalleryDir = "Unable to create the Message Board directory. No Message Board System data has been exported.<br>"
			End If
		End If
		
	End Function
	'************************************************************************************

	'************************************************************************************
	'*																					*
	'*	Create the Message Board files.													*
	'*																					*
	'************************************************************************************
	Sub CreateMsgBoardFiles()
		Dim RadioConnection
	
		Set DBConnection = Server.CreateObject("ADODB.Connection")
		DBConnection.Open DOMAIN_Conf("DSN_MSGBOARD_NAME"), DOMAIN_Conf("DSN_MSGBOARD_LOGIN"), DOMAIN_Conf("DSN_MSGBOARD_PASSWORD")
		sSQLText = "SELECT A.* FROM Admin A (NOLOCK), Conference C (NOLOCK) WHERE C.DomainUnq = " & iDomainUnq & " AND A.ConfUnq = C.ConfUnq"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			Set fsoTextFile = fsoFileObject.CreateTextFile(sMBDir & "\Admin.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("AccountUnq,ConfUnq")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("AccountUnq") & vbTab & rsDB("ConfUnq"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
		
		sSQLText = "SELECT * FROM Conference (NOLOCK) WHERE DomainUnq = " & iDomainUnq
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			Set fsoTextFile = fsoFileObject.CreateTextFile(sMBDir & "\Conference.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("DescriptionSize,SigSize,DomainUnq,ConfUnq,Parent,Name,NumThreads,NumChildren,Description,Sig")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(Len(rsDB("Description")) & vbTab & Len(rsDB("Sig")) & vbTab & rsDB("DomainUnq") & vbTab & rsDB("ConfUnq") & vbTab & rsDB("Parent") & vbTab & rsDB("Name") & vbTab & rsDB("NumThreads") & vbTab & rsDB("NumChildren") & vbTab & rsDB("Description") & vbTab & rsDB("Sig"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
		
		sSQLText = "SELECT M.* FROM Conference C (NOLOCK), Message M (NOLOCK) WHERE C.DomainUnq = " & iDomainUnq & " AND C.ConfUnq = M.ConfUnq"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			Set fsoTextFile = fsoFileObject.CreateTextFile(sMBDir & "\Message.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("BodySize,MsgUnq,ThreadUnq,ConfUnq,Parent,AccountUnq,Subject,Body,DateChanged,NumReaders,Rating,NumRaters,FileLoc,FileName,FileSize,NumDownloads")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(Len(rsDB("Body")) & vbTab & rsDB("MsgUnq") & vbTab & rsDB("ThreadUnq") & vbTab & rsDB("ConfUnq") & vbTab & rsDB("Parent") & vbTab & rsDB("AccountUnq") & vbTab & rsDB("Subject") & vbTab & rsDB("Body") & vbTab & rsDB("DateChanged") & vbTab & rsDB("NumReaders") & vbTab & rsDB("Rating") & vbTab & rsDB("NumRaters") & vbTab & rsDB("FileLoc") & vbTab & rsDB("FileName") & vbTab & rsDB("FileSize") & vbTab & rsDB("NumDownloads"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
		
		sSQLText = "SELECT E.* FROM Conference C (NOLOCK), Message M (NOLOCK), EmailNotifications E (NOLOCK) WHERE C.DomainUnq = " & iDomainUnq & " AND C.ConfUnq = M.ConfUnq AND M.ThreadUnq = E.ThreadUnq"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			Set fsoTextFile = fsoFileObject.CreateTextFile(sMBDir & "\EmailNotifications.txt", TRUE)
			fsoTextFile.WriteLine(CStr(SITEBEATER_VERSION))
			fsoTextFile.WriteLine("ThreadUnq,MsgUnq,AccountUnq")
			While ( NOT rsDB.EOF )
				' delimit with tab
				fsoTextFile.WriteLine(rsDB("ThreadUnq") & vbTab & rsDB("MsgUnq") & vbTab & rsDB("AccountUnq"))
				rsDB.MoveNext
			Wend
		End If
		rsDB.Close
		
		Set DBConnection = Nothing
	End Sub
	'************************************************************************************



	'************************************************************************************
	'*																					*
	'*	This is the function to write out the form.										*
	'*																					*
	'************************************************************************************
	Sub WriteForm()
		%>
		<script language='JavaScript1.2' type='text/javascript'>
	
			function SubmitForm(sAction){
				document.ExportDomains.sAction.value = sAction;
				document.ExportDomains.submit();
			}
			
		</script>
		<center>
		<form name='ExportDomains' action='Default.asp' method='post'>
		<%
		aVariables(0) = "sAction"
		aValues(0) = ""
		Response.Write DOMAIN_Link("P")
		%>
		<table cellpadding=0 cellspacing=0 border=0 width=671>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
			<tr>
				<td>
					<font color='<%=DOMAIN_Color("DomainsPageText")%>'>
					<font size=+1><b><%=DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_TITLE")%></b></font>
					<br>
					<%=DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_HEADER")%>
					<br><br>
					<table cellpadding=2 cellspacing=0 border=0 width=671>
						<tr>
							<td><font color='<%=DOMAIN_Color("DomainsPageText")%>'><b><%=DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_DOMAIN")%></b></td>
							<td><font color='<%=DOMAIN_Color("DomainsPageText")%>'><b><%=DOMAIN_Text("DOMAINS_MANAGE_DOMAINS_EXPORT_DESTPATH")%></b></td>
						</tr>
						<tr>
							<td><%Call DOMAINS_DomainsDropDown("SB_MD_EXPORT", "", "")%></td>
							<td><input type='text' name='sDestDir' value='<%=sDestDir%>' size=60></td>
						</tr>
					</table>
					<font size=-2>
					<%=DOMAIN_Text("DOMAINS_DOMAIN_EXPORT_FOOTER")%>
				</td>
			</tr>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
		</table>
		</form>
		<%
	End Sub
	'************************************************************************************
%>