<!--#INCLUDE VIRTUAL="/WS_Content/Includes/i_Includes.asp"-->
<%
	Response.Buffer = TRUE
	Dim sDescription, sSystemConst, sSystemUnq
	
	Dim sSQLText, rsDB
	
	Call DISP_Action("SB_DOMAINS_OPEN")
	Call DISP_Action("SB_DOMAINS_MANAGE_SYSTEMS_NEW")
	If   (ACCNT_AnyDomain("SB_MS_CREATE_NEW")) Then
		Call Main()
	Else
		Call DOMAIN_Message(DOMAIN_Text("DOM_SYS_RIGHTS"), "ERROR")
	End If
	Call DISP_Action("SB_DOMAINS_CLOSE")
	Response.Flush
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub Main()
		Dim sAction, sError, sTemp
		
		Set rsDB = CreateObject("ADODB.Recordset")	
		sAction = Request("sAction")
		
		sDescription = Trim(Request("sDescription"))
		sSystemConst = Trim(Request("sSystemConst"))
		sSystemUnq = Trim(Request("sSystemUnq"))
		
		Select Case sAction
			Case "AddSystem"
				If ( NOT ACCNT_AnyDomain("SB_MS_CREATE_NEW") ) Then
					sError = DOMAIN_Text("DOM_SYS_RIGHTS")
				Else
					' See if it already exists then add it.
					If ( sSystemUnq = "" ) Then
						sError = DOMAIN_Text("DOMAINS_SYSTEMS_BLANK_ID")
					End If
					If ( NOT IsNumeric(sSystemUnq) ) Then
						sError = sError & DOMAIN_Text("DOMAINS_SYSTEMS_NUM_ID")
					Else
						If (SystemUnqExists()) Then
							sError = sError & DOMAIN_Text("DOMAINS_SYSTEMS_ID_EXISTS2")
						End If
					End If
					If (sError = "") Then
						If (SystemConstExists()) Then
							sError = DOMAIN_Text("DOMAINS_SYSTEMS_CONST_EXISTS2")
						Else
							If ( sSystemConst <> "" ) Then
								DBConnection.Execute "INSERT INTO Systems VALUES (" & sSystemUnq & ", '" & SQLEncode(sSystemConst) & "', '" & SQLEncode(sDescription) & "')"
								Call DOMAIN_Log(25, "", sSystemUnq, "", 0, "", 0, "V", "I", sSystemUnq, "")
								Call DOMAIN_Log(26, "", sSystemUnq, "", 0, "", 0, "V", "I", SQLEncode(sSystemConst), "")
								Call DOMAIN_Log(27, "", sSystemUnq, "", 0, "", 0, "V", "I", SQLEncode(sDescription), "")
								Call DOMAIN_Message(DOMAIN_Text("DOMAINS_SYSTEMS_CREATED"), "SUCCESS")
								sDescription = ""
								sSystemConst = ""
								sSystemUnq = ""
							Else
								sError = sError & DOMAIN_Text("DOMAINS_SYSTEMS_NO_CONST")
							End If
						End If
					End If
				End If
		End Select
		
		If ( sError <> "" ) Then
			Call DOMAIN_Message(sError, "ERROR")
		End If
		
		Call WriteForm()
		Set rsDB = Nothing
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Checks to see if the System Constant exists or not.								*
	'*																					*
	'************************************************************************************
	Function SystemConstExists()
		SystemConstExists = FALSE
		sSQLText = "SELECT * FROM Systems WHERE SystemConst = '" & SQLEncode(sSystemConst) & "'"
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			SystemConstExists = TRUE
		End If
		rsDB.Close
	End Function
	'************************************************************************************
	
	'************************************************************************************
	'*																					*
	'*	Checks to see if the System Unq exists or not.									*
	'*																					*
	'************************************************************************************
	Function SystemUnqExists()
		SystemUnqExists = FALSE
		sSQLText = "SELECT * FROM Systems WHERE SystemUnq = " & sSystemUnq
		rsDB.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsDB.EOF ) Then
			SystemUnqExists = TRUE
		End If
		rsDB.Close
	End Function
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This is the function to write out the form.										*
	'*																					*
	'************************************************************************************
	Sub WriteForm()
		Dim sBGColor, rsDomain
		
		sBGColor = DOMAIN_Color("AccountsBGColor2")
		sDescription = Replace(sDescription, "'", "&#39;")
		sSystemConst = Replace(sSystemConst, "'", "&#39;")
		%>
		<script language='JavaScript1.2' type='text/javascript'>
	
			function SubmitForm(sAction){
				document.ManageSystems.sAction.value = sAction;
				document.ManageSystems.submit();
			}
			
		</script>
		<form name='ManageSystems' action='New.asp' method='post'>
		<%
		aVariables(0) = "sAction"
		aVariables(1) = "iDBLoc2"
		aVariables(2) = "iDomainUnq2"
		aValues(0) = "New"
		aValues(1) = Request("iDBLoc2")
		aValues(2) = Request("iDomainUnq2")
		Response.Write DOMAIN_Link("P")
		
		Call DOMAIN_Link_Clear()
		%>
		<table cellpadding=0 cellspacing=0 border=0 width=671>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
			<tr>
				<td>
					<font color='<%=DOMAIN_Color("DomainsPageText")%>'>
					<font size=+1><b><%=DOMAIN_Text("DOMAINS_SYSTEMS_HEAD2")%></b></font>
					<br>
					<table cellpadding=2 cellspacing=0 border=0 width=671>
						<tr>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>'><b><%=DOMAIN_Text("DOMAINS_SYSTEMS_ID")%></b></td>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>'><b><%=DOMAIN_Text("DOMAINS_SYSTEMS_CONST")%></b></td>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("AccountsTextColor2")%>'><b><%=DOMAIN_Text("DOMAINS_SYSTEMS_DESC")%></b></td>
						</tr>
						<%sBGColor = DOMAIN_Color("AccountsPageBGColor")%>
						<tr>
							<td bgcolor=<%=sBGColor%>><input type='text' name='sSystemUnq' value='<%=sSystemUnq%>' size=3 maxlength=5></td>
							<td bgcolor=<%=sBGColor%>><input type='text' name='sSystemConst' value='<%=sSystemConst%>' size=23 maxlength=250></td>
							<td bgcolor=<%=sBGColor%>><input type='text' name='sDescription' value='<%=sDescription%>' size=55 maxlength=250></td>
						</tr>
					</table>
					<table cellpadding=2 cellspacing=0 border=0 width=671>
						<%sBGColor = DOMAIN_Color("AccountsBGColor1")%>
						<tr>
							<td bgcolor=<%=sBGColor%> align=center>
								<input type="button" value=" <%=DOMAIN_Text("DOMAINS_SYSTEMS_ADD_NEW")%> " onClick='SubmitForm("AddSystem")'>
							</td>
						</tr>
					</table>
				</td>
			</tr>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
		</table>
		</form>
		<%
	End Sub
	'********************************************************************************
%>
