<!--#INCLUDE FILE="../Includes/i_ImageGallery.asp"-->
<!--#INCLUDE FILE="../Includes/i_Upload.asp"-->
<%
	Response.Buffer = TRUE
	Dim iDomainUnq, rsImageGallery, sSQLText, bEZPrintsAccount, bUseEZPrints

	Call DISP_Action("SB_GALLERIES_ADMINOPEN")
	Call DISP_Action("SB_GALLERIES_MANAGE_IMAGES")
	If   (ACCNT_AnyDomain("SB_IG_ADMIN_ALL")) Or _
		 (ACCNT_AnyDomain("SB_IG_CREATE_GALLERY")) Then
		Call Main()
	Else
		Call WriteScripts()
		Call DOMAIN_Message(DOMAIN_Text("GALLERY_SYS_RIGHTS"), "ERROR")
	End If
	Call DISP_Action("SB_GALLERIES_ADMINCLOSE")
	Response.Flush
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub Main()
		Dim sAction, sError, sSuccess, sCheckbox, sCurImagePos
		Dim sEZPrintsImage, sRadio, iImageUnq
		
		Set rsImageGallery = Server.CreateObject("ADODB.recordset")
		
		sAction				= Trim(Request("sAction"))
		iDomainUnq			= Trim(Request("iDomainUnq"))
		iGalleryUnq			= Trim(Request("iGalleryUnq"))
		If ( iDomainUnq = "" ) Then
			iDomainUnq = ACCNT_GetDomainW_Rights("SB_IG_ADMIN_ALL", "SB_IG_CREATE_GALLERY", "")
		End If
		bEZPrintsAccount	= G_ADMINISTRATION_EZPrintsAccount(iDomainUnq)
		
		If ( sAction = "UpdateDomainUnq" ) Then
			iGalleryUnq = ""
		End If
		
		If ( iGalleryUnq = "" ) Then
			If ( ACCNT_SpecificDomain("SB_IG_ADMIN_ALL", iDomainUnq) ) Then
				sSQLText = "SET ROWCOUNT 1 SELECT GalleryUnq FROM Galleries (NOLOCK) WHERE Domain = " & iDomainUnq & " ORDER BY Name SET ROWCOUNT 0"
			Else
				sSQLText = "SET ROWCOUNT 1 SELECT GalleryUnq FROM Galleries (NOLOCK) WHERE Domain = " & iDomainUnq & " AND AccountUnq = " & iLoginAccountUnq & " ORDER BY Name SET ROWCOUNT 0"
			End If
			rsImageGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsImageGallery.EOF ) Then
				iGalleryUnq = rsImageGallery("GalleryUnq")
			Else
				iGalleryUnq = -1
			End If
			rsImageGallery.Close
		End If

		Select Case sAction
			Case "MoveUp"
				iImageUnq = Trim(Request("iMoveImageUnq"))
				If ( G_ADMINISTRATION_IsGalleryOwner(iLoginAccountUnq, iGalleryUnq, iImageUnq) Or ACCNT_SpecificDomain("SB_IG_ADMIN_ALL", iDomainUnq) ) Then
					sSQLText = "SET ROWCOUNT 2 SELECT * FROM Images I (NOLOCK), ImagesInGallery IG (NOLOCK) WHERE I.ImageUnq = IG.ImageUnq AND IG.GalleryUnq = " & iGalleryUnq & " AND IG.Position <= (SELECT Position FROM ImagesInGallery (NOLOCK) WHERE ImageUnq = " & iImageUnq & " AND GalleryUnq = " & iGalleryUnq & ") ORDER BY IG.Position DESC SET ROWCOUNT 0"
					rsImageGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
					If ( Not rsImageGallery.EOF ) Then
						sCurImagePos = rsImageGallery("Position")
						rsImageGallery.MoveNext
						If ( Not rsImageGallery.EOF ) Then	' if this is false, then the admin is trying to move the last image past the end
							DBConnection.Execute "UPDATE ImagesInGallery SET Position = " & rsImageGallery("Position") & " WHERE ImageUnq = " & iImageUnq & " AND GalleryUnq = " & iGalleryUnq
							DBConnection.Execute "UPDATE ImagesInGallery SET Position = " & sCurImagePos & " WHERE ImageUnq = " & rsImageGallery("ImageUnq") & " AND GalleryUnq = " & iGalleryUnq
						End If
					End If
					rsImageGallery.Close
				Else
					sError = DOMAIN_Text("GALLERY_IMAGES_NOTOWNER")
				End If
			Case "MoveDown"
				iImageUnq = Trim(Request("iMoveImageUnq"))
				If ( G_ADMINISTRATION_IsGalleryOwner(iLoginAccountUnq, iGalleryUnq, iImageUnq) Or ACCNT_SpecificDomain("SB_IG_ADMIN_ALL", iDomainUnq) ) Then
					sSQLText = "SET ROWCOUNT 2 SELECT * FROM Images I (NOLOCK), ImagesInGallery IG (NOLOCK) WHERE I.ImageUnq = IG.ImageUnq AND IG.GalleryUnq = " & iGalleryUnq & " AND IG.Position >= (SELECT Position FROM ImagesInGallery (NOLOCK) WHERE ImageUnq = " & iImageUnq & " AND GalleryUnq = " & iGalleryUnq & ") ORDER BY IG.Position ASC SET ROWCOUNT 0"
					rsImageGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
					If ( Not rsImageGallery.EOF ) Then
						sCurImagePos = rsImageGallery("Position")
						rsImageGallery.MoveNext
						If ( Not rsImageGallery.EOF ) Then	' if this is false, then the admin is trying to move the last image past the end
							DBConnection.Execute "UPDATE ImagesInGallery SET Position = " & rsImageGallery("Position") & " WHERE ImageUnq = " & iImageUnq & " AND GalleryUnq = " & iGalleryUnq
							DBConnection.Execute "UPDATE ImagesInGallery SET Position = " & sCurImagePos & " WHERE ImageUnq = " & rsImageGallery("ImageUnq") & " AND GalleryUnq = " & iGalleryUnq
						End If
					End If
					rsImageGallery.Close
				Else
					sError = DOMAIN_Text("GALLERY_IMAGES_NOTOWNER")
				End If
			Case "DeleteImage"
				If ( NOT ACCNT_SpecificDomain("SB_IG_ADMIN_ALL", iDomainUnq) ) Then
					If ( NOT ACCNT_SpecificDomain("SB_IG_CREATE_GALLERY", iDomainUnq) ) Then
						sError = DOMAIN_Text("GALLERY_SYS_RIGHTS")
					End If
				End If

				If ( sError = "" ) Then
					For Each sCheckbox In Request.Form
						If ( InStr(sCheckbox, "sDeleteI") > 0 ) Then
							iImageUnq = Replace(sCheckbox, "sDeleteI", "")
							If ( G_ADMINISTRATION_IsGalleryOwner(iLoginAccountUnq, iGalleryUnq, iImageUnq) Or ACCNT_SpecificDomain("SB_IG_ADMIN_ALL", iDomainUnq) ) Then
								' Decrement (by 1) all ImageNum's AFTER the one we are deleting.
								sSQLText = "SELECT I.ImageUnq, IG.Position FROM Images I (NOLOCK), ImagesInGallery IG (NOLOCK) WHERE IG.GalleryUnq = " & iGalleryUnq & " AND I.ImageUnq = IG.ImageUnq AND IG.Position > (SELECT Position FROM ImagesInGallery (NOLOCK) WHERE ImageUnq = " & iImageUnq & " AND GalleryUnq = " & iGalleryUnq & ") ORDER BY IG.Position"
								rsImageGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
								While (NOT rsImageGallery.EOF)
									DBConnection.Execute "UPDATE ImagesInGallery SET Position = " & (rsImageGallery("Position") - 1) & " WHERE ImageUnq = " & rsImageGallery("ImageUnq") & " AND GalleryUnq = " & iGalleryUnq
									rsImageGallery.MoveNext
								Wend
								rsImageGallery.Close
								
								' must also delete all the images
								Call G_UPLOAD_DelFiles(iImageUnq, TRUE)
								
								DBConnection.Execute "DELETE FROM IGECards WHERE ImageUnq = " & iImageUnq
								DBConnection.Execute "DELETE FROM Images WHERE ImageUnq = " & iImageUnq
								DBConnection.Execute "DELETE FROM ImagesInGallery WHERE ImageUnq = " & iImageUnq	' deletes the primary image and all references
								DBConnection.Execute "DELETE FROM IGImageCRs WHERE ImageUnq = " & iImageUnq
								DBConnection.Execute "DELETE FROM IGImageProds WHERE ImageUnq = " & iImageUnq
								DBConnection.Execute "DELETE FROM IGMiscLinks WHERE ImageUnq = " & iImageUnq
								DBConnection.Execute "DELETE FROM IGSearchResults WHERE ImageUnq = " & iImageUnq
								
								If ( sSuccess = "" ) Then
									sSuccess = DOMAIN_Text("GALLERY_IMAGES_DEL_OK")
								End If
							Else
								If ( sError = "" ) Then
									sError = DOMAIN_Text("GALLERY_IMAGES_NOTOWNER_DEL")
								End If
							End If
						End If
						
						' search for images being referenced and remove them
						If ( InStr(sCheckbox, "sDeleteR") > 0 ) Then
							iImageUnq = Replace(sCheckbox, "sDeleteR", "")
							If ( G_ADMINISTRATION_IsGalleryOwner(iLoginAccountUnq, iGalleryUnq, iImageUnq) Or ACCNT_SpecificDomain("SB_IG_ADMIN_ALL", iDomainUnq) ) Then
								' Decrement (by 1) all ImageNum's AFTER the one we are deleting.
								sSQLText = "SELECT I.ImageUnq, IG.Position FROM Images I (NOLOCK), ImagesInGallery IG (NOLOCK) WHERE IG.GalleryUnq = " & iGalleryUnq & " AND I.ImageUnq = IG.ImageUnq AND IG.Position > (SELECT Position FROM ImagesInGallery (NOLOCK) WHERE ImageUnq = " & iImageUnq & " AND GalleryUnq = " & iGalleryUnq & ") ORDER BY IG.Position"
								rsImageGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
								While (NOT rsImageGallery.EOF)
									DBConnection.Execute "UPDATE ImagesInGallery SET Position = " & (rsImageGallery("Position") - 1) & " WHERE ImageUnq = " & rsImageGallery("ImageUnq") & " AND GalleryUnq = " & iGalleryUnq
									rsImageGallery.MoveNext
								Wend
								rsImageGallery.Close
								
								DBConnection.Execute "DELETE FROM IGECards WHERE ImageUnq = " & iImageUnq & " AND GalleryUnq = " &  iGalleryUnq
								DBConnection.Execute "DELETE FROM ImagesInGallery WHERE ImageUnq = " & iImageUnq & " AND GalleryUnq = " &  iGalleryUnq
								DBConnection.Execute "DELETE FROM IGSearchResults WHERE ImageUnq = " & iImageUnq & " AND GalleryUnq = " &  iGalleryUnq
								
								If ( sSuccess = "" ) Then
									sSuccess = DOMAIN_Text("GALLERY_IMAGES_DEL_OK")
								End If
							Else
								If ( sError = "" ) Then
									sError = DOMAIN_Text("GALLERY_IMAGES_NOTOWNER_DEL")
								End If
							End If
						End If
					Next
				End If
				
			Case "Update"
			
				For Each sRadio In Request.Form
					If ( InStr(sRadio, "bUseEZPrints") > 0 ) Then
						bUseEZPrints = Request(sRadio)
						iImageUnq = Replace(sRadio, "bUseEZPrints", "")
						sEZPrintsImage = Request(iImageUnq & "sEZPrintsImage")
				
						DBConnection.Execute "UPDATE Images SET EZPrints = '" & bUseEZPrints & sEZPrintsImage & "' WHERE ImageUnq = " & iImageUnq
					End If
				Next

		End Select

		' Pagination variables -- begin
		iNumPerPage = 20
		iTtlNumItems = Trim(Request("iTtlNumItems"))
		If ( iTtlNumItems = "" ) Then
			iTtlNumItems = 0
		Else
			iTtlNumItems = CDbl(iTtlNumItems)
		End If
		If IsNull(Request("iDBLoc")) Or Trim(Request("iDBLoc"))="" Then
			iDBLoc = 0
		Else
			iDBLoc = CDbl(Request("iDBLoc"))
			If (iDBLoc<0) Then
				iDBLoc = 0
			End If
		End If
		' must reset the position in the db and the ttlnumitems when changing the domain or system drop-down menu
		' must also reset them if colors have been deleted
		Select Case sAction
			Case "UpdateDomainUnq"
				iDBLoc = 0
				iTtlNumItems = 0
			Case "UpdateGalleryUnq"
				iDBLoc = 0
				iTtlNumItems = 0
			Case "DeleteImage"
				iTtlNumItems = 0
		End Select
		
		' Get ttl num of items from the database if it's not already in the QueryString
		if (iTtlNumItems = 0) then
			sSQLText = "SELECT Count(*) FROM Galleries G (NOLOCK), ImagesInGallery IG (NOLOCK) WHERE G.GalleryUnq = " & iGalleryUnq & " AND IG.GalleryUnq = " & iGalleryUnq
			rsImageGallery.Open sSQLText, DBConnection
			If Not(rsImageGallery.EOF) Then
				iTtlNumItems = rsImageGallery(0)
			End If
			rsImageGallery.Close
		end if
		' Pagination variables -- end
		
		If ( sError <> "" ) Then
			Call DOMAIN_Message(sError, "ERROR")
		End If
		If ( sSuccess <> "" ) Then
			Call DOMAIN_Message(sSuccess, "SUCCESS")
		End If
		
		Call WriteScripts()
		Call WriteForm()
		Set rsImageGallery = Nothing
	End Sub
	'************************************************************************************

	'************************************************************************************
	'*																					*
	'*	This is the function to write out the form.										*
	'*																					*
	'************************************************************************************
	Sub WriteForm()
		Dim sSQLText, sImage, iPosition, sThumbnail, sAccountUnq, iTempDN
		Dim sBGColor, sTextColor, x, sLinkColor, iPrimaryG, iPrimaryD
		Dim sColor1, sColor2, sColor3, sColor4, bIsImage, bIsReferenced
		Dim bAddProdRights, bAddCRRights, bAddCustFieldsRights, bReference
		Dim aXSize, aYSize, aAltImage, aImageSize, bFoundAlt, iPos, sTemp
		Dim sColor5, sColor6, bWatermarkRights, bManipulateRights

		ReDim aXSize(4)
		ReDim aYSize(4)
		ReDim aAltImage(4)
		ReDim aImageSize(4)
		
		If ( ( ACCNT_SpecificDomain("SB_IG_ADMIN_ALL", iDomainUnq) ) Or ( ACCNT_SpecificDomain("SB_IG_ADD_PROD_2IMAGES", iDomainUnq) ) ) Then
			bAddProdRights = TRUE
		Else
			bAddProdRights = FALSE
		End If
		If ( ( ACCNT_SpecificDomain("SB_IG_ADMIN_ALL", iDomainUnq) ) Or ( ACCNT_SpecificDomain("SB_IG_ADD_CR_2IMAGES", iDomainUnq) ) ) Then
			bAddCRRights = TRUE
		Else
			bAddCRRights = FALSE
		End If
		If ( ( ACCNT_SpecificDomain("SB_IG_ADD_CF_IMAGE", iDomainUnq) ) Or ( ACCNT_SpecificDomain("SB_IG_EDIT_CF_DATA_IMAGE", iDomainUnq) ) Or ( ACCNT_SpecificDomain("SB_IG_EDIT_CF_IMAGE", iDomainUnq) ) Or ( ACCNT_SpecificDomain("SB_IG_DEL_CF_IMAGE", iDomainUnq) ) ) Then
			bAddCustFieldsRights = TRUE
		Else
			bAddCustFieldsRights = FALSE
		End If
		If ( ( ACCNT_SpecificDomain("SB_IG_REF_GALLERY", iDomainUnq) ) Or ( ACCNT_SpecificDomain("SB_IG_REF_DOMAIN", iDomainUnq) ) ) Then
			bReference = TRUE
		Else
			bReference = FALSE
		End If
		If ( ( ACCNT_SpecificDomain("SB_IG_ADD_WATERMARK", iDomainUnq) ) Or ( ACCNT_SpecificDomain("SB_IG_ADMIN_ALL", iDomainUnq) ) ) Then
			bWatermarkRights = TRUE
		Else
			bWatermarkRights = FALSE
		End If
		If ( ( ACCNT_SpecificDomain("SB_IG_MANIPULATE_IMAGE", iDomainUnq) ) Or ( ACCNT_SpecificDomain("SB_IG_ADMIN_ALL", iDomainUnq) ) ) Then
			bManipulateRights = TRUE
		Else
			bManipulateRights = FALSE
		End If		
	
		%>
		<form name='ManageImages' action='Default.asp' method='post'>
		<%
		aVariables(0) = "sAction"
		aVariables(1) = "iTtlNumItems"
		aVariables(2) = "iDBLoc"
		aVariables(3) = "iMoveImageUnq"
		aVariables(4) = "iMoveImagePos"
		aValues(0) = "New"
		aValues(1) = iTtlNumItems
		aValues(2) = iDBLoc
		aValues(3) = 0
		aValues(4) = 0
		Response.Write DOMAIN_Link("P")
		%>
		<table cellpadding=0 cellspacing=0 border=0 width=671>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
			<tr>
				<td>
					<font color='<%=DOMAIN_Color("GalleriesPageText")%>'>
					<font size=+1><b><%=DOMAIN_Text("GALLERY_IMAGES_HEAD")%></b></font>
					<br><br>
					<table width=671>
						<tr>
							<td><font color='<%=DOMAIN_Color("GalleriesPageText")%>'><b><%=DOMAIN_Text("GALLERY_DOMAIN")%></b></font></td>
							<td><font color='<%=DOMAIN_Color("GalleriesPageText")%>'><b><%=DOMAIN_Text("GALLERY_IMAGES_GALLERY")%></b></font></td>
						</tr>
						<tr>
							<td>
								<%Call DOMAINS_DomainsDropDown("SB_IG_ADMIN_ALL", "SB_IG_CREATE_GALLERY", "")%>
							</td>
							<td>
								<select name='iGalleryUnq' onChange='SubmitForm("UpdateGalleryUnq");'>
									<%
									If ( ACCNT_SpecificDomain("SB_IG_ADMIN_ALL", iDomainUnq) ) Then
										sSQLText = "SELECT GalleryUnq, Name FROM Galleries (NOLOCK) WHERE Domain = " & iDomainUnq & " ORDER BY Name"
									Else
										sSQLText = "SELECT GalleryUnq, Name FROM Galleries (NOLOCK) WHERE Domain = " & iDomainUnq & " AND AccountUnq = " & iLoginAccountUnq & " ORDER BY Name"
									End If
									rsImageGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
									If ( NOT rsImageGallery.EOF ) Then
										While ( NOT rsImageGallery.EOF )
											If ( iGalleryUnq = Trim(CStr(rsImageGallery("GalleryUnq"))) ) Then
												Response.Write "<option value='" & rsImageGallery("GalleryUnq") & "' Selected>" & Server.HTMLEncode(rsImageGallery("Name")) & "</option>"
											Else
												Response.Write "<option value='" & rsImageGallery("GalleryUnq") & "'>" & Server.HTMLEncode(rsImageGallery("Name")) & "</option>"
											End If
											rsImageGallery.MoveNext
										Wend
									Else
										Response.Write "<option value='-1'>" & DOMAIN_Text("GALLERIES_MANAGE_NO_GAL") & "</option>"
									End If
									rsImageGallery.Close
									%>
								</select>
							</td>
						</tr>
					</table>
					<%If ( CStr(iDomainUnq) <> Trim(CStr(iDomainName)) ) Then%>
					<br><b><%=DOMAIN_Text("GALLERY_IMAGES_NOTONDOMAIN")%></b><br><br>
					<%End If%>
					<table cellpadding=2 cellspacing=0 border=0 width=671>
						<tr>
							<td align=center bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("GalleriesTextColor2")%>'><b><%=DOMAIN_Text("GALLERY_IMAGES_ID")%></b></td>
							<td bgcolor=<%=sBGColor%>>&nbsp;</td>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("GalleriesTextColor2")%>'><b><%=DOMAIN_Text("GALLERY_IMAGES_NAME")%></b></td>
							<td bgcolor=<%=sBGColor%>>&nbsp;</td>
							<td bgcolor=<%=sBGColor%>>&nbsp;</td>
							<td align=center bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("GalleriesTextColor2")%>'><b><%=DOMAIN_Text("GALLERY_IMAGES_DEL")%></b></td>
							<td align=center bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("GalleriesTextColor2")%>'><b><%=DOMAIN_Text("GALLERY_IMAGES_ORDER")%></td>
						</tr>
						<%
						sColor1 = DOMAIN_Color("GalleriesBGColor1")
						sColor2 = DOMAIN_Color("GalleriesPageBGColor")
						sColor3 = DOMAIN_Color("GalleriesPageText")
						sColor4 = DOMAIN_Color("GalleriesTextColor1")
						sColor5 = DOMAIN_Color("GalleriesBGColor2")
						sColor6 = DOMAIN_Color("GalleriesTextColor2")
						
						sSQLText = "SET ROWCOUNT " & (CDbl(iDBLoc) + CDbl(iNumPerPage)) & " SELECT I.ImageUnq, I.Image, I.Thumbnail, I.FileType, I.Image2, I.Image3, I.Image4, I.Image5, I.Image2Desc, I.Image3Desc, I.Image4Desc, I.Image5Desc, I.AltTag2, I.AltTag3, I.AltTag4, I.AltTag5, I.XSize2, I.YSize2, I.XSize3, I.YSize3, I.XSize4, I.YSize4, I.XSize5, I.YSize5, I.ImageSize2, I.ImageSize3, I.ImageSize4, I.ImageSize5, I.EZPrints, G.AccountUnq, IG.GalleryUnq, IG.Position, IG.PrimaryG, IG.PrimaryD FROM Images I (NOLOCK), Galleries G (NOLOCK), ImagesInGallery IG (NOLOCK) WHERE G.GalleryUnq = " & iGalleryUnq & " AND IG.GalleryUnq = " & iGalleryUnq & " AND I.ImageUnq = IG.ImageUnq ORDER BY IG.Position SET ROWCOUNT 0"
						rsImageGallery.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
						sBGColor = DOMAIN_Color("GalleriesBGColor2")
						For x = 1 To CDbl(iDBLoc)
							rsImageGallery.MoveNext
						Next
						While ( NOT rsImageGallery.EOF )
							If ( sBGColor = sColor1 ) Then
								sBGColor = sColor2
								sTextColor = sColor3
								sLinkColor = "SmallNavPage"
							Else
								sBGColor = sColor1
								sTextColor = sColor4
								sLinkColor = "SmallNav1"
							End If
							sImage 			= Server.HTMLEncode(Trim(rsImageGallery("Image")))
							sThumbnail		= Trim(rsImageGallery("Thumbnail"))
							iImageUnq 		= rsImageGallery("ImageUnq")
							iPosition		= rsImageGallery("Position")
							sAccountUnq		= rsImageGallery("AccountUnq")
							iGalleryUnq		= rsImageGallery("GalleryUnq")
							aAltImage(0)	= Trim(rsImageGallery("Image2"))
							aAltImage(1)	= Trim(rsImageGallery("Image3"))
							aAltImage(2)	= Trim(rsImageGallery("Image4"))
							aAltImage(3)	= Trim(rsImageGallery("Image5"))
							aXSize(0)		= Trim(rsImageGallery("XSize2"))
							aXSize(1)		= Trim(rsImageGallery("XSize3"))
							aXSize(2)		= Trim(rsImageGallery("XSize4"))
							aXSize(3)		= Trim(rsImageGallery("XSize5"))
							aYSize(0)		= Trim(rsImageGallery("YSize2"))
							aYSize(1)		= Trim(rsImageGallery("YSize3"))
							aYSize(2)		= Trim(rsImageGallery("YSize4"))
							aYSize(3)		= Trim(rsImageGallery("YSize5"))
							aImageSize(0)	= Trim(rsImageGallery("ImageSize2"))
							aImageSize(1)	= Trim(rsImageGallery("ImageSize3"))
							aImageSize(2)	= Trim(rsImageGallery("ImageSize4"))
							aImageSize(3)	= Trim(rsImageGallery("ImageSize5"))
							bUseEZPrints	= Trim(rsImageGallery("EZPrints"))
							iPrimaryG		= Trim(rsImageGallery("PrimaryG"))
							iPrimaryD		= Trim(rsImageGallery("PrimaryD"))
							If ( IsNull(bUseEZPrints) Or ( NOT ACCNT_SpecificDomain("SB_IG_EZPRINTS_GALLERIES", iDomainUnq) ) ) Then
								bUseEZPrints = "N"
							Else
								If ( bUseEZPrints = "" ) Then
									bUseEZPrints = "N"
								End If
							End If
							If ( CDbl(iPrimaryG) = CDbl(iGalleryUnq) ) And ( CDbl(iPrimaryD) = CDbl(iDomainUnq ) ) Then
								bIsReferenced = FALSE
							Else
								bIsReferenced = TRUE
							End If
							
							%>
							<tr>
								<td bgcolor=<%=sBGColor%> align=center valign=top><font color='<%=sTextColor%>'><%=iImageUnq%></td>
								<td bgcolor=<%=sBGColor%> align=center valign=top width=<%=DOMAIN_Conf_W_DomainUnq("IMAGEGALLERY_THUMBNAIL_WIDTH", iDomainUnq)%>>
									<%Call DispThumb( iImageUnq, iGalleryUnq, sAccountUnq, sThumbnail, iPrimaryG, iPrimaryD)%>
								</td>
								<td bgcolor=<%=sBGColor%> valign=top><font color='<%=sTextColor%>'>
									<%
									Call G_STRUCTURE_FileType(Trim(rsImageGallery("FileType")), FALSE, bIsImage, iImageUnq)
									If ( bIsImage = FALSE ) Then
										Response.Write "<img src='" & sPath & "/Images/MediaIcons/" & Trim(rsImageGallery("FileType")) & ".gif' alt = '" & Trim(rsImageGallery("FileType")) & DOMAIN_Text("GALLERY_IMAGEFILETYPE_FILE") & "'>&nbsp;"
									End If
									%>
									<a href = '<%=sPath%>Attachments/DownloadAttach.asp?sAccountUnq=<%=sAccountUnq%>&iGalleryUnq=<%=iPrimaryG%>&iImageUnq=<%=iImageUnq%>&iDomainUnq=<%=iPrimaryD%>' class='SmallNav1' target='_blank'>
									<%=Server.HTMLEncode(sImage)%>
									</a>
								</td>
								<td bgcolor=<%=sBGColor%> valign=top nowrap>
									<li><a href='Edit.asp?iGalleryUnq=<%=iGalleryUnq%>&iDBLoc=<%=iDBLoc%>&iDomainUnq=<%=iDomainUnq%>&iImageUnq=<%=iImageUnq%>' class='<%=sLinkColor%>'><%=DOMAIN_Text("GALLERY_IMAGES_EDIT_IMAGE")%></a><br><br>
									<li><a href='EditLinks.asp?iGalleryUnq=<%=iGalleryUnq%>&iDBLoc=<%=iDBLoc%>&iDomainUnq=<%=iDomainUnq%>&iImageUnq=<%=iImageUnq%>' class='<%=sLinkColor%>'><%=DOMAIN_Text("GALLERY_IMAGES_EDIT_LINKS")%></a><br><br>
									<%If ( bAddCRRights ) Then%>
									<li><a href='EditCopyrights.asp?iGalleryUnq=<%=iGalleryUnq%>&iDBLoc=<%=iDBLoc%>&iDomainUnq=<%=iDomainUnq%>&iImageUnq=<%=iImageUnq%>' class='<%=sLinkColor%>'><%=DOMAIN_Text("GALLERY_IMAGES_EDIT_CR")%></a><br><br>
									<%End If%>
									<%If ( CStr(iDomainUnq) = Trim(CStr(iDomainName)) ) Then%>
									<%If ( bIsReferenced = FALSE ) Then%>
									<li><a href='EditThumbnail.asp?iGalleryUnq=<%=iGalleryUnq%>&iDBLoc=<%=iDBLoc%>&iDomainUnq=<%=iDomainUnq%>&iImageUnq=<%=iImageUnq%>' class='<%=sLinkColor%>'><%=DOMAIN_Text("GALLERY_IMAGES_EDIT_THUMB")%></a><br><br>
									<%End If%>
									<%End If%>
									<%If ( bReference ) Then%>
									<li><a href='Referencing.asp?iGalleryUnq=<%=iGalleryUnq%>&iDBLoc=<%=iDBLoc%>&iDomainUnq2=<%=iDomainUnq%>&iImageUnq=<%=iImageUnq%>' class='<%=sLinkColor%>'>Reference Elsewhere</a><br><br>
									<%End If%>
									<%If ( G_ADMINISTRATION_DetectImageMagick() = IMAGEMAGICK ) And ( bManipulateRights ) And ( bIsReferenced = FALSE ) And ( bIsImage ) Then%>
									<li><a href='ManipulateImage.asp?iGalleryUnq=<%=iGalleryUnq%>&iDBLoc=<%=iDBLoc%>&iDomainUnq=<%=iDomainUnq%>&iImageUnq=<%=iImageUnq%>' class='<%=sLinkColor%>'>Manipulate</a><br><br>
									<%End If%>
								</td>
								<td bgcolor=<%=sBGColor%> valign=top nowrap>
									<%If ( bAddProdRights ) Then%>
									<li><a href='EditProducts.asp?iGalleryUnq=<%=iGalleryUnq%>&iDBLoc=<%=iDBLoc%>&iDomainUnq=<%=iDomainUnq%>&iImageUnq=<%=iImageUnq%>' class='<%=sLinkColor%>'><%=DOMAIN_Text("GALLERY_IMAGES_EDIT_PRODS")%></a><br><br>
									<%Else%>
									&nbsp;
									<%End If%>
									<%If ( CStr(iDomainUnq) = Trim(CStr(iDomainName)) ) Then%>
									<%If ( bIsReferenced = FALSE ) Then%>
									<li><a href='AltViews.asp?iGalleryUnq=<%=iGalleryUnq%>&iDBLoc=<%=iDBLoc%>&iDomainUnq=<%=iDomainUnq%>&iImageUnq=<%=iImageUnq%>' class='<%=sLinkColor%>'><%=DOMAIN_Text("GALLERY_IMAGES_EDIT_ALTS")%></a><br><br>
									<%End If%>
									<%End If%>
									<%If ( bIsReferenced = FALSE ) Then%>
									<li><a href='Move.asp?iGalleryUnq=<%=iGalleryUnq%>&iDBLoc=<%=iDBLoc%>&iDomainUnq=<%=iDomainUnq%>&iImageUnq=<%=iImageUnq%>' class='<%=sLinkColor%>'><%=DOMAIN_Text("GALLERY_IMAGES_MOVE")%></a><br><br>
									<%End If%>
									<%If ( bAddCustFieldsRights ) Then%>
									<li><a href='EditCustom.asp?iGalleryUnq=<%=iGalleryUnq%>&iDBLoc=<%=iDBLoc%>&iDomainUnq=<%=iDomainUnq%>&iImageUnq=<%=iImageUnq%>' class='<%=sLinkColor%>'>Edit Custom Data</a><br><br>
									<%End If%>
									<%If ( G_ADMINISTRATION_DetectImageMagick() = IMAGEMAGICK ) And ( bWatermarkRights ) And ( bIsReferenced = FALSE ) And ( bIsImage ) Then%>
									<li><a href='Watermark.asp?iGalleryUnq=<%=iGalleryUnq%>&iDBLoc=<%=iDBLoc%>&iDomainUnq=<%=iDomainUnq%>&iImageUnq=<%=iImageUnq%>' class='<%=sLinkColor%>'>Watermarks</a>
									<%End If%>
								</td>
								<td align=center bgcolor=<%=sBGColor%> valign=top>
									<%If ( bIsReferenced = FALSE ) Then%>
									<input type='checkbox' name="sDeleteI<%=iImageUnq%>" value="<%=iImageUnq%>">
									<%Else%>
									<font size=-2 color='<%=sTextColor%>'>(Remove Reference)</font><br>
									<input type='checkbox' name="sDeleteR<%=iImageUnq%>" value="<%=iImageUnq%>">
									<%End If%>
								</td>
								<td bgcolor=<%=sBGColor%> align=center valign=top>
									<Table cellpadding=0 cellspacing=0 border=0>
										<%If ( iPosition > 1 ) Then%>
										<tr><td><a href='JavaScript:ReorderImages(<%=iPosition%>, <%=iImageUnq%>, "MoveUp")'><img src='../Images/Administrative/MoveUp.gif' border=0 width=12 height=6 alt=' <%=DOMAIN_Text("GALLERY_IMAGES_MOVE_UP")%> '></a></td></tr>
										<%End If%>
										<tr><td><img src='/WS_Content/Images/Blank.gif' border=0 width=12 height=6></td></tr>
										<%If ( iPosition < iTtlNumItems ) And ( iTtlNumItems > 1 ) Then%>
										<tr><td><a href='JavaScript:ReorderImages(<%=iPosition%>, <%=iImageUnq%>, "MoveDown")'><img src='../Images/Administrative/MoveDown.gif' border=0 width=12 height=6 alt=' <%=DOMAIN_Text("GALLERY_IMAGES_MOVE_DOWN")%> '></a></td></tr>
										<%End If%>
									</table>
								</td>
							</tr>
							
							<%If ( bEZPrintsAccount ) And ( ACCNT_SpecificDomain("SB_IG_EZPRINTS_GALLERIES", iDomainUnq) ) Then%>
							<tr>
								<td colspan=7 bgcolor=<%=sBGColor%>>
									<font color='<%=sTextColor%>'><b>Display EZPrints Links?</b>
									<br><br>
									<table width=100% cellpadding=0 cellspacing=0>
										<tr>
											<td width=110 align=right><font size=-2 color='<%=sTextColor%>'>Display with just Prints:</td><td><input type='radio' name='<%=iImageUnq%>bUseEZPrints' value='P' <%If ( InStr(bUseEZPrints, "P" ) > 0 ) Then Response.Write "checked" End If%>></td>
											<td width=110 align=right><font size=-2 color='<%=sTextColor%>'>Display with just Gifts:</td><td><input type='radio' name='<%=iImageUnq%>bUseEZPrints' value='G' <%If ( InStr(bUseEZPrints, "G" ) > 0 ) Then Response.Write "checked" End If%>></td>
											<td width=110 align=right><font size=-2 color='<%=sTextColor%>'>Display with both:</td><td><input type='radio' name='<%=iImageUnq%>bUseEZPrints' value='B' <%If ( InStr(bUseEZPrints, "B" ) > 0 ) Then Response.Write "checked" End If%>></td>
											<td width=110 align=right><font size=-2 color='<%=sTextColor%>'>Display NO EZPrints links:</td><td><input type='radio' name='<%=iImageUnq%>bUseEZPrints' value='N' <%If ( InStr(bUseEZPrints, "N" ) > 0 ) Then Response.Write "checked" End If%>></td>
										</tr>
									</table>
									<font size=-2>If EZPrints is activated, which image should be used on the product?
									<table width=100% cellpadding=0 cellspacing=0 border=1>
										<tr>
											<td align=center valign=bottom><font size=-2 color='<%=sTextColor%>'>Alternate Image 1</td>
											<td align=center valign=bottom><font size=-2 color='<%=sTextColor%>'>Alternate Image 2</td>
											<td align=center valign=bottom><font size=-2 color='<%=sTextColor%>'>Alternate Image 3</td>
											<td align=center valign=bottom><font size=-2 color='<%=sTextColor%>'>Alternate Image 4</td>
											<td align=center valign=bottom><font size=-2 color='<%=sTextColor%>'>Primary Image</td>
										</tr>
										<tr>
											<%
											bFoundAlt = FALSE
											For x = 0 to 3
												Response.Write "<td width=20" & "%" & " align=center><font size=-2>"
												iPos = InStrRev(aAltImage(x), ".")
												If ( iPos > 0 ) Then
													sTemp = UCase(Mid(aAltImage(x), iPos + 1))	' this is the file extension
													If ( sTemp = "JPG") Or ( sTemp = "GIF" ) Or ( sTemp = "PNG" ) Or ( sTemp = "BMP" ) Then
														Response.Write aAltImage(x)
														Response.Write "<BR>"
														Response.Write FormatNumber(aImageSize(x),0)
														Response.Write "k<BR>"
														Response.Write aXSize(x) & "x" & aYSize(x)
														Response.Write "<br><input type='radio' name='" & iImageUnq & "sEZPrintsImage' value='" & x & "'"
														If ( InStr(bUseEZPrints, x) > 0 ) Then 
															Response.Write " checked"
															bFoundAlt = TRUE
														End If
														Response.Write ">"
													Else
														Response.Write "Not a supported file type: <b>" & sTemp & "</b>."
													End If
												Else
													Response.Write "No file."
												End If
												Response.Write "</td>"
											Next
											%>
											<td width=20% align=center>
												<input type='radio' name='<%=iImageUnq%>sEZPrintsImage' value='' <%If ( ( Len(Trim(bUseEZPrints)) < 2 ) Or ( bFoundAlt = FALSE ) ) Then Response.Write "checked" End If%>>
											</td>
										</tr>
									</table>
									<br><br>
								</td>
							</tr>
							<%End If%>
							<%If ( bIsReferenced ) Then%>
							<tr>
								<td colspan=7 bgcolor=<%=sColor5%>><font color='<%=sColor6%>'>
									<%
									iTempDN = DOMAIN_Domain_Name(iPrimaryD)
									Response.Write "<b>Image "
									Response.Write iImageUnq
									Response.Write " is being referenced from: "
									Response.Write "<a href='http://"
									Response.Write iTempDN
									'Response.Write "/"
									Response.Write DOMAIN_Conf_W_DomainUnq("IMAGEGALLERY_SPATH", iPrimaryD)
									Response.Write "ManageImages/Default.asp?iGalleryUnq="
									Response.Write iPrimaryG
									Response.Write "' class='SmallNav1' target='_new'>"
									Response.Write G_ADMINISTRATION_GetGalleryName(iPrimaryG)
									Response.Write "&#151;"
									Response.Write DOMAIN_Domain_Name(iPrimaryD)
									Response.Write "</a></b>"
									%>
								</td>
							</tr>
							<%End If%>
							<%
							rsImageGallery.MoveNext
						Wend
						rsImageGallery.Close
						%>
						<tr>
							<td colspan=7 align=right>
								<%Call PrintRecordsetNav( "Default.asp", "", "Galleries" )%>
							</td>
						</tr>
					</table>
				</td>
			</tr>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
		</table>
		</form>
		<%
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	This writes the JavaScript out even if the Main() Sub isn't called in case the	*
	'*		admin has creation rights, but not edit rights.								*
	'*																					*
	'************************************************************************************
	Sub WriteScripts()
		%>
		<script language='JavaScript1.2' type='text/javascript'>
	
			function SubmitForm(sAction){
				document.ManageImages.sAction.value = sAction;
				document.ManageImages.submit();
			}
			
			function PaginationLink(sQueryString){
				document.location = "Default.asp?<%=DOMAIN_Link("G")%>&iDomainUnq=<%=iDomainUnq%>&iGalleryUnq=<%=iGalleryUnq%>" + sQueryString;
			}
			
			function ReorderImages(iMoveImagePos, iMoveImageUnq, sAction){
				document.ManageImages.iMoveImageUnq.value=iMoveImageUnq;
				document.ManageImages.iMoveImagePos.value=iMoveImagePos;
				SubmitForm(sAction);
			}
			
			function NewImage(){
				document.location = "New.asp?<%=DOMAIN_Link("G")%>&iTtlNumItems=" + document.ManageImages.iTtlNumItems.value + "&iGalleryUnq=" + document.ManageImages.iGalleryUnq.value + "&iDBLoc=" + document.ManageImages.iDBLoc.value + "&iDomainUnq=" + document.ManageImages.iDomainUnq.value;
			}
			
		</script>
		<%
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub DispThumb( iImageUnq, iGalleryUnq, sAccountUnq, sThumbnail, iPrimaryG, iPrimaryD )
		
		%>
		<table cellpadding=0 cellspacing=0 border=0><tr>
			<td align=center bgcolor=<%=DOMAIN_Color("GalleriesBGColor1")%>>
				<table cellpadding=0 cellspacing=0 border=0 width=100% height=100%>
					<tr>
						<td colspan=3 align=center>
							<table cellpadding=0 cellspacing=0 border=0 width=<%=DOMAIN_Conf("IMAGEGALLERY_THUMBNAIL_WIDTH")%>>
								<tr><td colspan=3 bgcolor=<%=DOMAIN_Color("GalleriesBorderColor2")%>><img src = "/WS_Content/Images/Blank.gif" width=1 height=1></td></tr>
								<tr>
									<td bgcolor=<%=DOMAIN_Color("GalleriesBorderColor2")%>><img src = "/WS_Content/Images/Blank.gif" width=1 height=1></td>
									<%If ( CStr(iDomainUnq) = Trim(CStr(iDomainName)) ) Then%>
									<td><a href = '<%=sPath%>ImageDetail.asp?iGalleryUnq=<%=iGalleryUnq%>&iImageUnq=<%=iImageUnq%>' target='_blank'><img src = "<%=sPath%>Attachments/DispThumb.asp?sAccountUnq=<%=sAccountUnq%>&sThumbnail=<%=sThumbnail%>&iGalleryUnq=<%=iPrimaryG%>&iDomainUnq=<%=iPrimaryD%>" width=<%=DOMAIN_Conf("IMAGEGALLERY_THUMBNAIL_WIDTH")%> border=0></a></td>
									<%Else%>
									<td><a href = 'http://<%=DOMAIN_Domain_Name(iDomainUnq)%>/<%=DOMAIN_Conf_W_DomainUnq("IMAGEGALLERY_SPATH", iDomainUnq)%>/ImageDetail.asp?iGalleryUnq=<%=iGalleryUnq%>&iImageUnq=<%=iImageUnq%>' target='_blank'><img src = "http://<%=DOMAIN_Domain_Name(iDomainUnq)%>/<%=DOMAIN_Conf_W_DomainUnq("IMAGEGALLERY_SPATH", iDomainUnq)%>/Attachments/DispThumb.asp?sAccountUnq=<%=sAccountUnq%>&sThumbnail=<%=sThumbnail%>&iGalleryUnq=<%=iPrimaryG%>&iDomainUnq=<%=iPrimaryD%>" width=<%=DOMAIN_Conf_W_DomainUnq("IMAGEGALLERY_THUMBNAIL_WIDTH", iDomainUnq)%> border=0></a></td>
									<%End If%>
									<td bgcolor=<%=DOMAIN_Color("GalleriesBorderColor2")%>><img src = "/WS_Content/Images/Blank.gif" width=1 height=1></td>
								</tr>
								<tr><td colspan=3 bgcolor=<%=DOMAIN_Color("GalleriesBorderColor2")%>><img src = "/WS_Content/Images/Blank.gif" width=1 height=1></td></tr>
							</table>
						</td>
					</tr>
				</table>
			</td>
		</tr></table>
		<%
	End Sub
	'************************************************************************************
%>
