<!--#INCLUDE VIRTUAL="/WS_Content/Includes/i_Includes.asp"-->
<%
	' System Globals
	Dim sPath


	'************************************************************************************
	'*																					*
	'*	Open the connection and command objects for the News database.	 				*
	'*																					*
	'************************************************************************************
	Sub DB_OpenNews()
		sPath = DOMAIN_Conf("NEWS_SPATH")	' the root path of all files - appended to all links/forms - so this whole dir can be moved
	End Sub
	'************************************************************************************
	
	
	'************************************************************************************
	'*																					*
	'*	Close the connection and command objects for the databases.			 			*
	'*																					*
	'************************************************************************************
	Sub DB_CloseNews()
		SET DBConnection = nothing
		SET DBCommand = nothing
	End Sub
	'************************************************************************************
	
	
	
	'************************************************************************************
	'*																					*
	'*	sends out an email to the moderator when a new article that needs moderation	*
	'*		is submitted.																*
	'*																					*
	'************************************************************************************
	Sub EmailTheModerator()
		Dim sEmailResponse, sCategory, sSQLText, rsNews, iCatUnq, sHeadline, sDisplayName
		Dim sFullLetter
		
		If ( DOMAIN_Has_RemoteHost() ) Then
			Set rsNews = CreateObject("ADODB.Recordset")
			sSQLText = "SELECT * FROM News (NOLOCK) WHERE NewsUnq = " & iNewsUnq
			rsNews.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsNews.EOF ) Then
				iCatUnq			= Trim(rsNews("CatUnq"))
				sHeadline		= Trim(rsNews("Headline"))
				sDisplayName	= Trim(rsNews("DisplayName"))
			End If
			rsNews.Close
			
			sSQLText = "SELECT Name FROM Categories (NOLOCK) WHERE CatUnq = " & iCatUnq
			rsNews.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
			If ( NOT rsNews.EOF ) Then
				sCategory = "<b>" & rsNews("Name") & "</b>"
			Else
				sCategory = DOMAIN_Text("NEWS_SUBMIT_NOCAT")
			End If
			rsNews.Close
			Set rsNews = Nothing
			sFullLetter = Replace(DOMAIN_Text("NEWS_MODERATOR_EMAIL"), "1:", sHeadline)
			sFullLetter = Replace(sFullLetter, "2:", sCategory)
			sEmailResponse = DOMAIN_Send_EMail(sFullLetter, sDisplayName, "SiteBeaterNews@" & Request.ServerVariables("SERVER_NAME"), DOMAIN_Text("NEWS_MODERATOR_NAME"), DOMAIN_Conf("SB_NEWS_MODERATOR_EMAIL"), Request.ServerVariables("SERVER_NAME") & DOMAIN_Text("NEWS_MODERATOR_TITLE"), FALSE)
		End If
	End Sub
	'************************************************************************************
	
	
	
	'************************************************************************************
	'*																					*
	'*	Strips HTML and replaces HTMLCodes with the proper HTML.			 			*
	'*																					*
	'************************************************************************************
	Function StripCodes(sBody)
		Dim sKeyArray, sUCaseVersion, x, BegPos, EndPos, CheckPos, sTemp, sContent
		Dim sQOpen, sQClose
dim icount
icount = 0

		sKeyArray = Array("B", "U", "I", "BLOCKQUOTE", "CODE", "OL", "UL", "URL", "EMAIL", "IMG", "PRE", "Q", "P", "b", "u", "i", "blockquote", "code", "ol", "ul", "url", "email", "img", "pre", "q", "p")
		
		StripCodes = Replace(sBody, ">", "&GT;")
		StripCodes = Replace(StripCodes, "<", "&LT;")
		sUCaseVersion = UCase(StripCodes)
		sQOpen = "<blockquote><table cellpadding=5 cellspacing=0 bordercolor=" & DOMAIN_Color("NewsBorderColor2") & " border=1><tr><td bgcolor=" & DOMAIN_Color("NewsBGColor2") & "><font color=" & DOMAIN_Color("NewsTextColor2") & ">"
		sQClose = "</td></tr></table></blockquote>"
		
		' Now check the string for any &gt;BLOCKQUOTE&lt; stuff and it's corresponding closing &gt;/BLOCKQUOTE&lt;
		' If there is no second opening one after the first opening one and before the closing one, then convert 
		'	the &gt;BLOCKQUOTE&lt; and &gt;/BLOCKQUOTE&lt; back into <BLOCKQUOTE> and </BLOCKQUOTE>
		' The exception to the rule is the "LI". Leave this in no matter what...it can't hurt.
		for x = 0 to UBound(sKeyArray)
			BegPos = InStr(sUCaseVersion, "&LT;" & sKeyArray(x) & "&GT;")
			EndPos = InStr(BegPos + 1, sUCaseVersion, "&LT;/" & sKeyArray(x) & "&GT;")
			while BegPos > 0 and icount < 60
icount = icount + 1
				CheckPos	= InStr(BegPos + 1, sUCaseVersion, "&LT;" & sKeyArray(x) & "&GT;")
				if CheckPos = 0 or CheckPos > EndPos then
					' It's ok
					sTemp = left(StripCodes, BegPos - 1)
					select case sKeyArray(x)
						case "URL"
							StripCodes = Replace(StripCodes, "&LT;URL&GT;", "<a href = ""http://", BegPos, 1, 1)
						case "EMAIL"
							StripCodes = Replace(StripCodes, "&LT;EMAIL&GT;", "<a href = ""mailto:", BegPos, 1, 1)
						case "IMG"
							StripCodes = Replace(StripCodes, "&LT;IMG&GT;", "<img src = ""http://", BegPos, 1, 1)
						Case "Q"
							' quoted text - put in a cool box
							StripCodes = Replace(StripCodes, "&LT;Q&GT;", sQOpen, BegPos, 1, 1)
							EndPos = EndPos + (Len(sQOpen) - Len("&LT;Q&GT;"))		' this is the difference in len between the original and replaced
						case else
							StripCodes = Replace(StripCodes, "&LT;" & sKeyArray(x) & "&GT;", "<" & sKeyArray(x) & ">", BegPos, 1, 1)
							EndPos = EndPos - 6
					end select
					StripCodes = sTemp & StripCodes

					sTemp = left(StripCodes, EndPos - 1)
					select case sKeyArray(x)
						case "URL"
							sContent = mid(StripCodes, BegPos + Len("<a href = ""http://"), (Len("<a href = ""http://") - Len("&LT;URL&GT;") + EndPos) - (BegPos + Len("<a href = ""http://")))
							StripCodes = Replace(StripCodes, "&LT;/URL&GT;", """ class='MediumNavPage'>" & sContent & "</a>", EndPos, 1, 1)
						case "EMAIL"
							sContent = mid(StripCodes, BegPos + Len("<a href = ""mailto:"), (Len("<a href = ""mailto:") - Len("&LT;EMAIL&GT;") + EndPos) - (BegPos + Len("<a href = ""mailto:")))
							StripCodes = Replace(StripCodes, "&LT;/EMAIL&GT;", """ class='MediumNavPage'>" & sContent & "</a>", EndPos, 1, 1)
						case "IMG"
							sContent = mid(StripCodes, BegPos + Len("<img src = ""http://"), (Len("<img src = ""http://") - Len("&LT;IMG&GT;") + EndPos) - (BegPos + Len("<img src = ""http://")))
							StripCodes = Replace(StripCodes, "&LT;/IMG&GT;", """>", EndPos, 1, 1)
						Case "Q"
							sContent = mid(StripCodes, BegPos + Len(sQOpen), EndPos - (BegPos + Len(sQOpen)))
							StripCodes = Replace(StripCodes, "&LT;/Q&GT;", sQClose, EndPos, 1, 1)
						case else
							StripCodes = Replace(StripCodes, "&LT;/" & sKeyArray(x) & "&GT;", "</" & sKeyArray(x) & ">", EndPos, 1, 1)
					end select
					StripCodes = sTemp & StripCodes
					sUCaseVersion = UCase(StripCodes)
					BegPos = InStr(sUCaseVersion, "&LT;" & sKeyArray(x) & "&GT;")
					EndPos = InStr(BegPos + 1, sUCaseVersion, "&LT;/" & sKeyArray(x) & "&GT;")
				else
					' its either not found (then it's 0...so the loop will stop) or it's before the endpos (so it should start again)
					BegPos = CheckPos
				end if
			wend
		next
		
		StripCodes = Replace(StripCodes, "&LT;LI&GT;", "<LI>")
		StripCodes = Replace(StripCodes, "&LT;li&GT;", "<LI>")
		StripCodes = Replace(StripCodes, "&LT;BR&GT;", "<BR>")
		StripCodes = Replace(StripCodes, "&LT;br&GT;", "<BR>")
		StripCodes = Replace(StripCodes, "&LT;HR&GT;", "<HR>")
		StripCodes = Replace(StripCodes, "&LT;hr&GT;", "<HR>")

	End Function
	'************************************************************************************
	
	

	'************************************************************************************
	'*																					*
	'*	Returns the total number of articles in the system - for license checking.		*
	'*																					*
	'************************************************************************************
	Function G_NEWS_GetArticleCount()
		Dim rsNews, sSQLText
	
		Set rsNews = CreateObject("ADODB.Recordset")
		sSQLText = "SELECT Count(*) FROM News (NOLOCK) WHERE Preview = 'N'"
		rsNews.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		If ( NOT rsNews.EOF ) Then
			G_NEWS_GetArticleCount = rsNews(0)
		Else
			G_NEWS_GetArticleCount = 0
		End If
		rsNews.Close
		Set rsNews = Nothing
		
	End Function
	'************************************************************************************
%>