<!--#INCLUDE FILE="../Includes/i_News.asp"-->
<!--#INCLUDE FILE="../Includes/i_Upload.asp"-->
<%
	Response.Buffer = TRUE
	Dim iDomainUnq, rsNews, iNumPerPage, iTtlNumItems, iDBLoc

	Call DISP_Action("SB_NEWS_OPEN")
	Call DISP_Action("SB_NEWS_MANAGE_CATEGORIES")
	If   (ACCNT_AnyDomain("SB_NEWS_CATEGORIES")) Or _
		 (ACCNT_AnyDomain("SB_NEWS_EDITORS")) Then
		Call Main()
	Else
		Call DOMAIN_Message(DOMAIN_Text("NEWS_SYS_RIGHTS"), "ERROR")
	End If
	Call DISP_Action("SB_NEWS_CLOSE")
	Response.Flush
	
	'************************************************************************************
	'*																					*
	'*																					*
	'*																					*
	'************************************************************************************
	Sub Main()
		Dim sAction, sSQLText, sError, sSuccess, bTemp, sTextField, sCheckbox, sTemp
		Dim sOldName, sName, sNewName, sOldDescription, sNewDescription, iCatUnq
		
		sAction = Trim(Request("sAction"))
		iDomainUnq = Trim(Request("iDomainUnq"))
		If ( iDomainUnq = "" ) Then
			iDomainUnq = ACCNT_GetDomainW_Rights("SB_NEWS_CATEGORIES", "SB_NEWS_EDITORS", "")
		End If

		Set rsNews = Server.CreateObject("ADODB.recordset")

		Select Case sAction
			Case "UpdateCategory"
				If ( iDomainUnq <> iDomainName ) And (NOT ACCNT_SpecificDomain("SB_NEWS_CATEGORIES", iDomainUnq)) Then
					sError = DOMAIN_Text("NEWS_SYS_RIGHTS")
				Else
					For Each sTextField In Request.Form
						If ( InStr(sTextField, "sOldName") > 0 ) Then
							iCatUnq = Replace(sTextField, "sOldName", "")
							sOldName = Request(sTextField)
							sNewName = Request("sNewName" & iCatUnq)
							sOldDescription = Request("sOldDescription" & iCatUnq)
							sNewDescription = Request("sNewDescription" & iCatUnq)
							If ( sOldName <> sNewName Or sOldDescription <> sNewDescription ) Then
								DBConnection.Execute "UPDATE Categories SET Name = '" & SQLEncode(sNewName) & "', Description = '" & SQLEncode(sNewDescription) & "' WHERE CatUnq = " & iCatUnq
								Call DOMAIN_Log(145, "", iDomainUnq, "", iCatUnq, "", 0, "V", "U", SQLEncode(sOldName), "")
								Call DOMAIN_Log(146, "", iDomainUnq, "", iCatUnq, "", 0, "V", "U", SQLEncode(sOldDescription), "")
								If ( sSuccess = "" ) Then
									sSuccess = DOMAIN_Text("NEWS_MANAGECATS_UPDATESUCCESS")
								End If
							End If
						End If
					Next
				End If
			Case "DeleteCategory"
				If ( iDomainUnq <> iDomainName ) And (NOT ACCNT_SpecificDomain("SB_NEWS_CATEGORIES", iDomainUnq)) Then
					sError = DOMAIN_Text("NEWS_SYS_RIGHTS")
				Else
					For Each sCheckbox In Request.Form
						If ( InStr(sCheckbox, "sDelete") > 0 ) Then
							iCatUnq = Replace(sCheckbox, "sDelete", "")
							DBConnection.Execute "DELETE FROM Categories WHERE CatUnq = " & iCatUnq
							Call DelOldCatFiles(iCatUnq)
							Call DOMAIN_Log(145, "", iDomainUnq, "", iCatUnq, "", 0, "V", "D", SQLEncode(Request("sOldName" & iCatUnq)), "")
							Call DOMAIN_Log(146, "", iDomainUnq, "", iCatUnq, "", 0, "V", "D", SQLEncode(Request("sOldDescription" & iCatUnq)), "")
							If ( sSuccess = "" ) Then
								sSuccess = DOMAIN_Text("NEWS_MANAGECATS_DELSUCCESS")
							End If
						End If
					Next
				End If
		End Select
		
		' Pagination variables -- begin
		iNumPerPage = 20
		iTtlNumItems = CDbl(Request("iTtlNumItems"))
		If IsNull(Request("iDBLoc")) Or Trim(Request("iDBLoc"))="" Then
			iDBLoc = 0
		Else
			iDBLoc = CDbl(Request("iDBLoc"))
			If (iDBLoc<0) Then
				iDBLoc = 0
			End If
		End If
		' must reset the position in the db and the ttlnumitems when changing the domain or system drop-down menu
		' must also reset them if colors have been deleted
		Select Case sAction
			Case "UpdateDomainUnq"
				iDBLoc = 0
				iTtlNumItems = 0
			Case "DeleteCategory"
				iTtlNumItems = 0
		End Select
		
		' Get ttl num of items from the database if it's not already in the QueryString
		if (iTtlNumItems = 0) then
			sSQLText = "SELECT Count(*) FROM Categories (NOLOCK) WHERE DomainUnq = " & iDomainUnq
			rsNews.Open sSQLText, DBConnection
			If Not(rsNews.EOF) Then
				iTtlNumItems = rsNews(0)
			End If
			rsNews.Close
		end if
		' Pagination variables -- end
		
		If ( sError <> "" ) Then
			Call DOMAIN_Message(sError, "ERROR")
		End If
		If ( sSuccess <> "" ) Then
			Call DOMAIN_Message(sSuccess, "SUCCESS")
		End If
		
		Call WriteForm()
		Set rsNews = Nothing
	End Sub
	'************************************************************************************

	'************************************************************************************
	'*																					*
	'*	This is the function to write out the form.										*
	'*																					*
	'************************************************************************************
	Sub WriteForm()
		Dim sSQLText, sName, sDescription, iCatUnq
		Dim sBGColor, sTextColor, x, sLinkColor
		Dim sColor1, sColor2, sColor3, sColor4, sFilePath
		
		sSQLText = "SET ROWCOUNT " & (CDbl(iDBLoc) + CDbl(iNumPerPage)) & " SELECT * FROM Categories (NOLOCK) WHERE DomainUnq = " & iDomainUnq & " ORDER BY CatUnq SET ROWCOUNT 0"
		Set rsNews = CreateObject("ADODB.Recordset")
		rsNews.Open sSQLText, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
		sBGColor = DOMAIN_Color("NewsBGColor2")
		For x = 1 To CDbl(iDBLoc)
			rsNews.MoveNext
		Next
		%>
		<script language='JavaScript1.2' type='text/javascript'>
	
			function SubmitForm(sAction){
				document.ManageCategories.sAction.value = sAction;
				document.ManageCategories.submit();
			}
			
			function PaginationLink(sQueryString){
				document.location = "Default.asp?<%=DOMAIN_Link("G")%>&iTtlNumItems=<%=iTtlNumItems%>&iDBLoc=<%=iDBLoc%>&iDomainUnq=<%=iDomainUnq%>" + sQueryString;
			}
			
			function NewCategory(){
				document.location = "New.asp?<%=DOMAIN_Link("G")%>&iTtlNumItems=<%=iTtlNumItems%>&iDBLoc=<%=iDBLoc%>&iDomainUnq=<%=iDomainUnq%>";
			}
			
			function EditEditors(sActionConst){
				document.location = "EditEditors.asp?<%=DOMAIN_Link("G")%>&iTtlNumItems=<%=iTtlNumItems%>&iDBLoc=<%=iDBLoc%>&iDomainUnq=<%=iDomainUnq%>&iCatUnq=" + sActionConst;
			}
			
			function EditImage(sActionConst){
				document.location = "EditImage.asp?<%=DOMAIN_Link("G")%>&iTtlNumItems=<%=iTtlNumItems%>&iDBLoc=<%=iDBLoc%>&iDomainUnq=<%=iDomainUnq%>&iCatUnq=" + sActionConst;
			}

		</script>

		<form name='ManageCategories' action='Default.asp' method='post'>
		<%
		aVariables(0) = "sAction"
		aVariables(1) = "iTtlNumItems"
		aVariables(2) = "iDBLoc"
		aValues(0) = "New"
		aValues(1) = iTtlNumItems
		aValues(2) = iDBLoc
		Response.Write DOMAIN_Link("P")
		%>
		<table cellpadding=0 cellspacing=0 border=0 width=671>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
			<tr>
				<td>
					<font color='<%=DOMAIN_Color("NewsPageText")%>'>
					<font size=+1><b><%=DOMAIN_Text("NEWS_MANAGECATS_HEADER")%></b></font>
					<br><br>
					<table width=671>
						<tr>
							<td><font color='<%=DOMAIN_Color("NewsPageText")%>'><b><%=DOMAIN_Text("NEWS_TEXT_DOMAIN")%></b></font></td>
						</tr>
						<tr>
							<td>
								<%Call DOMAINS_DomainsDropDown("SB_NEWS_CATEGORIES", "SB_NEWS_EDITORS", "")%>
							</td>
						</tr>
					</table>
					<table cellpadding=2 cellspacing=0 border=0 width=671>
						<tr>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("NewsTextColor2")%>'><b><%=DOMAIN_Text("NEWS_MANAGECATS_ID")%></b></td>
							<td bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("NewsTextColor2")%>'><b><%=DOMAIN_Text("NEWS_MANAGECATS_IMAGE")%></b></td>
							<td bgcolor=<%=sBGColor%> align=center><font color='<%=DOMAIN_Color("NewsTextColor2")%>'><b><%=DOMAIN_Text("NEWS_MANAGECATS_CAT")%></b></td>
							<td bgcolor=<%=sBGColor%> align=center><font color='<%=DOMAIN_Color("NewsTextColor2")%>'><b><%=DOMAIN_Text("NEWS_MANAGECATS_DESC")%></b></td>
							<td bgcolor=<%=sBGColor%>>&nbsp;</td>
							<td align=center bgcolor=<%=sBGColor%>><font color='<%=DOMAIN_Color("NewsTextColor2")%>'><b><%=DOMAIN_Text("NEWS_MANAGECATS_DEL")%></b></td>
						</tr>
						<%
						sColor1 = DOMAIN_Color("NewsBGColor1")
						sColor2 = DOMAIN_Color("NewsPageBGColor")
						sColor3 = DOMAIN_Color("NewsPageText")
						sColor4 = DOMAIN_Color("NewsTextColor1")
						While ( NOT rsNews.EOF )
							If ( sBGColor = sColor1 ) Then
								sBGColor = sColor2
								sTextColor = sColor3
								sLinkColor = "MediumNavPage"
							Else
								sBGColor = sColor1
								sTextColor = sColor4
								sLinkColor = "MediumNav1"
							End If
							sName 			= Server.HTMLEncode(rsNews("Name"))
							sDescription 	= Server.HTMLEncode(rsNews("Description"))
							iCatUnq 		= rsNews("CatUnq")
							%>
							<tr>
								<td bgcolor=<%=sBGColor%> align=center valign=top><font color='<%=sTextColor%>'><%=iCatUnq%></td>
								<td bgcolor=<%=sBGColor%> align=center>
									<%
									sFilePath = DOMAIN_Conf("SB_NEWS_CAT_IMAGE_LOC") & "/" & "CatImage_" & iCatUnq & ".jpg"
									sFilePath = Replace(sFilePath, "\", "/")
									sFilePath = Replace(sFilePath, "//", "/")
									If ( UCase(Trim(rsNews("HasImage"))) = "Y" ) Then
										%>
										<img src='<%=sFilePath%>' width=<%=DOMAIN_Conf("SB_NEWS_CAT_IMAGE_WIDTH")%> height=<%=DOMAIN_Conf("SB_NEWS_CAT_IMAGE_HEIGHT")%> border=1>
									<%End If%>
								</td>
								<td bgcolor=<%=sBGColor%> valign=top><input type='hidden' name="sOldName<%=iCatUnq%>" value="<%=sName%>"><input type='text' name="sNewName<%=iCatUnq%>" value="<%=sName%>" size=25 maxlength=250><br><a href='JavaScript:EditImage("<%=iCatUnq%>")' class='<%=sLinkColor%>'><%=DOMAIN_Text("NEWS_MANAGECATS_CHNGIMAGE")%></a></td>
								<td bgcolor=<%=sBGColor%> valign=top><input type='hidden' name="sOldDescription<%=iCatUnq%>" value="<%=sDescription%>"><input type='text' name="sNewDescription<%=iCatUnq%>" value="<%=sDescription%>" size=45 maxlength=250></td>
								<td bgcolor=<%=sBGColor%> align=center valign=top><a href='JavaScript:EditEditors("<%=iCatUnq%>")' class='<%=sLinkColor%>'><%=DOMAIN_Text("NEWS_MANAGECATS_MANAGEEDITORS")%></a></td>
								<td align=center bgcolor=<%=sBGColor%>><input type='checkbox' name="sDelete<%=iCatUnq%>" value="<%=iCatUnq%>"></td>
							</tr>
							<%
							rsNews.MoveNext
						Wend
						%>
						<tr>
							<td colspan=6 align=right>
								<%Call PrintRecordsetNav( "Default.asp", "", "News" )%>
							</td>
						</tr>
					</table>
				</td>
			</tr>
			<tr><td><img src='/WS_Content/Images/Blank.gif' Width=1 Height=5></td></tr>
		</table>
		</form>
		<%
	End Sub
	'************************************************************************************
%>