<!--#INCLUDE VIRTUAL="/WS_Content/Includes/i_Includes.asp"-->
<!--#INCLUDE VIRTUAL="/WS_Content/Radio/Includes/i_Radio.asp"-->
<%
	Response.Buffer = TRUE
	Call DISP_Action("SB_RADIO_OPEN")
	Call DISP_Action("SB_RADIO_PLAYLIST")
	Call DisplaySongs()
	Call DISP_Action("SB_RADIO_CLOSE")
	Response.Flush

	'************************************************************************************
	'*																					*
	'*	Display the songs in the playlist.												*
	'*																					*
	'************************************************************************************  
	Sub DisplaySongs()
		Dim sSQL, sTextColor, sLinkColor, sAccountUnq
		Dim rsRadio2, bOwnsPL
		Dim sTempOverride, sDescription, sArtist, sTitle
		%>
	    <form action = "UpdatePL.asp" method = "POST">
			<%
			bOwnsPL = FALSE
			aVariables(0) = "bPLEdit"
			aVariables(1) = "iPlayListUnq"
			aValues(0) = "T"
			aValues(1) = iPlayListUnq
			Response.Write DOMAIN_Link("P")
			%>
			<table width=<%=iTableWidth%> cellpadding = 1 cellspacing = 0 border = 0><tr><td bgcolor = <%=DOMAIN_Color("RadioBorderColor1")%> align=center>
			<table cellpadding=5 width=<%=iTableWidth%> cellspacing = 0 border = 0>
			    <%
			    sBGColor = DOMAIN_Color("sRadioGlobalBGColor")
			    If ( bHasAccount ) Then
			    	' members can see either public or private playlists, but only private playlists that they own
			    	If ( ACCNT_SpecificDomain("SB_ADMIN_PL", iDomainName) ) Then	' the SB_ADMIN_PL person can see all playlists entries
			    		sSQL = "SELECT S.Description, S.SongUnq, S.Directory, S.FileName, S.Artist, S.CD, S.Rating, S.NumRaters, P.AddDate, L.AccountUnq FROM SongsInPL P (NOLOCK), Songs S (NOLOCK), PlayLists L (NOLOCK) WHERE P.PlayListUnq = " & iPlayListUnq & " AND P.SongUnq = S.SongUnq AND P.PlayListUnq = L.PlayListUnq AND S.DomainUnq = " & iDomainName & " ORDER BY S.Artist"
			    	Else
			    		sSQL = "SELECT S.Description, S.SongUnq, S.Directory, S.FileName, S.Artist, S.CD, S.Rating, S.NumRaters, P.AddDate, L.AccountUnq FROM SongsInPL P (NOLOCK), Songs S (NOLOCK), PlayLists L (NOLOCK) WHERE P.PlayListUnq = " & iPlayListUnq & " AND P.SongUnq = S.SongUnq AND (L.Visibility = 1 OR L.AccountUnq = " & iLoginAccountUnq & ") AND P.PlayListUnq = L.PlayListUnq AND S.DomainUnq = " & iDomainName & " ORDER BY S.Artist"
			    	End If
			    Else
			    	' make sure non-members can only see PUBLIC playlists
			    	sSQL = "SELECT S.Description, S.SongUnq, S.Directory, S.FileName, S.Artist, S.CD, S.Rating, S.NumRaters, P.AddDate, L.AccountUnq FROM SongsInPL P (NOLOCK), Songs S (NOLOCK), PlayLists L (NOLOCK) WHERE L.Visibility = 1 AND P.PlayListUnq = " & iPlayListUnq & " AND P.SongUnq = S.SongUnq AND P.PlayListUnq = L.PlayListUnq AND S.DomainUnq = " & iDomainName & " ORDER BY S.Artist"
			    End If

				Set rsRadio = CreateObject("ADODB.Recordset")
				Set rsRadio2 = CreateObject("ADODB.Recordset")
				rsRadio.Open sSQL, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
			    If (NOT rsRadio.EOF) Then
			    	sAccountUnq = rsRadio("AccountUnq")	' for use below when printing out the submit button
				    While (NOT rsRadio.EOF)
						sSql = "SELECT * FROM Songs S (NOLOCK) LEFT OUTER JOIN  SongInfo I (NOLOCK) ON S.SongUnq = I.SongUnq WHERE S.DomainUnq = " & iDomainName & " AND S.SongUnq = " & rsRadio("SongUnq")
						rsRadio2.Open sSQL, DBConnection, adOpenKeyset, adLockReadOnly, adCmdText
						If ( NOT rsRadio2.EOF ) Then

							sTempOverride = Trim(rsRadio2("OverrideDesc"))
							If ( ( IsNull(sTempOverride) ) Or ( sTempOverride = "N" ) Or ( sTempOverride = "" ) ) Then
								sDescription = rsRadio2("Description")
							Else
								sDescription = rsRadio2("ExtraDesc")
							End If
							sTempOverride = Trim(rsRadio2("OverrideArtist"))
							If ( ( IsNull(sTempOverride) ) Or ( sTempOverride = "N" ) Or ( sTempOverride = "" ) ) Then
								sArtist = rsRadio2("Artist")
							Else
								sArtist = rsRadio2("ExtraArtist")
							End If
							sTempOverride = Trim(rsRadio2("OverrideTitle"))
							If ( ( IsNull(sTempOverride) ) Or ( sTempOverride = "N" ) Or ( sTempOverride = "" ) ) Then
								sTitle = rsRadio2("Title")
							Else
								sTitle = rsRadio2("ExtraTitle")
							End If
						
							If (sBGColor = DOMAIN_Color("RadioBGColor1")) Then
								sBGColor = DOMAIN_Color("RadioPageBGColor")
								sTextColor = DOMAIN_Color("RadioPageText")
								sLinkColor = "MediumNavPage"
							Else
								sBGColor = DOMAIN_Color("RadioBGColor1")
				    			sLinkColor = "MediumNav1"
				    			sTextColor = DOMAIN_Color("RadioTextColor1")
							End If
						    %>
					    	<TR>
					    		<TD valign = top bgcolor = <%=sBGColor%>>
					    			<table cellpadding=0 cellspacing=3 border=0>
					    				<tr>
					    					<td>
					    						<font color='<%=sTextColor%>'>
					    						<b><%=sArtist%></b>
					    					</td>
					    				</tr>
					    				<tr>
					    					<td>
												<%
												aVariables(0) = "sPath"
												aVariables(1) = "iPlayListUnq"
												aValues(0) = sBasePath & rsRadio("Directory")
												aValues(1) = iPlayListUnq
												%>
					    						<A href="SongList.asp?<%=DOMAIN_Link("G")%>" class='<%=sLinkColor%>'><IMG SRC="/WS_Content/Radio/Images/Dir_Dir.gif" BORDER=0 alt='<%= rsRadio("Directory")%>'>&nbsp;<%=DOMAIN_Text("RADIO_SONG_DIR")%></a>
					    						<br>
					    						<%
				    							' based on the configuration setting, do or do not display a link to download the song
					    						Select Case DOMAIN_Conf("RADIO_DOWNLOAD_SONGS")
					    							Case "MEMBERS"	' only members can see it
					    								If ( bHasAccount ) Then
								    						If ( ( ACCNT_SpecificDomain("SB_RADIO_PLAY_SONGS", iDomainName) ) Or ( ACCNT_SpecificDomain("SB_ADMIN_PL", iDomainName) ) ) Then
								    							' they still need to have SB_RADIO_PLAY_SONGS rights to download songs
								    							If ( Trim(sTitle) = "" ) Then
								    								sTitle = rsRadio("FileName")
								    							End If
							    								%><A href="<%= sBasePath & rsRadio("Directory") & rsRadio("FileName") %>" class='<%=sLinkColor%>'><IMG SRC="/WS_Content/Radio/Images/Dir_MP3.gif" BORDER=0 align = top>&nbsp;<%= sTitle %></A><%
							    							End If
						    							Else
						    								%><IMG SRC="/WS_Content/Radio/Images/Dir_MP3.gif" BORDER=0 align = top>&nbsp;<%= sTitle %><%
						    							End If
					    							Case "ALL"	' everyone can see it
						    							If ( Trim(sTitle) = "" ) Then
						    								sTitle = rsRadio("FileName")
						    							End If
					    								%><A href="<%= sBasePath & rsRadio("Directory") & rsRadio("FileName") %>" class='<%=sLinkColor%>'><IMG SRC="/WS_Content/Radio/Images/Dir_MP3.gif" BORDER=0 align = top>&nbsp;<%= sTitle %></A><%
					    							Case Else	' everyone can see it
						    							If ( Trim(sTitle) = "" ) Then
						    								sTitle = rsRadio("FileName")
						    							End If
					    								%><A href="<%= sBasePath & rsRadio("Directory") & rsRadio("FileName") %>" class='<%=sLinkColor%>'><IMG SRC="/WS_Content/Radio/Images/Dir_MP3.gif" BORDER=0 align = top>&nbsp;<%= sTitle %></A><%
					    						End Select
					    						%>
					    					</td>
					    				</tr>
					    				<tr>
					    					<td>
					    						<font color='<%=sTextColor%>'>
					    						<%=rsRadio("CD")%>
					    					</td>
					    				</tr>
					    			</table>
					    		</td>
					    		<td valign = top bgcolor = <%=sBGColor%> width = 200>
					    			<table cellpadding=0 cellspacing=3 border=0>
					    				<tr>
					    					<td>
					    						<font color='<%=sTextColor%>'>
					    						<%=sDescription%>
					    					</td>
					    				</tr>
					    				<%If (rsRadio("NumRaters") > 0) Then%>
					    				<tr>
					    					<td>
					    						<font color='<%=sTextColor%>'>
					    						<%=DOMAIN_Text("RATING")%><%=rsRadio("Rating")%>
					    						<%=DOMAIN_Text("NUM_RATERS")%><%=rsRadio("NumRaters")%>
					    					</td>
					    				</tr>
					    				<%End If%>
					    				<tr>
					    					<td>
					    						<font size=-2>
					    						<font color='<%=sTextColor%>'>
					    						<%=DOMAIN_Text("ADD_DATE")%>: <%=rsRadio("AddDate")%>
					    					</td>
					    				</tr>
					    			</table>
					    		</TD>
					    		<%If ( ACCNT_SpecificDomain("SB_ADMIN_PL", iDomainName) ) Then%>
					    		<TD bgcolor = <%=sBGColor %>>
					    			<table cellspacing=0 cellpadding=0 border=0>
					    				<tr>
					    					<td valign = top><font color='<%=sTextColor%>'>-</td>
					    					<td><input type = "checkbox" name = "sModPL" value = "R<%=rsRadio("SongUnq")%>"></td>
					    				</tr>
					    			</table>
					    		</TD>
					    		<%ElseIf ( ( rsRadio("AccountUnq") = iLoginAccountUnq ) And ( ACCNT_SpecificDomain("SB_RADIO_ADD_PL", iDomainName) ) ) Then
					    		bOwnsPL = TRUE
					    		%>
					    		<TD bgcolor = <%=sBGColor %>>
					    			<table cellspacing=0 cellpadding=0 border=0>
					    				<tr>
					    					<td valign = top><font color='<%=sTextColor%>'>-</td>
					    					<td><input type = "checkbox" name = "sModPL" value = "R<%=rsRadio("SongUnq")%>"></td>
					    				</tr>
					    			</table>
					    		</TD>
					    		<%End If%>
					    	</TR>
					    	<%
					    End If
					    rsRadio2.Close
				    	rsRadio.MoveNext
			    	Wend
			    	Response.Write "<tr><td bgcolor=" & DOMAIN_Color("RadioPageBGColor") & " colspan=3><center>"
			    	If ( ACCNT_SpecificDomain("SB_ADMIN_PL", iDomainName) ) Then
			    		Response.Write "<input type = 'submit' value = '" & DOMAIN_Text("REMOVE_FROM_PL") & "'>"
			    	ElseIf ( ( bOwnsPL = TRUE ) And ( ACCNT_SpecificDomain("SB_RADIO_ADD_PL", iDomainName) ) ) Then
			    		Response.Write "<input type = 'submit' value = '" & DOMAIN_Text("REMOVE_FROM_PL") & "'>"
			    	End If
			    	Response.Write "</center><BR>" & DOMAIN_Text("PL_SONGS_INST") & "</td></tr>"
		    	Else
		    		Response.Write "<tr><td bgcolor=" & DOMAIN_Color("RadioPageBGColor") & "><font color='" & DOMAIN_Color("RadioPageText") & "'>"
		    		Call DOMAIN_Message(DOMAIN_Text("NO_SONGS"), "ERROR")
		    		Response.Write "</td></tr>"
		    	End If
		    	Set rsRadio = Nothing
		    	Set rsRadio2 = Nothing
			    %>
		    </table>
		    </td></tr></table>
	    </form>
		<%
	End Sub
	'************************************************************************************  	
%>