CREATE PROCEDURE DOMAIN_Log (
	@iDomainUnq		INT = 0,
	@iTypeUnq		INT = 0,
	@sKey1			VARCHAR(255) = '',
	@iKey2			INT = 0,
	@sKey3			VARCHAR(255) = '',
	@iKey4			INT = 0,
	@sKey5			VARCHAR(255) = '',
	@iKey6			INT = 0,
	@sType			CHAR(3) = '',
	@iAccountUnq	INT = 0,
	@sAction		CHAR(3) = '',
	@sVarCharData	VARCHAR(255) = '',
	@sTextData		TEXT = ''
)
WITH ENCRYPTION
AS

/* Additional variables used in this procedure */
DECLARE
	@dDateChanged	DATETIME


/* Initialize the main variables in use */
SELECT @dDateChanged = GetDate()


If @iDomainUnq <= 0 BEGIN
	GOTO Proc_Finalize
END

If @iTypeUnq <= 0 BEGIN
	GOTO Proc_Finalize
END

If @iAccountUnq <= 0 BEGIN
	GOTO Proc_Finalize
END

If @sAction = '' BEGIN
	GOTO Proc_Finalize
END


INSERT INTO LogData VALUES (@iDomainUnq, @iTypeUnq, @sKey1, @iKey2, @sKey3, @iKey4, @sKey5, @iKey6, @sType, @iAccountUnq, GetDate(), @sAction, @sVarCharData, @sTextData)

Proc_Finalize:

RETURN 0